;
;	VT-DOS 1.1 Cartridge
;
;
;

#define PG0ADR(addr)	addr - 0C000h	; makr a 0. lapra lapozott U3 RAM-beli cmek szmtshoz

LC02E	.equ	0C02Eh			; FISH belpsi pont a floppy ROM-ban
LC031	.equ	0C031h			; DISKIO belpsi pont a floppy ROM-ban
LDDEB	.equ	0DDEBh			; a floppy RAM-ba tlttt rutin cme 1.
LDF01	.equ	0DF01h			; a floppy RAM-ba tlttt rutin cme 2.
LDF49	.equ	0DF49h			; a floppy RAM-ba tlttt rutin cme 3.



	.org	0C000h
;
	.db	"MOPS"
;
	ld	a,030h			; U0,U1,U2,CART lapozs
	out	(002h),a		; memrialapozs belltsa
	exx
	ld	hl,00048h		; HL' a 0. interfszkrtya RAM terletre mutat
	ld	de,00030h
	in	a,(05Ah)		; krtyaazonost port beolvassa A reg.-be
	ld	b,h			; B'= csatlakoz sorszma (0)
LC012:	ld	c,a
	and	003h
	cp	002h			; floppy csatol keresse a krtyaazonost bjtban
	jr	z,LC053			; ugrs, ha megtallta
	ld	a,c			; egybknt az azonost bjt lptetse a kvetkez krtyahelyre
	rrca
	rrca
	inc	b
	add	hl,de			; HL' a kvetkez csatol RAM terletre mutat
	inc	h
	dec	h
	jr	z,LC012			; ismtls, amig nem haladta meg a 4. csatol memriacmt
LC022:	exx
	ld	hl,0FFEAh		; HL= -22
	add	hl,de			; HL= 00322h (DE belpskor a SYS ROM-ban egy "MOPS" szveg utnra mutatott)
	ld	a,020h			; SYS,U1,U2,CART lapozs
	out	(002h),a		; memrialapozs belltsa
	jp	(hl)			; visszatrs a rendszer ROM-ba
;



LC02C:	.db	"VT-DOS  "
	.db	"Copyright (1986) IS Systems Ltd"


LC053:	ld	a,b			; A reg.= floppy illesztt tartalmaz csatlakoz sorszma
	rrca
	rrca
	out	(003h),a		; a csatolnak megfelel IOMEM kivlasztsa
	ld	de,LC02C		; DE= a "VT-DOS  " szvegre mutat
	ld	b,006h
LC05D:	ld	a,(de)			; szveg ellenrzse
	cp	(hl)			; HL= a diszk illeszt MOPS-os RAM terletre mutat
	jr	nz,LC022		; visszatrs a ROM-ba, ha nem egyezik (pl. a floppy rendszer nem inicializldott, vagy nem VT-DOS-os)
	inc	hl			; sszehasonltand szvegek mutatinak nvelse
	inc	de
	djnz	LC05D			; ismtls 6 karakterre
	ld	a,(00B1Bh)		; A reg.= P3RAM vltoz
	or	a
	jr	nz,LC022		; ugrs, ha hibs az U3-as RAM lap (vagy csak 32kB-os a gp)
	ld	a,038h			; U3,U1,U2,CART lapozs
	out	(002h),a		; memrialapozs belltsa
	ld	hl,LC08B		; HL= tmsoland memriaterlet kezdete
	ld	de,PG0ADR(LC08B)	; DE= clcm az U3 RAM-ban a 0. lapon
	ld	bc,U3COPY_END - LC08B	; BC= msoland hossz (majdnem a teljes 16kB-os ROM)
	ldir				; memriatartalom tmsolsa
	ld	hl,LFF09		; HL= megszaktskiszolgl msodik lehetsges belpsi pontjnak cme
	ld	(PG0ADR(LFDFD +1)),hl	; cm belltsa az LFDFD cmen lv "JP xxxx" utasts paramterbe
	call	PG0ADR(LE644)		; adat betltse a floppy RAM-bl A reg.-be, megszaktsok tiltsa
;
	.dw	0DFF2h			; DOSCART vltoz cme
;
	or	a
	jr	z,LC022			; visszatrs, ha DOSCART = 000h
	jp	PG0ADR(LC08B)		; ugrs a 0.lapon lv U3 RAM-ba (megegyezik a ROM kvetkez tartalmval)

;
;
;	A kvetkez kdrszletek mr az U3 RAM-ba tmsolva futnak a 0. lapon
;
LC08B:	ld	a,0F8h			; U3,U1,U2,EXT/IOMEM lapozs
	out	(002h),a		; memrialapozs belltsa
	ld	a,0FFh
	ld	(0DFF1h),a		; DISK_RAM_OK belltsa a floppy vezrl bels RAM-jban
	ld	hl,PG0ADR(LC0E8)	; HL= msoland kdrszlet kezdcme
	ld	de,0DDDDh		; DE= clcm a floppy RAM-ban (konstans cmrtk!!!)
	ld	a,d			; A reg.= 0DDh
	ld	bc,FCOPY_1 - LC0E8	; BC= msoland hossz
	ldir				; kdrszlet msolsa (megszakts rutin belpsi s kilpsi kd)
LC0A0:	ld	(de),a			; 256 darab 0DDh bjt elhelyezse a 0DE00h cmtl (!!!)
	inc	de
	djnz	LC0A0			; ismtls a teljes hosszra
	ld	(de),a			; a 257. bjt elhelyezse a 0DF00h cmre (gy megszaktskor mindig a 0DDDDh cmre ugrik)
	inc	de
	ld	bc,FCOPY_2 - FCOPY_1	; tovbbi 100 darab bjt msolsa a 0010Bh cmrl a floppy 0DF01h cmre
	ldir
	ld	iy,(0DFF5h)		; IY= floppy vltozk bziscme
	ld	(02686h),iy		; bziscm mentse az U3 RAM-ba is
	ld	a,018h			; U3,U1,VID,CART lapozs
	out	(002h),a		; memrialapozs belltsa
	ld	hl,0BE80h		; HL a videomemria utols 384 bjtjra mutat
	ld	de,0BE81h		; DE a kvetkez cmre
	xor	a
	out	(000h),a		; BORDER feketre lltsa
	ld	(hl),a
	ld	bc,0002Fh		; 48 bjt kinullzsa a vide memria vgn
	ldir
	call	LC8AC			; VT-DOS rendszer HW inicializlsa (rutin meghvsa a CART-ban)
	ld	a,0B8h			; U3,U1,U2,U3 lapozs
	out	(002h),a		; memrialapozs belltsa
	jp	LC0D0			; ugrs a kvetkez utastsra de a 3. memrialapon
;
LC0D0:	ld	a,0B0h			; U0,U1,U2,U3 lapozs
	out	(002h),a		; memrialapozs belltsa
	ld	hl,00000h		; HL az U0 RAM 0. cmre mutat
	ld	e,l
	ld	d,h
	inc	de
	ld	bc,03FFFh
	ld	(hl),l
	ldir				; a teljes U0 RAM kinullzsa
	ld	a,0FFh
	ld	(00045h),a		; bjt bersa az U0 adott cmre
	jp	LE410			; ugrs a folytatsra az U3 RAM megfelel cmn



;
;
;	A floppy csatol bels RAM-jba tmsolt kdrszletek
;	(35 bjt a 0DDDDh cmre + 100 bjt a 0DF01h cmre)
;	
;
LC0E8:	push	af			; megszakts kiszolgl rutin belpsi pontja (0DDDDh cmen)
	push	hl
	ld	a,(0DFFFh)		; A reg.= aktulis memrialapozsi rtk msolata (P_SAVE_COPY)
	ex	af,af'			; rtk mentse A'-be
	push	af
	ld	a,0F8h			; U3,U1,U2,EXT/IOMEM lapozs
	out	(002h),a		; memrialapozs belltsa
	jp	PG0ADR(LFF2C)		; ugrs a 0. lapon az U3 RAM-ban lv megszakts-kiszolgl rutinra


;
LC0F6:	ex	af,af'			; megszakts kiszolgl rutin befejez kdrszlete (0DDEBh cmen)
	ld	(0DFFFh),a		; memrialapozsi rtk visszarsa a bels vltozba
	out	(002h),a		; memrialapozs belltsa a porton
	pop	af
	ex	af,af'			; eredeti A' helyrelltsa
	pop	hl
	pop	af
	ei
	ret

;
; 	Kitlt bjtok (9 db.), az utols a 0DDFFh cmre kerl
;
	.db	000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h

FCOPY_1	.equ	$

;
;	A kvetkez 100 bjt a floppy RAM 0DF01h cmre msolva
;

;
;
;	FISH funkci vgrehajtsa U0,U1,U2,EXT/IOMEM lapozssal (cme a floppy RAM-ban: 0DF01h)
;	in:   A - FISH funkcikd
;	     BC,DE,IX - FISH funkcinak megfelelen belltva
;	out:  A - hibakd
;	     BC,DE,IX - FISH funkcinak megfelelen belltva
;
LC10B:	ld	(02688h),sp		; veremmutat mentse az 0. lapon lv U3 RAM-ba
	ld	sp,0DDDDh		; j verem ltrehozsa a IT ugrutasts alatti floppy RAM terleten
	push	af			; A reg. mentse
	ld	a,0F0h			; U0,U1,U2,EXT/IOMEM lapozs
	ld	(0DFFFh),a		; P_SAVE msolatnak belltsa
	out	(002h),a		; j memrialapozs belltsa
	pop	af			; A reg. vissza
	call	LC02E			; FISH funkci vgrehajtsa (fix cm a floppy ROM-ban)
	push	af			; A reg. mentse
	ld	a,0F8h			; U3,U1,U2,EXT/IOMEM lapozs
	ld	(0DFFFh),a		; P_SAVE msolatnak belltsa
	out	(002h),a		; j memrialapozs belltsa
	pop	af
	ld	sp,(02688h)		; veremmutat visszalltsa
	ret


;
;	Floppy SW kls hibakezel fggvnye (cme a floppy RAM-ban: 0DF22h)
;	in:   A - 0FFh-> IGNORE vlasz ajnlhat  000h-> nem ajnlhat (bug? - fordtva?)
;	      B - hibakd
;	      C - meghajt szma, ahol a hiba trtnt
;	out:  A - vlasztott mvelet sorszma (1->Abort  2-> Retry  3->Ignore) 
;
LC12C:	ld	e,a			; E= IGNORE vlaszt engedlyez flag
	ld	a,(0DFFFh)		; A reg.= P_SAVE msolata
	ld	d,a			; rtk mentse D-be
	ld	a,0F8h			; U3,U1,U2,EXT/IOMEM lapozs
	ld	(0DFFFh),a		; P_SAVE msolatnak belltsa
	out	(002h),a		; j memrialapozs belltsa
	ld	(0DF40h),sp		; veremmutat bersa a rutin vgn lv LD SP,0000h utasts paramterbe
	ld	hl,(02688h)		; HL= veremmutat korbbi rtke
	ld	a,h
	or	l
	jr	z,LC144			; ugrs, ha nulla
	ld	sp,hl			; egybknt a veremmmutat tlltsa
LC144:	push	de			; eredeti P_SAVE msolat a verembe
	call	PG0ADR(LE309)		; diszk hiba kirsa a kpernyre s felhasznli beavatkozs megvrsa
	pop	af			; A reg.= eredeti P_SAVE msolat
	ld	sp,00000h		; veremmutat helyrelltsa
	ld	(0DFFFh),a		; P_SAVE msolat helyrelltsa
	out	(002h),a		; memrialapozs helyrelltsa
	ld	a,e			; A reg.= vlasztott hibakezels
	ret


;
;
;	Belpsi rutin a felhasznli programbl hvott FISH s DISKIO funkcik vgrehajtshoz
;	(cme a floppy RAM-ban: 0DF49h)
;	in:   A - felhasznli memrialapozs
;	     CY - CY=0 -> FISH funkci  CY=1 -> DISKIO funkci
;	out:  A - felhasznli memrialapozs
;
LC153:	ld	(0DFFFh),a		; P_SAVE msolat mentse
	ld	a,0DEh
	ld	i,a			; megszaktsvektor belltsa 0DExx -re (floppy RAM)
	ei
	pop	hl
	pop	af
	call	nc,LC02E		; ha CY=0, akkor FISH funkci vgrehajtsa
	call	c,LC031			; ha CY=1, akkor a DISKIO hvsa
	push	af			; hibakd mentse
	di
	ld	a,0FEh
	ld	i,a			; megszaktsvektor belltsa 0FExx -re (U3 RAM)
	ld	a,(0003Bh)		; A reg.= felhasznli memrialapozs
	jp	000Bh			; vissza a 0. lapon lv U0 RAM-ba

FCOPY_2	.equ	$

;
; ----------------- eddig msoldik a floppy RAM-ba -----------------
;


;
;
;	UPM I/O funkcik
;
;	megj.: mindig a cartridge ROM-ban futnak, fggetlenl attl, hogy
;	       indulskor ez a ROM terlet is bemsoldik az U3 RAM-ba
;

;
;
;	UPM konzol output funkci vgrehajtsa (CONOUT)
;
LC16F:	ex	af,af'			; msodlagos regiszterek mentse
	push	af
	exx
	push	bc
	push	de
	push	hl
	push	ix
	exx
	xor	a
	ld	(0BE8Bh),a		; konzol output llapot: 0 -> folyamatban
	ld	hl,(0BE88h)		; HL= aktulis konzolkimenetet kezel rutin cme (llapotgp az ESC szekvencikhoz)
	call	LC1E7			; HL-ben adott funkci meghvsa (egy "JP (HL)" utasts)
	ld	hl,0BE8Ch
	ld	(hl),002h		; a karakter kirsa utn a kurzor tvltsnak kezdeti idztse (?)
	dec	hl
	dec	(hl)			; konzol output llapot: 0FFh -> ksz
	pop	ix			; elmentett regiszterek helyrelltsa
	pop	hl
	pop	de
	pop	bc
	exx
	pop	af
	ex	af,af'
	xor	a
	ei				; megszaktsok engedlyezse
	ret


;
;
;	Vezrl karakterek megjelentse a kperny kimeneten (belps az ESC szekvenciba)
;	in:  C - karakterkd
;	out: -
;
LC194:	call	LC438			; kurzor megjelentse
	ld	a,c
	ld	hl,LC493		; HL= specilis karakterek tblzatcme
	ld	bc,00021h		; 33 karaktert ellenriz
	cpir
	jr	nz,LC1E0		; ugrs, ha nem tallta meg
	ld	a,c
	ld	(0BE85h),a		; tallt tblzat-pozci mentse
	add	hl,bc			; HL a specilis karakterek tblzata 
	add	hl,bc			; utni tblzat megfelel elemre mutat
	ld	a,(hl)			; a specilis karakterhez tartoz rtk kiolvassa
	or	a
	jr	z,LC1CE			; ugrs, ha kiolvasott rtk nulla
	ld	(0BE87h),a		; kiolvasott rtk trolsa /'i'->1,'d'->2,'u'->2,'y'->1,'x'->1,'Y'->2/
	ld	hl,LC1B4		; j konzol output rutin cme HL-be
	jr	LC1E3			; ugrs a cm letrolsra, majd visszatrs a hvhoz


;
;
;	Konzol output rutin (llapot az ESC szekvencia 1. paramtere utn)
;	in:  C - karakterkd
;	out: -
;
LC1B4:	call	LC438			; kurzor megjelentse
	ld	hl,0BE87h		; HL= paramter szmll cme
	dec	(hl)			; szmll cskkentse
	jr	z,LC1CE			; ugrs, ha csak egy paramter kell
	ld	a,c			; karakterkd A reg.-be
	ld	(0BE86h),a		; karakterkd mentse
	ld	hl,LC1C6		; j konzol output rutin cme HL-be
	jr	LC1E3			; ugrs a cm letrolsra, majd visszatrs a hvhoz


;
;
;	Konzol output rutin (llapot az ESC szekvencia 2. paramtere utn)
;	in:  C - karakterkd
;	out: -
;
LC1C6:	call	LC438			; kurzor megjelentse
	ld	b,c			; 2. paramter B-be
	ld	a,(0BE86h)
	ld	c,a			; 1. paramter C-be
LC1CE:	ld	a,(0BE85h)		; A reg.= vezrl karakter helye (33-sorszm) a tblzatban
	add	a,a
	ld	e,a			; DE= vezrl karakter tblzatcme * 2
	xor	a
	ld	d,a
	ld	hl,LC4D5		; HL= rutincm tblzat kezdcme
	add	hl,de			; HL= a 16 bites elem cme a tblzatban
	ld	e,(hl)			; rutincm beolvassa DE-be a tblzatbl
	inc	hl
	ld	d,(hl)
	ex	de,hl			; rutin cme HL-be
	call	LC1E7			; rutin meghvsa egy JP (HL) utastson keresztl
LC1E0:	ld	hl,LC1EE		; default konzol output rutin cme HL-be
LC1E3:	ld	(0BE88h),hl		; rutin cmnek letrolsa
	ret
;
LC1E7:	jp	(hl)
;


;
;
;	ESC szekvencia vgrehajtsa
;	in:  -
;	out: -
;
LC1E8:	pop	hl			; visszatrsi cm kivtele a verembl
	ld	hl,LC194		; j konzol output rutin cme HL-be
	jr	LC1E3			; ugrs a cm letrolsra, majd visszatrs a hvt meghvhoz


;
;
;	Alaprtelmezett konzol kimeneti rutin a kpernyre
;	in:  C - karakterkd
;	out:   -
;
LC1EE:	ld	a,c
	cp	07Fh
	jr	z,LC194			; ugrs, ha balra es karakter kiejtse (DEL) kd
	cp	020h
	jr	c,LC194			; ugrs, ha brmilyen ms vezrl karakter kdja

;
;
;	Karakter kirsa a kurzor jobbra lptetsvel
;	in:  C - karakterkd
;	out:   -
;	
LC1F7:	call	LC3BA			; karakter kirsa a kpernyre
	xor	a
	ld	(0BE8Eh),a
	ld	a,(0BE83h)		; karakteres X koordinta nvelse
	inc	a
	cp	040h			; X koordinta > 63 ?
	jp	nc,LC235		; ha igen, ugrs kperny pozci kvetkez sor elejre lltsra, majd visszatrs
	ld	(0BE83h),a		; megnvelt X koordinta mentse
	exx
	ld	hl,(0BE80h)		; HL= az aktulis karakterhez tartoz vidememria cm
	inc	hl			; cm nvelse eggyel
LC20Fh:	ld	(0BE80h),hl		; vidememria cm trolsa
	ret


;
;
;	Teljes kperny trlse
;
LC213:	call	LC22F			; a 0. kpernysorra ll

;
;
;	Az aktulis karaktertl jobbra s lefel az sszes karakter trlse
;
LC216:	call	LC242			; sor htralv karaktereinek trlse
	ld	bc,(0BE82h)		; C= aktulis sor szma
	ld	a,017h			; A reg.= 23 (legnagyobb sor szma)
	sub	c			; A reg.= htralv sorok szma
	ret	z			; visszatrs, ha a kperny aljn van
	ld	b,a			; B= htralv sorok szma
	ld	a,c			; A reg.= aktulis sor
	inc	a			; kvetkez sor szma
	call	LC28B			; A reg.-ben adott sor szmbl vidememria cm kiszmtsa
	ld	a,b			; A reg.= htralv sorok szma
LC228:	call	LC26C			; egy teljes karaktersor trlse
	dec	a			; bug? - ide kell mg egy 'INC HL' is, a csszs miatt a kperny utols 22 bjtjt nem trli
	jr	nz,LC228		; ismtls az sszes htralv sorra
	ret


;
;
;	Az aktulis kperny-pozci nullzsa (bal fels sarok, X= 0  Y= 0)
;	in:  -
;	out: -
;
LC22F:	xor	a
	ld	(0BE82h),a		; Y koordinta = 0
	jr	LC280			; ugrs az X koordinta 0-ra lltsra


;
;
;	Kperny pozci kvetkez sor elejre lltsa
;	in:  -
;	out: -
;
LC235:	call	LC280			; az aktulis sor elejre ll
LC238:	call	LC34E			; karakteres Y koordinta nvelse eggyel
	ret	c			; visszatrs, ha a kpernyre esik az j koordinta
	ld	bc,01700h		; B= als sor (23)  C= fels sor (0)
	jp	LC29F			; ugrs a karakteres kperny felfele mozgatsra (scrollozs), majd visszatrs


;
;
;	Aktulis karaktersor htralv karaktereinek letrlse a kpernyrl
;
LC242:	ld	hl,(0BE80h)		; HL= aktulis karakterpozci a vidememriban
	ld	a,03Fh
	sub	l
	and	03Fh			; A reg.= a sorban htralv karakterek szma -1
	inc	a
	ld	de,00040h		; DE= egy kpernysor hossza (64 bjt)
	ld	b,00Ah			; B = egy karakter magassga (10 TV sor)
LC250:	push	hl
	exx
	pop	hl			; HL'= aktulis pozci a vidememriban
	ld	e,l
	ld	d,h
	inc	de			; DE'= HL' + 1
	ld	c,a
	ld	b,000h			; BC'= a sorban htralv karakterek szma
	ld	(hl),b			; els karakter kinullzsa
	dec	c
	jr	z,LC25F			; ugrs, ha csak 1 karakter volt
	ldir				; maradk karakterbjtok kinullzsa
LC25F:	exx
	add	hl,de			; HL a karaktersor kvetkez TV sorra mutat
	djnz	LC250			; ismtls az sszes TV sorra
	ret


;
;
;	Az aktulis sor trlse
;	in:  -
;	out: -
;
LC264:	ld	a,(0BE82h)		; A reg.= Y koordinta
	ld	b,a			; B= Y koordinta

;
;
;	Adott sor trlse
;	in:   B - sor szma
;	out:  -
;
LC268:	ld	a,b			; sor szma A reg.-be
	call	LC28B			; A reg.-ben adott sor szmbl vidememria cm kiszmtsa

;
;
;	Egy teljes karaktersor trlse
;	in:  HL - a karaktersor kezd vidememria beli cme
;	out: -
;
LC26C:	ld	e,l			; vidememria cm DE-be is
	ld	d,h
	inc	de			; cm nvelse
	ld	(hl),000h		; els bjt nullzsa
	ld	bc,0027Fh		; BC= 639 (10 * 64 bjt -1)
	ldir				; karaktersor trlse
	ret


;
;
;	Az aktulis sor kiejtse az alatta lvk felfel mozgatsval, kurzor a sor elejre ll
;
LC277:	ld	bc,(0BE82h)		; B= X koordinta  C= Y koordinta (fels sor)
	ld	b,017h			; B= 23 (als sor)
	call	LC29F			; karakteres kperny mozgatsa felfel (scrollozs)

;
;
;	Aktulis sor elejre lls (X koordinta = 0)
;
LC280:	xor	a
	ld	(0BE83h),a
	ld	hl,LC20Fh		; HL= a rutin j visszatrsi cme
	push	hl			; j visszatrsi cm  a verembe
	ld	a,(0BE82h)		; A reg.= aktulis sor szma

;
;
;	A reg.-ben adott sor szmbl vidememria cm kiszmtsa
;	in:   A - kperny sor szma
;	out:  A - u.a. mint H rtke, de a 7. bit = 0
;	     HL - a sor vidememriabeli cme
;	     BC - megrzdik
;
LC28B:	add	a,a			; A reg. szorzsa 10-el
	ld	d,a
	add	a,a
	add	a,a
	add	a,d			; A reg. = 10 * A reg.
	ld	l,000h
	rra				; A:L = 256 * 10 * A reg.
	rr	l			; A:L = 256 * 10 * A reg. / 4
	rra
	rr	l
	ld	h,a			; HL= 640 * A reg.
	set	7,h			; H legfels bitjnek belltsa (08000h offszet)
	ret


;
;
;	Kperny felfel grgetse 1 sorral (scrollozs felfel)
;	in:   B - 2. paramter ( als sor Y koordintja, ahol az res sor keletkezik)
;	      C - 1. paramter (fels sor Y koordintja, ami "kilp")
;	out:  -
;
LC29C:	call	LC42C			; paramterek rtknek vizsglata s mdostsa


;
;
;	Karakteres kperny mozgatsa felfel (scrollozs)
;	in:   B - legals sor szma, amit mg mozgatni kell felfel
;	      C - legfels sor szma, ami trldik
;	out: -
;
LC29F:	ld	a,b			; A reg.= legals sor szma
	sub	c
	ret	c			; visszatrs, ha a legfels sor szma nagyobb a legals sornl
	jp	z,LC268			; ugrs a B-ben adott sor trlsre, ha a fels sor megegyezik az als sorral, majd visszatrs
	call	LC28B			; A reg.-ben lv sortvolsgbl a mozgatand memriaterlet kiszmtsa
	ld	b,a			; BC= 640 * sortvolsg
	ld	a,c			; A= cl sor szma
	ld	c,l
	call	LC28B			; A reg.-ben adott sor szmbl vidememria cm kiszmtsa
	ex	de,hl			; DE= cl vidememria cm
	ld	hl,00280h		; HL= 640
	add	hl,de			; HL= DE + 640
	ldir				; sorok mozgatsa felfel
	ex	de,hl			; HL= utols sor vidememrabeli cme
	jp	LC26C			; ugrs a HL-ben adott teljes karaktersor trlsre, majd visszatrs


;
;
;	Kurzor mozgatsa egy sorral feljebb, s kperny scrollozsa lefel, ha szksges
;	in:  -
;	out: -
;
LC2B9:	call	LC34F			; karakteres Y koordinta cskkentse eggyel
	ret	c			; visszatrs, ha a kperny tartomnyon bell maradt az j pozci
	scf				; CY=1 -> tlpi a kvetkez CALL NC,xxxx utastst


;
;
;	Egy res sor beszrsa az aktulis Y koordintnl a kperny lefel grgetsvel
;	in:  -
;	out: -
;
LC2BE:	call	nc,LC280		; ha CY=0, akkor az aktulis sor elejre ll (X koordinta = 0)
	ld	bc,(0BE82h)		; B= X koordinta  C= Y koordinta
	ld	b,017h			; B= 23
	scf				; CY=1 -> tlpi a kvetkez CALL NC,xxxx utastst


;
;
;	Kperny lefele grgetse 1 sorral (scrollozs lefel)
;	in:   B - 2. paramter ( als sor Y koordintja, ami "kilp")
;	      C - 1. paramter (fels sor Y koordintja, ahol az res sor keletkezik)
;	     CY - CY= 0 -> paramterek vizsglata s mdostsa
;	out:  -
;
LC2C8:	call	nc,LC42C		; ha CY=0, akkor a paramterek rtknek vizsglata s mdostsa
	ld	a,b			; A reg.= als sor Y koordintja
	ld	b,c			; B s C tartalmnak felcserlse
	ld	c,a
	sub	b			; A reg.= sorok kzti tvolsg
	ret	c			; visszatrs, ha a fels Y koordinta nagyobb az als Y koordintnl
	jp	z,LC268			; ugrs a B-ben adott sor trlsre, ha a fels sor megegyezik az als sorral, majd visszatrs
	call	LC28B			; A reg.-ben adott sor szmbl vidememria cm kiszmtsa
	ld	b,a			; vidememria beli offszet cm mentse BC-be (msoland bjtok szma)
	ld	a,c			; A reg.= als sor Y koordintja
	ld	c,l
	inc	a			; A reg.= als sor utni kvetkez sor szma
	call	LC28B			; A reg.-ben adott sor szmbl vidememria cm kiszmtsa
	dec	hl			; HL az als sor utols bjtjra mutat
	ex	de,hl			; vidememria cm DE-be
	ld	hl,0FD80h		; HL= -640
	add	hl,de			; HL az als sor eltti sor utols bjtjra mutat
	lddr				; sorok msolsa (grgets lefel)
	inc	hl			; HL a fels sor bal fels bjtjra mutat
	jp	LC26C			; ugrs a teljes karaktersor trlsre, majd visszatrs


;
;
;	Vezrl szekvencia feldolgozsa: ESC + 'x'
;	in:  C - paramter karakter: C='4' -> 10 soros kurzor   C='5'-> kurzor kikapcsolsa
;	out: -
;
LC2E9:	ld	a,c			; A reg.= paramter karakter
	cp	034h
	jr	z,LC300			; ugrs, ha a karakter '4'
	cp	035h
	ret	nz			; visszatrs, ha a karakter nem '5'
	.db	03Eh			; a kvetkez bjttal: 'LD A,0AFH' (elfedi 'XOR A'-t)
LC2F2:	xor	a
	ld	(0BE8Ah),a		; kurzor llapotnak belltsa (be/ki)
	ret


;
;
;	Vezrl szekvencia feldolgozsa: ESC + 'y'
;	in:  C - paramter karakter: C='4' -> 2 soros kurzor   C='5'-> kurzor bekapcsolsa
;	out: -
;
LC2F7:	ld	a,c			; A reg.= paramter karakter
	cp	035h
	jr	z,LC2F2			; ugrs, ha a karakter '5'
	cp	034h
	ret	nz			; visszatrs, ha a karakter nem '4'
	.db	03Eh			; a kvetkez bjttal: 'LD A,0AFH' (elfedi 'XOR A'-t)
LC300:	xor	a
	ld	(0BE84h),a		; kurzor tpusnak belltsa
	ret


;
;
;	Karakter megjelentsi md belltsa (norml/inverz)
;	in:  C - paramter (C=0 -> norml  C<>0 -> inverz)
;	out: -
;
LC305:	ld	a,c			; A reg.= paramter
	add	a,0FFh
	sbc	a,a			; A reg.= 000h vagy 0FFh
	ld	(0BE8Fh),a		; karakter megjelentsi md belltsa
	ret


;
;
;	Cskken amplitudj fix hang megszlaltatsa (BEEP)
;	in:  -
;	out: -
;
LC30D:	di				; megszak. tiltsa
	ld	a,000h
	out	(004h),a		; PITCH als 8 bit belltsa
	call	PG0ADR(LE644)		; adatbjt kiolvassa a floppy RAM-bl, megszaktsok tiltsa
;
	.dw	0DFFDh			; Port 5 msolata
;
	and	0C0h
	or	01Fh			; hang jel engedlyezse s PITCH fels 4 bit = 00Fh
	out	(005h),a		; port 5 belltsa
	ld	bc,00F3Ch		; B= ismtlsek szma (15)  C= hang kezd amplitudja
LC320:	call	PG0ADR(LE644)		; adatbjt kiolvassa a floppy RAM-bl, megszaktsok tiltsa
;
	.dw	0DFFCh			; Port 6 msolata
;
	and	0C3h			; hang amplitud kimaszkolsa
	or	c			; amplitud belltsa a maximlis rtkre
	out	(006h),a		; port 6 belltsa
	ld	de,007D0h		; DE= vrakozsi ciklus hossza
LC32D:	dec	de
	ld	a,d
	or	e
	jr	nz,LC32D		; vrakozs a megadott ideig
	dec	a			; A reg.= 0FFh
	call	PG0ADR(LE652)		; adatbjt belltsa a floppy RAM-ban, megszaktsok tiltsa
;
	.dw	0D015h			; SER_OK vltoz
;
	ld	a,c			; A reg.= hang amplitud
	sub	004h			; amplitud cskkentse
	ld	c,a			; cskkentett rtk vissza C-be
	djnz	LC320			; ismtls 15-szr
	call	PG0ADR(LE644)		; adatbjt kiolvassa a floppy RAM-bl, megszaktsok tiltsa
;
	.dw	0DFFCh			; Port 6 msolata
;
	out	(006h),a		; port 6 visszalltsa az eredeti rtkre
	call	PG0ADR(LE644)		; adatbjt kiolvassa a floppy RAM-bl, megszaktsok tiltsa
;
	.dw	0DFFDh			; Port 5 msolata
;
	out	(005h),a		; port 5 visszalltsa az eredeti rtkre
	ei				; megszak. engedlyezse
	ret


;
;
;	Karakteres Y koordinta nvelse eggyel
;	in:  -
;	out: CY - CY= 0 -> kpernyn kvlre esne az j koordinta
;	          CY= 1 -> a koordinta frisstve lett
;
LC34E:	.db	0F6h			; CY= 0 (0F6h a kvetkez bjttal: 'OR 037h' (elfedi 'SCF'-t))
;
;
;	Karakteres Y koordinta cskkentse eggyel
;	in:  -
;	out: CY - CY= 0 -> kpernyn kvlre esne az j koordinta
;	          CY= 1 -> a koordinta frisstve lett
;
LC34F:	scf				; CY= 1
	sbc	hl,hl			; HL= 0000h (ha CY=0 volt) vagy 0FFFFh (ha CY=1 volt)
	set	0,l			; HL= 0001h (ha CY=0 volt) vagy 0FFFFh (ha CY=1 volt)
	jr	LC35E


;
;
;	Karakteres X koordinta nvelse eggyel
;	in:  -
;	out: CY - CY= 0 -> kpernyn kvlre esne az j koordinta
;	          CY= 1 -> a koordinta frisstve lett
;
LC356:	.db	0F6h			; CY= 0 (0F6h a kvetkez bjttal: 'OR 037h' (elfedi 'SCF'-t))
;
;
;	Karakteres X koordinta cskkentse eggyel
;	in:  -
;	out: CY - CY= 0 -> kpernyn kvlre esne az j koordinta
;	          CY= 1 -> a koordinta frisstve lett
;
LC357:	scf				; CY= 1
	sbc	a,a			; A reg.= 000h (ha CY=0 volt) vagy 0FFh (ha CY=1 volt)
	or	001h			; A reg.= 001h (ha CY=0 volt) vagy 0FFh (ha CY=1 volt)
	ld	h,a			; HL= 00100h vagy 0FF00h
	ld	l,000h

;
;
;	Karakteres kpernykoordintk frisstse
;	in:   H - X koordinta vltozsa, 001h (X= X+1) vagy 0FFh (X= X-1)
;	      L - Y koordinta vltozsa, +127...-128
;	out: CY - CY= 0 -> kpernyn kvlre esne az j koordinta
;	          CY= 1 -> a koordintk frisstve lettek
;
LC35E:	ld	e,l			; HL rtknek mentse DE-be
	ld	d,h
	ld	bc,(0BE82h)		; B= X koordinta  C= Y koordinta a karakteres kpernyn
	add	hl,bc			; koordintk nvelse a HL-ben adott rtkekkel
	ld	a,l			; A reg.= j Y koordinta
	cp	018h
	ret	nc			; visszatrs, ha Y > 23
	ld	a,h			; A reg.= j X koordinta
	cp	040h
	ret	nc			; visszatrs, ha X > 63
	ld	(0BE82h),hl		; mdostott karakteres koordinta rtkek elmentse
	ld	a,e			; A reg.= Y koordinta vltozsa
	or	a
	jr	nz,LC37B		; ugrs, ha az Y koordinta vltozott
	ld	e,d			; E= X vltozsa
	dec	d
	jr	z,LC38A			; ugrs, ha X koordinta 1-el nvekedett (ilyenkor DE= 0001h)
	inc	d
	jr	LC38A			; ha X koordinta 1-el cskkent, akkor DE= 0FFFFh (= -1)
;
LC37B:	add	a,a			; A reg.= 10 * Y koordinta vltozsa
	add	a,a
	add	a,e
	add	a,a
	ld	e,000h
	sra	a			; kapott rtk lptetse ktszer jobbra
	rr	e			; kilp bitek E-be
	sra	a
	rr	e
	ld	d,a			; DE= 64 * 10 * Y koordinta vltozsa
LC38A:	ld	hl,(0BE80h)		; HL= az aktulis karakterhez tartoz vidememria cm
	add	hl,de			; vidememria cm nvelse a koordinta vltozsnak megfelelen
	ld	(0BE80h),hl		; frisstett memriacm mentse
	scf
	ret


;
;
;	Karakteres X koordinta cskkentse eggyel, sor elejn az elz sor vgre ll
;	in:  -
;	out: CY - CY=0 -> elrte a kperny bal fels sarkt
;
LC393:	call	LC357			; karakteres X koordinta cskkentse eggyel
	ret	c			; visszatrs, ha a kperny tartomnyon bell maradt
	call	LC34F			; karakteres Y koordinta cskkentse eggyel
	ret	nc			; visszatrs, ha elrte a kperny tetejt
	ld	a,03Fh
	ld	(0BE83h),a		; X koordinta belltsa 63-ra (elz sor vge)
	ld	e,a			; DE= eltolsi rtk X koordintnak megfelelen
	ld	d,000h
	jr	LC38A			; ugrs az aktulis vidememria cm frisstsre, majd visszatrs


;
;
;	Karakteres X koordinta nvelse eggyel, sor vgn a kvetkez sor elejre ll
;	in:  -
;	out: -
;
LC3A5:	call	LC356			; karakteres X koordinta nvelse eggyel
	ret	c			; visszatrs, ha a kperny tartomnyon bell maradt
	call	LC34E			; karakteres Y koordinta nvelse eggyel
	ret	nc			; visszatrs, ha elrte a kperny aljt
	jp	LC280			; ugrs az aktulis sor elejre llsra, majd visszatrs


;
;
;	Kurzor balra lptetse s karakter trlse (DEL)
;	in:  -
;	out: -
;
LC3B0:	call	LC393			; karakteres X koordinta cskkentse eggyel, sor elejn az elz sor vgre ll
	ret	nc			; visszatrs, ha elrte a kperny bal fels sarkt
	ld	c,020h			; C= SPACE karakter kdja
	ld	e,000h			; E= norml megjelents
	jr	LC3BE			; ugrs a karakter kirsra, majd visszatrs


;
;
;	Karakter kirsa a kpernyre
;	in:   C - karakterkd (>020h)
;	out: CY - CY=1
;
LC3BA:	ld	a,(0BE8Fh)		; A reg.= karakter megjelentsi md
	ld	e,a			; E= karakter megjelentsi md (000h - norml  0FFh - invertlt)
LC3BE:	ld	a,c
	sub	020h			; karakterkd cskkentse (vezrl karakter nem lehet)
	cp	080h
	jr	c,LC3C7			; ugrs, ha az eredeti karakterkd kisebb 0A0h-nl
	ld	a,05Fh			; karakter helyettestse 07Fh-nak megfelel kddal
LC3C7:	ld	c,a			; mdostott karakterkd kiterjesztve 16 bitre BC-ben
	ld	b,000h
	ld	h,b			; HL= mdostott karakterkd
	ld	l,c
	add	hl,hl			; karakterkd szorzsa
	add	hl,hl
	add	hl,bc
	add	hl,hl			; HL= karakterkd * 10
	ld	bc,LC97A		; BC= karaktermintzatok kezdcme
	add	hl,bc			; HL= kirand karaktermintazat cme
	ld	c,e			; C = invertlsi kd
	ld	b,00Ah			; B = 10 karaktersor lesz
	exx
	ld	hl,(0BE80h)		; HL'= az aktulis karakterhez tartoz vidememria cm
	exx
LC3DC:	ld	a,(hl)			; A reg.= karakter aktulis sornak bitmintja
	xor	c			; sor invertlsa, ha kell
	exx
	ld	(hl),a			; karakter sornak kirsa a kpernyre
	ld	bc,00040h
	add	hl,bc			; HL' a karakter kvetkez kpernysornak cmre mutat
	exx
	inc	hl			; HL a karakter kvetkez sornak bitmintjra mutat
	djnz	LC3DC			; ismtls az sszes sorra
	scf				; CY= 1
	ret


;
;
;	Karakteres X koordinta nvelse a TAB mrettel, szkzk kirsval
;	in:  -
;	out: -
;
LC3EA:	ld	a,(0BE83h)		; A reg.= X koordinta
	ld	c,a			; rtk C-be is
	add	a,008h			; koordinta nvelse a TAB rtkkel (8 karakter)
	and	078h			; lekerekts a legkzelebbi 8-al oszthat rtkre
	sub	c			; A reg.= tnyleges X koordinta nvels rtke
	ld	b,a			; koordinta vltozs B-be
	ld	c,020h			; C= SPACE karakter
LC3F6:	push	bc
	call	LC1F7			; karakter kirsa a kurzor jobbra lptetsvel
	pop	bc
	djnz	LC3F6			; a szksges szm szkz kirsa a kpernyre
	ret


;
;
;	Kurzor pozcionlsa
;	in:   B - 2. paramter (oszlop X koordintja)
;	      C - 1. paramter (   sor Y koordintja)
;	out:  -
;
LC3FE:	call	LC423			; vezrl karakter utni paramterek rtknek cskkentse 020h-val
	ld	a,b
	cp	040h			; X koordinta ellenrzse
	jr	c,LC408			; ugrs, ha kisebb 64-nl
	ld	b,03Fh			; koordinta belltsa 63-ra
LC408:	ld	h,b			; H= limitlt X koordinta
	ld	a,c
	cp	018h			; Y koordinta ellenrzse
	jr	c,LC410			; ugrs, ha kisebb 24-nl
	ld	c,017h			; koordinta belltsa 23-ra
LC410:	ld	l,c			; L= limitlt Y koordinta
	ld	(0BE82h),hl		; aktulis karakterpozci belltsa
	ld	a,l
	call	LC28B			; A reg.-ben adott sor szmbl vidememria cm kiszmtsa
	ld	a,(0BE83h)		; A reg.= X koordinta
	ld	e,a
	ld	d,000h
	add	hl,de			; szmtott vide memria cm nvelse az X koordintnak megfelelen
	ld	(0BE80h),hl		; memria cm mentse
	ret


;
;
;	Vezrl karakter utni paramterek rtknek cskkentse 020h-val
;	in:   B - 2. paramter
;	      C - 1. paramter
;	out:  B - 2. paramter - 32
;	      C - 1. paramter - 32
;
LC423:	ld	a,b			; A reg.= 1. paramter a vezrl karakter utn
	sub	020h
	ld	b,a			; 32-vel cskkentett paramterrtk vissza B-be
	ld	a,c			; A reg.= 2. paramter a vezrl karakter utn
	sub	020h
	ld	c,a			; 32-vel cskkentett paramterrtk vissza C-be
	ret


;
;
;	Vezrl karakter utni paramterek vizsglata (Y koordinta adatok kperny grgetshez),
;	csak akkor tr vissza a hvhoz, ha 1. paramter < 038h s 2. paramter < vagy = 1. paramter
;	in:   B - 2. paramter
;	      C - 1. paramter
;	out:  B - 2. paramter - 32
;	      C - 1. paramter - 32
;
LC42C:	call	LC423			; vezrl karakter utni paramterek rtknek cskkentse 020h-val
	ld	a,b
	cp	c			; mdostott paramterek sszehasonltsa
	jr	c,LC436			; ugrs, ha 2. paramter > 1. paramter
	cp	018h
	ret	c			; visszatrs a hvhoz, ha 1. paramter < 018h (eredetileg 038h)
LC436:	pop	hl			; egybknt a hv visszatrsi cmnek eltvoltsa a verembl
	ret				; visszatrs a hvt meghv rutinhoz


;
;
;	Kurzor megjelentse
;	in:   -
;	out:  BC - megrzdik
;
LC438:	ld	a,(0BE8Eh)		; kurzor fzisnak ellenrzse
	or	a
	ret	z			; visszatrs, ha nem ltszik (?)
LC43D:	push	bc
	ld	hl,0BE8Eh		; ? kurzor fzisa
	ld	a,(hl)
	cpl
	ld	(hl),a
	ld	hl,(0BE80h)		; HL= az aktulis karakterhez tartoz vidememria cm
	ld	de,00040h		; DE= 64
	ld	bc,00A03h		; B = teljes karakter magassga (10)  C= kurzor magassga+1 (3)
	ld	a,(0BE84h)		; A reg.= kurzor tpusa
	or	a
	jr	nz,LC455		; ugrs, ha csak 2 soros a kurzor
	ld	c,00Bh			; egybknt: C= 11
LC455:	ld	a,b
	cp	c
	jr	nc,LC45C		; ugrs, ha a karakter aktulis sora mg nem esik bele a kurzor tartomnyba
	ld	a,(hl)			; egybknt a kpernytartalom invertlsa
	cpl
	ld	(hl),a
LC45C:	add	hl,de			; HL= HL + 64
	djnz	LC455			; ismtls a karakter sszes sorra
	pop	bc
	ret


;
;
;	Megszakts-kiszolglbl hvott rutin
;	(kurzor frisstse)
;
LC461:	ld	hl,0BE8Ah		; kurzor llapot vltoz cme
	ld	a,(hl)			; A reg.= kurzor llapot ( 0-> bekapcsolva  nem 0 -> kikapcsolva)
	or	a
	ret	nz			; visszatrs, ha a kurzor ki van kapcsolva
	inc	hl
	or	(hl)			; konzol output llapot (?) vizsglata
	ret	z			; visszatrs, ha karakter kirajzols van folyamatban
	inc	hl
	and	(hl)			; konzol output utni kurzor idzt vizsglata (eltte A reg.-ben 0FFh volt)
	jr	z,LC472			; ugrs, ha mr lejrt az idzt
	dec	(hl)			; idzt cskkentse
	ret	nz			; visszatrs, ha mg nem nulla
	inc	hl
;
	.db	0C2h			; a kvetkez kt bjttal: JP NZ,03523h (elfedi INC HL-t s DEC (HL)-t)
;
LC472:	inc	hl
	dec	(hl)			; norml kurzor idzt cskkentse
	ret	nz			; visszatrs, ha mg nem nulla
	ld	(hl),00Ah		; norml idzt alaprtknek belltsa
	jr	LC43D			; ugrs az aktulis kurzorfzis megjelentsre, majd visszatrs


;
;
;	Kperny inicializlsa
;
LC479:	xor	a
	ld	(0BE84h),a		; kurzor tpusa: 10 sor magas
	ld	hl,LC1EE
	ld	(0BE88h),hl		; aktulis konzol output rutin cme
	call	LC213			; a teljes kperny letrlse
	ld	hl,0BE8Ch
	ld	(hl),001h		; kurzor idzts kzvetlenl a konzol output vgrehajtsa utn
	dec	hl
	ld	(hl),0FFh		; konzol output llapot: ksz
	xor	a
	ld	(0BE8Ah),a		; kurzor llapot: 0-> bekapcsolva
	ret


;
;
;	Vezrl karakterek kdjai (33 bjt) (ld. pdf. 100. oldal)
;
LC493:
	.db	01Bh, 019h, 00Ah, 00Dh, 00Ch, 007h, 008h, 07Fh, 009h, 00Bh, 01Ch
	.db	01Dh, 01Eh, 01Fh, 06Ah, 045h, 04Bh, 04Ah, 06Ch, 04Ch, 04Dh, 059h
	.db	041h, 042h, 043h, 044h, 048h, 078h, 079h, 075h, 064h, 049h, 069h

;
;
;	Vezrl karakterek utni "paramter karakterek" szma
;	az els tblzathoz kpest fordtott sorrendben (33 bjt)
;
	.db	001h, 000h, 002h, 002h, 001h, 001h, 000h, 000h, 000h, 000h, 000h
	.db	002h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
	.db	000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h

;
;
;	Vezrl karakterekhez tartoz vgrehajtand rutinok cmei
;	az els tblzathoz kpest fordtott sorrendben (33 x 2 bjt)
;
LC4D5:
	.dw	LC305			; 'i'  - karakter megjelentsi md belltsa (norml/inverz)
	.dw	LC2B9			; 'I'  - kurzor mozgatsa egy sorral feljebb, s kperny scroll-ozsa, ha szksges
	.dw	LC2C8			; 'd'  - kperny lefel grgetse 1 sorral, a fels s als sor a paramterekben megadva
	.dw	LC29C			; 'u'  - kperny felfel grgetse 1 sorral, a fels s als sor a paramterekben megadva
	.dw	LC2F7			; 'y'  -  2 soros kurzor (1. paramter = '4') vagy kurzor bekapcsolsa (1. paramter = '5')
	.dw	LC2E9			; 'x'  - 10 soros kurzor (1. paramter = '4') vagy kurzor kikapcsolsa (1. paramter = '5')
	.dw	LC22F			; 'H'  - kurzor a kperny bal fels sarokba lltsa (u.a. mint 00Bh)
	.dw	LC357			; 'D'  - karakteres X koordinta cskkentse eggyel
	.dw	LC356			; 'C'  - karakteres X koordinta nvelse eggyel
	.dw	LC34E			; 'B'  - karakteres Y koordinta nvelse eggyel    (u.a. mint 01Fh)
	.dw	LC34F			; 'A'  - karakteres Y koordinta cskkentse eggyel (u.a. mint 01Eh)
	.dw	LC3FE			; 'Y'  - kurzor pozcionlsa
	.dw	LC277			; 'M'  - az aktulis sor kiejtse az alatta lvk felfel mozgatsval, kurzor a sor elejre ll
	.dw	LC2BE			; 'L'  - egy res sor beszrsa az aktulis Y koordintnl a kperny lefel grgetsvel
	.dw	LC264			; 'l'  - az aktulis sor trlse
	.dw	LC216			; 'J'  - az aktulis karaktertl jobbra s lefel az sszes karakter trlse
	.dw	LC242			; 'K'  - az aktulis karaktersor htralv karaktereinek trlse (u.a. mint 019h)
	.dw	LC213			; 'E'  - teljes kperny trlse
	.dw	LC213			; 'j'  - teljes kperny trlse
	.dw	LC34E			; 01Fh - karakteres Y koordinta nvelse eggyel
	.dw	LC34F			; 01Eh - karakteres Y koordinta cskkentse eggyel
	.dw	LC393			; 01Dh - karakteres X koordinta cskkentse eggyel, sor elejn az elz sor vgre ll
	.dw	LC3A5			; 01Ch - karakteres X koordinta nvelse eggyel, sor vgn a kvetkez sor elejre ll
	.dw	LC22F			; 00Bh - kurzor a kperny bal fels sarokba lltsa
	.dw	LC3EA			; 009h - TAB a kvetkez 8-al oszthat X koordintig, szkzk kirsval
	.dw	LC3B0			; 07Fh - kurzor balra lptetse s karakter trlse (DEL)
	.dw	LC393			; 008h - karakteres X koordinta cskkentse eggyel, sor elejn az elz sor vgre ll
	.dw	LC30D			; 007h - cskken amplitudj fix hang megszlaltatsa (BEEP)
	.dw	LC213			; 00Ch - teljes kperny trlse
	.dw	LC280			; 00Dh - kurzor a sor elejre
	.dw	LC238			; 00Ah - kurzor a kvetkez sorra (soremels), a kperny aljn scrollozs
	.dw	LC242			; 019h - az aktulis karaktersor htralv karaktereinek trlse
	.dw	LC1E8			; 01Bh - ESC  (kilps)



;
;
;	UPM konzol input funkci vgrehajtsa (CONIN)
;	in:   A - A= 0 -> vrakozs egy billenty lenyomsra
;	          A<>0 -> csak jelzi, hogy van-e lenyomott billenty
;	out:  A - A = 000h
;	      C - beolvasott karakter kdja v. billentyzet llapot
;
LC517:	or	a
	jr	z,LC520
	ld	bc,(0BE90h)
	xor	a
	ret
;
LC520:	ld	hl,0BE90h		; HL= rvnyes karaktert jelz flag cme
LC523:	ld	a,(hl)			; flag ellenrzse
	or	a
	jr	z,LC523			; vrakozs, amg nem rkezik rvnyes karakter
	ld	a,(0BE94h)
	ld	c,a			; beolvasott karakter kdja C-be
	xor	a
	ld	(hl),a			; karakter feldolgozottsgnak jelzse
	ret


;
;
;	Billentyzet idztsi paramtereinek alaphelyzetbe lltsa
;	in: -
;	out:  A - 000h
;
LC52E:	ld	a,01Eh
	call	PG0ADR(LE652)		; adatbjt belltsa a floppy RAM-ban, megszaktsok tiltsa
;
	.dw	0D01Bh			; DLY_KEY
;
	ld	a,003h
	call	PG0ADR(LE652)		; adatbjt belltsa a floppy RAM-ban, megszaktsok tiltsa
;
	.dw	0D019h			; RATE_KEY
;
	xor	a
	ret


;
;
;	Megszakts-kiszolgl CART-ban fut rsze
;
LC53E:	call	LC461			; kurzor frisstse
	call	PG0ADR(LE644)		; adatbjt kiolvassa a floppy RAM-bl, megszaktsok tiltsa
;
	.dw	0D01Ah			; LOCK_KEY
;
	and	00Bh			; hasznlt jelzbitek megtartsa
	ld	b,a			; bitek B-be is
	neg				; A= 0-A
	and	b			; billentyzet lock priorits szerint tkdolva: nagybet > SHIFT > ALT
	call	PG0ADR(LE652)		; adatbjt belltsa a floppy RAM-ban, megszaktsok tiltsa
;
	.dw	0D01Ah			; LOCK_KEY (mdostva)
;
	call	LC69D			; billentyzet mtrix beolvassa s trolsa
	ld	hl,0BE92h		; HL= LOCK flag vltoz cme
	bit	5,(iy+006h)		; billentyzet 6. sor 5. bitjnek vizsglata (LOCK)
	jr	z,LC56C			; ugrs, ha nincs lenyomva
	ld	a,(hl)
	or	a
	ret	nz			; visszatrs, ha a LOCK mr korbban is le volt nyomva
	dec	(hl)			; LOCK flag = 0FFh
	ld	a,001h			; A reg.= 001h -> CTRL lenyomsa CAPS LOCK kdot fog visszaadni
	call	LC688			; vltbillentyk (CTRL/SHIFT/ALT) llapotnak lekrdezse
	call	PG0ADR(LE652)		; adatbjt belltsa a floppy RAM-ban, megszaktsok tiltsa
;
	.dw	0D01Ah			; LOCK_KEY (a beolvasott vltbillenty llapottal frisstve)
;
	ret	nz			; visszatrs, ha volt vltbillenty lenyomva
LC56C:	ld	(hl),b			; LOCK flag vltoz nullzsa (B = 000h volt)
	ld	a,004h			; CTRL lenyomsi kdja 004h lesz
	call	LC688			; vltbillentyk (CTRL/SHIFT/ALT) llapotnak lekrdezse
	ld	(0BE93h),a		; llapot trolsa
LC575:	call	LC5E0			; lenyomott gomb (ASCII) kdjnak kikeresse
	inc	e
	jr	z,LC58D			; ugrs, ha E=0FFh volt
	ld	a,c
	ld	(0BE94h),a		; lenyomott billenty kdjnak trolsa
	ld	a,0FFh
	ld	(0BE90h),a		; rvnyes kd jelzse
	call	PG0ADR(LE644)		; adatbjt kiolvassa a floppy RAM-bl, megszaktsok tiltsa
;
	.dw	0D01Bh			; DLY_KEY
;
	ld	(0BE95h),a		; billenty-ismtls kezdet idztsnek belltsa
	ret
;
LC58D:	ld	hl,0BE95h		; HL= billenty-ismtls kezdetnek idztje (DLY_KEY)
	call	LC5D9			; idzt rtknek cskkentse
	inc	hl			; HL= billenty-ismtls peridus idztje (RATE_KEY)
	call	nc,LC5D9		; idzt cskkentse, kivve, ha a DLY_KEY idzt ppen lejrt
	ret	nc			; visszatrs, ha mg nem jrt le egyik idzt sem
	ld	a,(0BE99h)
	ld	c,a			; C = a legutbb feldolgozott billenty mtrixsora (a megfelel bit 1)
	ld	de,(0BE97h)		; DE= a billentyhz tartoz mtrixsor cme
	ld	hl,0BEADh		; HL= az utols mtrixsor cme
	sbc	hl,de			; HL= HL-DE -1 (CY=1 volt)
	ex	de,hl
	jr	z,LC5B2			; ugrs, ha az utols eltti sor (jobb oldali joystick)
	or	a			; most CY=0
	ex	de,hl			; DE= az utoljra lenyomott billentyhz tartoz mtrixsor cme
	ld	hl,0BEADh
	sbc	hl,de			; HL= HL-DE
	ex	de,hl
	jr	nz,LC5BB		; ugrs, ha nem az utols sor (nem a bal oldali joystick)
LC5B2:	ld	d,066h
	and	d			; DOWN/UP/LEFT/RIGHT bitek megtartsa
	jr	z,LC5BB			; ugrs, ha egyik irny sem volt aktv
	xor	d			; csak az inaktv irnyok bitjei lesznek 1-esek 
	and	(hl)			; sszeveti a feldolgozott billentyzet adatokkal
	jr	nz,LC5CC		; ugrs, ha valamelyik msik irny is aktv
LC5BB:	ld	a,c			; A reg. = a legutoljra lenyomott billenty
	and	(hl)
	jr	nz,LC5CC		; ugrs, ha mg mindig nyomva van
	ld	hl,0BEA4h		; feldolgozottsgi mtrix cme HL-be
	ld	b,00Ah			; 10 sor lesz
LC5C4:	ld	(hl),a			; a mtrix minden sornak trlse (A reg.= 000h)
	inc	hl
	djnz	LC5C4
	ld	(0BE96h),a		; billenty-ismtlsi peridus idztjnek trlse
	ret
;
LC5CC:	cpl				; aktv billenty bitje 0-ba
	and	(hl)			; aktv billenty bitjnek trlse (gy azt jelzi, hogy nincs mg feldolgozva a gomb)
	ld	(hl),a			; mdostott bjt visszarsa a mtrixba
	call	PG0ADR(LE644)		; adatbjt kiolvassa a floppy RAM-bl, megszaktsok tiltsa
;
	.dw	0D019h			; RATE_KEY
;
	ld	(0BE96h),a		; billenty-ismtlsi peridus idztsnek belltsa
	jr	LC575			; ugrs a gomb kdjnak kikeressre (a folyamatosan nyomott gombot j gombknt fogja rzkelni a rutin)


;
;
;	Idzt rtknek cskkentse
;	in:  HL - az egybjtos dzt cmre mutat
;	out: CY - CY=1 -> az idzt ppen lejrt
;	     ZF - ZF=1 -> az idzt rtke nulla
;
LC5D9:	ld	a,(hl)
	or	a
	ret	z			; visszatrs, ha az idzt mr korbban lenullzdott
	dec	(hl)
	ret	nz			; visszatrs, ha cskkents utn mg nem lett nulla
	scf				; CY=1 ha az idzt nulla lett
	ret


;
;
;	Lenyomott gomb (ASCII) kdjnak kikeresse
;	in:  IY - a beolvasott billentyzet mtrix 0. sorra mutat
;	out:  C - lenyomott billentyhz tartoz karakterkd
;	      E - E=0FFh - egyik gombot vagy vltbillenty+gombot folyamatosan nyomva tartjk
;	                   vagy nincs j gomb lenyomva
;
LC5E0:	res	3,(iy+006h)		; 6. sor 3. bit nullzsa (SHIFT)
	res	4,(iy+007h)		; 7. sor 4. bit nullzsa (CTRL)
	res	0,(iy+007h)		; 7. sor 0. bit nullzsa (ALT)
	res	5,(iy+006h)		; 6. sor 5. bit nullzsa (LOCK)
	ld	de,000FFh		; D=000h - ksbbi hasznlatra  E=0FFh - visszatrsi rtk
	exx
	ld	hl,0BEA4h		; HL'= feldolgozott billentyzet mtrix cme
	ld	de,0BE9Ah		; DE'=   beolvasott billentyzet mtrix cme
	ld	bc,00A00h		; B'= 10 sor lesz   C'= 000h
LC5FD:	ld	a,(de)			; billentyzet mtrix aktulis sora A reg.-be
	xor	(hl)			; vltozsok keresse (amelyik gomb vltozott, ott 1 lesz)
	cpl				; amelyik gomb nem vltozott, az lesz most 1
	and	(hl)			; csak a vltozatlan llapot (folyamatosan nyomva tartott) gombok megtartsa
	ld	(hl),a			; mdostott rtk visszarsa
	inc	de			; kvetkez sor a beolvasott mtrixban
	inc	hl			; kvetkez sor a feldolgozott mtrixban
	or	c
	ld	c,a			; vltozatlan oszlopok gyjtse C'-ben
	djnz	LC5FD			; ismtls az sszes sorra
	ld	a,(0BE93h)		; A reg.= vltbillentyk llapota
	add	a,0FFh			; A reg. - 1
	sbc	a,a			; A reg.=000h (ha nem volt vlt) vagy 0FFh (ha volt vltbillenty)
	and	c			; vltbillenty-llapot ssze-S-else a folyamatosan nyomott gomb jelzsvel
	exx
	ret	nz			; visszatrs, ha volt vltbillenty s valamelyik gombot folyamatosan nyomva tartottk
	ld	e,00Ah			; E= 10 - ismt tz sort vizsgl, de most visszafele
	exx
LC614:	dec	de			; sormutatk cskkentse
	dec	hl
	exx
	dec	e			; szmll cskkentse
	ret	m			; visszatrs ha E= 0FFh -> nem volt jonnan lenyomott gomb
	exx
	ld	a,(de)			; visszafel haladva az aktulis billentyzet sor A reg.-be
	xor	(hl)			; ppen lenyomott gombok keresse
	jr	z,LC614			; ugrs a kvetkez sor vizsglatra, ha nincs jonnan lenyomott gomb
	ld	b,a			; j gomb sora B-be
	neg				; A reg.= 0 - A reg.
	and	b			; a legkisebb biten lv lenyomott gomb megtartsa
	ld	b,a
	xor	(hl)
	ld	(hl),a			; az j gomb bitjnek trolsa a feldolgozottsgot jelz mtrixban
	ld	a,b
	ld	(0BE97h),hl		; cm mentse
	ld	(0BE99h),a		; gomb bit mentse
	ld	a,050h			; A reg.= 80 (8 bit x 10 sor)
LC62E:	sub	00Ah			; annyiszor kivon 10-et, ahnyadik biten van az aktv billenty
	srl	b
	jr	nc,LC62E		; ismtls amg az aktv billenty bitje ki nem lp
	exx
	add	a,e			; a billenty mtrix-pozcjnak kialaktsa
	ld	e,a			; mtrixpozci E-be (billentyk szmozsa a mtrixban fentrl lefel s balrl jobbra)
	ld	a,(0BE93h)		; A reg.= vltbillentyk llapota
	ld	b,a			; vltbillentyk llapota B-be
	call	PG0ADR(LE644)		; adatbjt kiolvassa a floppy RAM-bl, megszaktsok tiltsa
;
	.dw	0D01Ah			; LOCK_KEY
;
	xor	b			; lenyomott vltbillentyk sszehozsa a LOCK-olt llapottal
	ld	b,a			; mdostott vltllapot B-be (pl. lockolt SHIFT + SHIFT lenyomsa kioltja egymst)
	ld	hl,LC7A9		; ALT tblzatcm HL-be
	bit	3,b
	jr	nz,LC685		; ugrs, ha ALT md van
	bit	2,b
	jr	z,LC660			; ugrs, ha nem CTRL md van
	ld	hl,LC759		; CTRL tblzatcm HL-be
	push	hl
	add	hl,de			; tblzaton belli cm szmtsa
	ld	a,(hl)			; kiolvasott rtk A reg.-be
	pop	hl
	cp	0FFh			; sszehasonlts az ESC helyn ll kddal
	jr	nz,LC685		; ugrs, ha nem CTRL-ESC
	call	PG0ADR(LE652)		; adatbjt belltsa a floppy RAM-ban, megszaktsok tiltsa
;
	.dw	0DFF4h			; STOP_FLAG msolata (-> 0FFh: CTRL-ESC-t nyomtak)
;
	ld	c,01Bh			; C= ESC karakter kdja
	ret
;
LC660:	bit	0,b			; CAPS LOCK jelzs ellenrzse
	scf
	jr	z,LC679			; ugrs, ha nincs CAPS LOCK
	ld	hl,LC6B9		; alapllapot-beli tblzatcm HL-be
	add	hl,de
	ld	a,(hl)			; kd kiolvassa A reg.-be
	cp	061h			; 'a'
	jr	c,LC679			; ugrs, ha kisebb az 'a' bet kdjnl
	cp	07Bh			; 'z' + 1
	jr	c,LC678			; ugrs, ha nem nagyobb a 'z' bet kdjnl
	cp	090h			; ''
	jr	c,LC679			; ugrs, ha kisebb az '' bet kdjnl
	cp	099h			; '' + 1
LC678:	ccf				; 'a'..'z', ''..'' esetekben CY=0
LC679:	sbc	a,a			; A reg.= 000h vagy 0FFh (CY-tl fggen)
	xor	b			; SHIFT bit invertlsa, ha CY=1 volt
	and	002h			; SHIFT bit megtartsa
	ld	hl,LC709		; SHIFT tblzatcm HL-be
	jr	z,LC685			; ugrs, ha a SHIFT bit 0 lett
	ld	hl,LC6B9		; alapllapot-beli tblzatcm HL-be
LC685:	add	hl,de
	ld	c,(hl)			; kd kiolvassa C-be
	ret


;
;
;	Vltbillentyk (CTRL/SHIFT/ALT) llapotnak lekrdezse
;	in:   A - CTRL lenyomshoz tartoz kd rtk (001h -> CAPS LOCK  vagy 004h -> CTRL vlt)
;	     IY - a billentyzet mtrix 0. sorra mutat
;	out:  A - a lenyomott vltbillenty kdja:
;	          0 - nincs  1 - CAPS LOCK  2 - SHIFT/SHIFT LOCK  4 - CTRL  8- ALT/ALT LOCK
;	     IY - megrzdik
;	     ZF - ZF=1 -> nincs lenyomva vltbillenty
;
LC688:	bit	4,(iy+007h)		; 7. sor 4. bit vizsglata (CTRL)
	ret	nz			; visszatrs, ha aktv
	ld	a,002h
	bit	3,(iy+006h)		; 6. sor 3. bit vizsglata (SHIFT)
	ret	nz			; visszatrs, ha aktv
	bit	0,(iy+007h)		; 7. sor 0. bit vizsglata (ALT)
	ld	a,008h
	ret	nz			; visszatrs, ha aktv
	xor	a			; egybknt A reg.= 0
	ret


;
;
;	Billentyzet mtrix beolvassa s trolsa
;	in:  -
;	out:  B - 000h
;	     IY - a beolvasott billentyzet mtrix 0. sorra mutat
;
LC69D:	call	PG0ADR(LE644)		; adatbjt kiolvassa a floppy RAM-bl, megszaktsok tiltsa
;
	.dw	0DFFEh			; Port3 msolata
;
	and	0F0h			; IOMEM lapozsi rtk megtartsa, als bitek nullzsa
	ld	c,a			; rtk C-be is
	ld	hl,0BE9Ah		; HL= beolvasott billentyzet mtrix trolsi cme
	push	hl
	pop	iy			; cm IY-ba is
	ld	b,00Ah			; 10 sort krdez le
LC6AD:	ld	a,c			; aktulis billentyzetsor kivlaszt rtk A reg.-be
	out	(003h),a		; sor kivlasztsa
	in	a,(058h)		; sor beolvassa
	cpl				; rtk neglsa (az aktv billentyk helyn 1 lesz)
	ld	(hl),a			; rtk trolsa a memriban
	inc	c			; kvetkez sor kivlaszt rtke
	inc	hl			; kvetkez trolsi cm
	djnz	LC6AD			; ismtls az sszes sorra
	ret


;
;
;	Billentyzet "scan" kdok tblzatai (4 x 80 bjt)
;	megj.: a billentyzet mtrix balra elforgatva, balrl jobbra a 10 sor, fentrl lefel 7.bit -> 0.bit 
;

;
;	Alap llapotbeli kdok
;
LC6B9:
	.db	034h, 037h, 072h, 075h, 066h, 06Ah, 076h, 06Dh, 02Ah, 02Ah
	.db	031h, 094h, 071h, 070h, 061h, 091h, 079h, 02Dh, 01Dh, 0FDh
	.db	092h, 093h, 040h, 096h, 03Ch, 098h, 02Ah, 020h, 01Ch, 0FCh
	.db	036h, 02Ah, 07Ah, 05Bh, 068h, 00Dh, 06Eh, 02Ah, 0E9h, 0F9h
	.db	030h, 097h, 03Bh, 095h, 05Ch, 090h, 02Ah, 01Bh, 0E8h, 0F8h
	.db	032h, 039h, 077h, 06Fh, 073h, 06Ch, 078h, 02Eh, 01Fh, 0FFh
	.db	033h, 038h, 065h, 069h, 064h, 06Bh, 063h, 02Ch, 01Eh, 0FEh
	.db	035h, 05Eh, 074h, 05Dh, 067h, 008h, 062h, 02Ah, 0ECh, 043h

;
;	SHIFT lenyomsakori kdok
;
LC709:
	.db	021h, 03Dh, 052h, 055h, 046h, 04Ah, 056h, 04Dh, 02Ah, 02Ah
	.db	027h, 084h, 051h, 050h, 041h, 081h, 059h, 05Fh, 0E5h, 0F5h
	.db	082h, 083h, 060h, 086h, 03Eh, 088h, 02Ah, 020h, 0E4h, 0F4h
	.db	02Fh, 023h, 05Ah, 07Bh, 048h, 00Dh, 04Eh, 02Ah, 0E9h, 0F9h
	.db	026h, 087h, 024h, 085h, 07Ch, 080h, 02Ah, 01Bh, 0E8h, 0F8h
	.db	022h, 029h, 057h, 04Fh, 053h, 04Ch, 058h, 03Ah, 0E7h, 0F7h
	.db	02Bh, 028h, 045h, 049h, 044h, 04Bh, 043h, 03Fh, 0E6h, 0F6h
	.db	025h, 07Eh, 054h, 07Dh, 047h, 0EFh, 042h, 02Ah, 0EEh, 049h

;
;	CTRL lenyomsakori kdok
;
LC759:
	.db	08Bh, 09Ch, 012h, 015h, 006h, 00Ah, 016h, 00Dh, 02Ah, 02Ah
	.db	099h, 0DCh, 011h, 010h, 001h, 0D9h, 019h, 01Fh, 0E1h, 0F1h
	.db	0DAh, 0DBh, 000h, 0DEh, 03Ch, 098h, 02Ah, 009h, 0E0h, 0F0h
	.db	08Ch, 08Eh, 01Ah, 01Bh, 008h, 00Dh, 00Eh, 02Ah, 0E9h, 0F9h
	.db	089h, 0DFh, 03Bh, 0DDh, 01Ch, 0CFh, 02Ah, 0FFh, 0E8h, 0F8h
	.db	08Ah, 09Dh, 017h, 00Fh, 013h, 00Ch, 018h, 02Eh, 0E3h, 0F3h
	.db	09Ah, 08Dh, 005h, 009h, 004h, 00Bh, 003h, 02Ch, 0E2h, 0F2h
	.db	09Bh, 01Eh, 014h, 01Dh, 007h, 07Fh, 002h, 02Ah, 0EDh, 053h

;
;	ALT lenyomsakori kdok
;
LC7A9:
	.db	0A4h, 0A7h, 0C2h, 0C5h, 0B6h, 0BAh, 0C6h, 0BDh, 02Ah, 02Ah
	.db	0A1h, 0D4h, 0C1h, 0C0h, 0B1h, 0D1h, 0C9h, 0ADh, 01Dh, 0FDh
	.db	0D2h, 0D3h, 0B0h, 0D6h, 0ACh, 0D8h, 02Ah, 020h, 01Ch, 0FCh
	.db	0A6h, 0AAh, 0CAh, 0CBh, 0B8h, 00Dh, 0BEh, 02Ah, 0E9h, 0F9h
	.db	0A0h, 0D7h, 0ABh, 0D5h, 0CCh, 0D0h, 02Ah, 01Bh, 0E8h, 0F8h
	.db	0A2h, 0A9h, 0C7h, 0BFh, 0C3h, 0BCh, 0C8h, 0AEh, 01Fh, 0FFh
	.db	0A3h, 0A8h, 0B5h, 0B9h, 0B4h, 0BBh, 0B3h, 0AFh, 01Eh, 0FEh
	.db	0A5h, 0CEh, 0C4h, 0CDh, 0B7h, 008h, 0B2h, 02Ah, 0ECh, 04Ch




;
;
;	Soros input/output UPM funkci vgrehajtsa
;	in:   A - A=0FFh -> output  A=000h -> input
;	      C - kldend karakter (ha output)
;	out:  A - hibakd
;	      C - vett karakter (ha input)
;
LC7F9:	or	a			; tviteli irny ellenrzse
	jr	z,LC81C			; ugrs, ha input
	ld	h,c			; kldend adat H-ba
	call	LC891			; vrakozs a soros porti csatol szabad llapotra
	ret	nc			; visszatrs, ha nincs csatol vagy CTRL-ESC-t nyomtak
	call	PG0ADR(LE644)		; adatbjt kiolvassa a floppy RAM-bl, megszaktsok tiltsa
;
	.dw	0D015h			; SER_OK
;
	or	a
	call	nz,LC8D7		; soros port inicializlsa, ha a HW-t ellltottk ms funkcik
	ld	a,005h			; A reg.= SEND_BREAK (az adatvonal L lesz a karakter kikldse eltt s utn) s TxEn
	out	(c),a			; USART parancs belltsa
LC80E:	call	LC8A3			; CTRL-ESC megnyomsnak vizsglata
	ret	nz			; visszatrs ha CTRL-ESC-t nyomtak
	in	a,(c)			; USART llapot beolvassa
	rrca				; 0.(TxRDY) bit CY-be
	jr	nc,LC80E		; vrakozs, amg az USART nem ksz az adatkldsre
	dec	c			; C az USART adatregiszterre mutat
	out	(c),h			; adat kikldse
	xor	a			; hibakd trlse
	ret


;
;
;	Soros input
;	in:   -
;	out:  A - hibakd
;	      C - vett karakter
;
LC81C:	call	LC883			; soros porti csatol I/O cmnek belltsa
	ret	nc			; visszatrs, ha nincs sorosporti csatol
	call	PG0ADR(LE644)		; adatbjt kiolvassa a floppy RAM-bl, megszaktsok tiltsa
;
	.dw	0D015h			; SER_OK
;
	or	a
	call	nz,LC8D7		; soros port inicializlsa, ha a HW-t ellltottk ms funkcik
	in	a,(c)			; USART llapot beolvassa
	rrca
	rrca				; 1.(RxRDY) bit CY-be
	jr	c,LC863			; ugrs, ha az USART tartalmaz vett adatot
	di
	call	PG0ADR(LE644)		; adatbjt kiolvassa a floppy RAM-bl, megszaktsok tiltsa
;
	.dw	0DFFEh			; floppy krtyacsatlakoz sorszma
;
	and	0F0h			; IOMEM lapozs megtartsa
	or	007h			; a 7. billentyzetsor kivlasztsa
	out	(003h),a		; port belltsa
	ld	a,025h			; A reg.= RTS (ksz a vtelre) s SEND_BREAK s TxEn
	out	(c),a			; USART parancs belltsa
LC83F:	in	a,(058h)		; billentyzet adat beolvassa
	and	018h			; CTRL s ESC vizsglata
	jr	nz,LC859		; ugrs, ha nincsenek egyszerre lenyomva
	ld	a,005h			; A reg.= SEND_BREAK s TxEn (nem ksz a vtelre)
	out	(c),a			; USART parancs belltsa
	ld	hl,0BEABh
	set	3,(hl)			; ESC gombnak megfelel bit belltsa a mdostott billentyzet mtrixban
	ld	a,0FFh
	call	PG0ADR(LE652)		; adatbjt belltsa a floppy RAM-ban, megszaktsok tiltsa
;
	.dw	0DFF4h			; STOP_FLAG msolata
;
	ei
	ld	a,0F5h			; A reg.= hibakd: .STOP (CTRL-ESC-t nyomtak)
	ret
;
LC859:	in	a,(c)			; USART llapot beolvassa
	rrca
	rrca				; 1.(RxRDY) bit CY-be
	jr	nc,LC83F		; ugrs, ha az USART mg nem vett adatot
	ld	a,005h			; A reg.= SEND_BREAK s TxEn (nem ksz a vtelre)
	out	(c),a			; USART parancs belltsa
LC863:	in	a,(c)			; USART llapot A reg.-be
	dec	c
	in	h,(c)			; vett adat H-ba
	ei
	and	038h			; FE s OE s PE hiba-jelzbitek vizsglata
	jr	z,LC881			; ugrs, ha nem trtnt hiba
	ld	b,a			; hibajelzk B-be
	inc	c			; C az USART parancsregiszter cmre mutat
	ld	a,011h			; A reg.= ERROR_RESET (hibajelzk trlse) s TxEN
	out	(c),a			; USART parancs belltsa
	ld	a,0F4h			; hibakd: .PARITY (parits hiba a soros vonalon)
	bit	3,b
	jr	nz,LC881		; ugrs, ha a PE bit aktv volt
	ld	a,0F2h			; hibakd: .OVERRUN (karakterveszts a soros vonalon)
	bit	4,b
	jr	nz,LC881		; ugrs, ha az OE bit aktv volt
	ld	a,0F3h			; hibakd: .FRAME (formtumhiba a soros vonalon)
LC881:	ld	c,h			; vett karakter C-be
	ret


;
;
;	Soros porti csatol I/O cmnek belltsa
;	in:  -
;	out:  A - hibakd (0F1h), ha CY=0
;	      C - I/O bziscm + 1
;	     CY - CY=0 -> nincs rvnyes sorosporti csatol
;
LC883:	call	LC8A3			; CTRL-ESC megnyomsnak vizsglata
	ret	nz			; visszatrs, ha volt CTRL-ESC
	ld	a,(0BEAEh)		; A reg.= soros porti csatol I/O bziscme + 1
	ld	c,a			; regisztercm C-be
	cp	050h
	ret	c			; visszatrs, ha rvnyes az I/O bziscm
	ld	a,0F1h			; A reg.= hibakd: .NCARD (nincs soros vonali krtya)
	ret


;
;
;	Vrakozs a soros porti csatol szabad llapotra
;	(az ellenlloms vtelre ksz s nincs rs folyamatban)
;	in:  -
;	out:  A - hibakd
;	      C - soros port I/O bziscm + 1
;	     CY - CY=1 a csatol szabad llapotban van
;
LC891:	call	LC883			; soros porti csatol I/O cmnek belltsa
	ret	nc			; visszatrs, ha nincs sorosporti csatol
LC895:	in	a,(c)			; USART llapotregiszter beolvassa
	and	081h			; 7.(DSR) s 0.(TxRDY) bit maszkolsa
	cp	081h			; bitek vizsglata
	ccf				; CY= 1 ha mindkt bit 1-es
	ret	c			; visszatrs, ha nincs vtel s nincs ads folyamatban
	call	LC8A3			; CTRL-ESC megnyomsnak vizsglata
	jr	z,LC895			; ismtls, ha nem nyomtak CTRL-ESC-t
	ret


;
;
;	CTRL-ESC megnyomsnak vizsglata
;	in:   -
;	out:  A - hibakd: A=000h -> nem nyomtak CTRL-ESC-t
;	                   A=0F5h -> CTRL-ESC-t nyomtak
;	     ZF - ZF=1 -> nem nyomtak CTRL-ESC-t
;
LC8A3:	call	PG0ADR(LE644)		; adatbjt kiolvassa a floppy RAM-bl, megszaktsok tiltsa
;
	.dw	0DFF4h			; STOP_FLAG msolata
;
	ei
	and	0F5h			; vltoz ellenrzse, egyben hibakd belltsa A reg.-be (0F5h)
	ret


;
;
;	VT-DOS rendszer HW inicializlsa
;
LC8AC:	call	LC479			; kperny inicializlsa
	call	LC52E			; billentyzet idztsi paramtereinek alaphelyzetbe lltsa
	ld	a,004h
	call	PG0ADR(LE652)		; adatbjt belltsa a floppy RAM-ban, megszaktsok tiltsa
;
	.dw	0D017h			; BAUD
;
	ld	a,0EEh
	call	PG0ADR(LE652)		; adatbjt belltsa a floppy RAM-ban, megszaktsok tiltsa
;
	.dw	0D016h			; FORM
;
	in	a,(05Ah)		; krtyaazonost port beolvassa A reg.-be
	ld	bc,00411h		; B= 4 -> ennyi csatolhelyet ellenriz  C= csatolkrtya port bziscme + 1
LC8C5:	ld	e,a
	and	003h			; soros vonali csatol keresse
	jr	z,LC8D3			; ugrs, ha megtallta
	ld	a,c
	add	a,010h			; port bziscm nvelse a kvetkez csatlakozhoz
	ld	c,a
	ld	a,e			; azonostbjt jobbralptetse 2-vel
	rrca
	rrca
	djnz	LC8C5			; ismtls az sszes csatlakozhelyre
LC8D3:	ld	a,c
	ld	(0BEAEh),a		; portcm mentse
;
;
;	Soros port inicializlsa
;
LC8D7:	push	bc
	push	hl
	call	PG0ADR(LE644)		; adatbjt kiolvassa a floppy RAM-bl, megszaktsok tiltsa
;
	.dw	0DFFCh			; VIDMODE (Port6 msolata)
;
	and	0C3h			; hang amplitud trlse
	call	PG0ADR(LE652)		; adatbjt belltsa a floppy RAM-ban, megszaktsok tiltsa
;
	.dw	0DFFCh
;
	out	(006h),a		; Port6 tnyleges belltsa
	call	PG0ADR(LE644)		; adatbjt kiolvassa a floppy RAM-bl, megszaktsok tiltsa
;
	.dw	0D017h			; BAUD
;
	cp	009h
	jr	c,LC8F7			; ugrs, ha 9-nl kisebb a BAUD rtke
	ld	a,008h			; BAUD belltsa 8-ra (19.2 kbit/s)
	call	PG0ADR(LE652)		; adatbjt belltsa a floppy RAM-ban, megszaktsok tiltsa
;
	.dw	0D017h
;
LC8F7:	ld	l,a			; BAUD rtk HL-be
	ld	h,000h
	add	hl,hl
	ld	de,LC946		; DE= tblzat kezdcme
	add	hl,de			; HL a BAUD-nak megfelel elemre mutat
	ld	e,(hl)			; pitch rtk beolvassa DE-be
	inc	hl
	ld	d,(hl)
	call	PG0ADR(LE644)		; adatbjt kiolvassa a floppy RAM-bl, megszaktsok tiltsa
;
	.dw	0DFFDh			; Port5 msolata
;
	and	0C0h			; vltoz fels 2 bitjnek meghagysa
	or	d			; pitch fels 4 bit bersa az als bitekre
	call	PG0ADR(LE652)		; adatbjt belltsa a floppy RAM-ban, megszaktsok tiltsa
;
	.dw	0DFFDh
;
	out	(005h),a		; Port5 tnyleges belltsa: pitch fels 4 bit
	ld	a,e
	out	(004h),a		; Port4 belltsa: pitch als 8 bit
	call	PG0ADR(LE644)		; adatbjt kiolvassa a floppy RAM-bl, megszaktsok tiltsa
;
	.dw	0D016h			; FORM
;
	and	0B4h
	or	04Ah
	ld	h,a			; mdostott FORM H-ba
	ld	bc,00411h		; B= 4 -> ennyi csatolhelyet ellenriz  C= csatolkrtya port bziscme + 1
	ld	de,04003h		; D= 040h   E= maszk a krtyaazonosthoz
	in	a,(05Ah)		; krtyaazonost port beolvassa A reg.-be
LC926:	ld	l,a
	and	e
	jr	nz,LC934		; ugrs, ha nem soros porti krtya
	out	(c),a			; 3-szor 000h r az USART parancsregiszterbe
	out	(c),a
	out	(c),a
	out	(c),d			; bels reset kiadsa
	out	(c),h			; zemmd-kivlaszts
LC934:	ld	a,010h			; port bziscm nvelse a kvetkez csatlakozhoz
	add	a,c
	ld	c,a
	ld	a,l			; azonostbjt jobbralptetse 2-vel
	rrca
	rrca
	djnz	LC926			; ismtls az sszes csatlakozhelyre
	xor	a
	call	PG0ADR(LE652)		; adatbjt belltsa a floppy RAM-ban, megszaktsok tiltsa
;
	.dw	0D015h			; SER_OK
;
	pop	hl
	pop	bc
	ret


;
;
;	Pitch rtkek a soros port inicializlshoz
;
LC946:
	.dw	01C88h			;   110 baud
	.dw	01D75h			;   150 baud
	.dw	01EBAh			;   300 baud
	.dw	01F5Dh			;   600 baud
	.dw	01FAFh			;  1200 baud
	.dw	01FD7h			;  2400 baud
	.dw	01FECh			;  4800 baud
	.dw	01FF6h			;  9600 baud
	.dw	01FFBh			; 19200 baud


;
;
;	Listz (prhuzamos) output funkci vgrehajtsa (LIST)
;	in:   C - kikldend adatbjt
;	out:  A - hibakd (0)
;	     ZF - ZF=1 -> nem volt hiba
;
LC958:	call	PG0ADR(LE644)		; adatbjt kiolvassa a floppy RAM-bl, megszaktsok tiltsa
;
	.dw	0DFF4h			; STOP_FLAG msolata
;
	and	0F5h			; vltoz rtknek vizsglata
	ei
	ret	nz			; visszatrs, ha CTRL-ESC-t nyomtak
	in	a,(059h)		; nyomtat ACK jelnek beolvassa
	rlca				; ACK bit CY-be
	jr	nc,LC958		; vrakozs, amg a nyomtat nem kpes fogadni az adatot
	di
	ld	a,c			; adat A reg.-be
	out	(001h),a		; adat kirsa a nyomtatportra
	call	PG0ADR(LE644)		; adatbjt kiolvassa a floppy RAM-bl, megszaktsok tiltsa
;
	.dw	0DFFCh			; Port6 msolata
;
	and	07Fh			; 7. bit nullzsa
	out	(006h),a		; STROBE jel kirsa a portra
	or	080h			; 7. bit 1-be lltsa
	out	(006h),a		; STROBE jel trlse
	ei
	xor	a
	ret


;
;	Karaktermtrixok (128 * 10 bjt)
;
LC97A:
;
	.db	000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h, 000h
	.db	000h, 018h, 018h, 018h, 018h, 018h, 000h, 018h, 000h, 000h
	.db	000h, 036h, 036h, 036h, 000h, 000h, 000h, 000h, 000h, 000h
	.db	000h, 036h, 036h, 07Fh, 036h, 07Fh, 036h, 036h, 000h, 000h
	.db	000h, 018h, 03Eh, 058h, 03Ch, 01Ah, 07Ch, 018h, 000h, 000h
	.db	000h, 060h, 066h, 00Ch, 018h, 030h, 066h, 006h, 000h, 000h
	.db	000h, 010h, 028h, 028h, 030h, 054h, 048h, 034h, 000h, 000h
	.db	000h, 018h, 018h, 030h, 000h, 000h, 000h, 000h, 000h, 000h
	.db	000h, 00Ch, 018h, 030h, 030h, 030h, 018h, 00Ch, 000h, 000h
	.db	000h, 030h, 018h, 00Ch, 00Ch, 00Ch, 018h, 030h, 000h, 000h
	.db	000h, 000h, 010h, 054h, 038h, 038h, 054h, 010h, 000h, 000h
	.db	000h, 000h, 018h, 018h, 07Eh, 018h, 018h, 000h, 000h, 000h
	.db	000h, 000h, 000h, 000h, 000h, 000h, 018h, 018h, 030h, 000h
	.db	000h, 000h, 000h, 000h, 07Ch, 07Ch, 000h, 000h, 000h, 000h
	.db	000h, 000h, 000h, 000h, 000h, 000h, 018h, 018h, 000h, 000h
	.db	000h, 000h, 006h, 00Ch, 018h, 030h, 060h, 000h, 000h, 000h
	.db	000h, 03Ch, 066h, 06Eh, 07Eh, 076h, 066h, 03Ch, 000h, 000h
	.db	000h, 018h, 038h, 018h, 018h, 018h, 018h, 018h, 000h, 000h
	.db	000h, 03Ch, 066h, 006h, 01Ch, 030h, 060h, 07Eh, 000h, 000h
	.db	000h, 07Eh, 006h, 00Ch, 01Ch, 006h, 046h, 03Ch, 000h, 000h
	.db	000h, 00Ch, 01Ch, 02Ch, 04Ch, 07Eh, 00Ch, 00Ch, 000h, 000h
	.db	000h, 07Eh, 060h, 07Ch, 006h, 006h, 046h, 03Ch, 000h, 000h
	.db	000h, 03Ch, 060h, 060h, 07Ch, 066h, 066h, 03Ch, 000h, 000h
	.db	000h, 07Eh, 006h, 00Ch, 018h, 030h, 060h, 060h, 000h, 000h
	.db	000h, 03Ch, 066h, 066h, 03Ch, 066h, 066h, 03Ch, 000h, 000h
	.db	000h, 03Ch, 066h, 066h, 03Eh, 006h, 00Ch, 038h, 000h, 000h
	.db	000h, 000h, 000h, 018h, 018h, 000h, 018h, 018h, 000h, 000h
	.db	000h, 000h, 000h, 018h, 018h, 000h, 018h, 018h, 030h, 000h
	.db	000h, 006h, 00Ch, 018h, 030h, 018h, 00Ch, 006h, 000h, 000h
	.db	000h, 000h, 000h, 07Ch, 000h, 07Ch, 000h, 000h, 000h, 000h
	.db	000h, 030h, 018h, 00Ch, 006h, 00Ch, 018h, 030h, 000h, 000h
	.db	000h, 03Ch, 066h, 006h, 00Ch, 018h, 000h, 018h, 000h, 000h
	.db	000h, 03Eh, 063h, 067h, 06Bh, 06Fh, 060h, 03Ch, 000h, 000h
	.db	000h, 01Ch, 03Eh, 063h, 063h, 07Fh, 063h, 063h, 000h, 000h
	.db	000h, 07Eh, 063h, 063h, 07Eh, 063h, 063h, 07Eh, 000h, 000h
	.db	000h, 03Eh, 063h, 060h, 060h, 060h, 063h, 03Eh, 000h, 000h
	.db	000h, 07Eh, 033h, 033h, 033h, 033h, 033h, 07Eh, 000h, 000h
	.db	000h, 07Eh, 060h, 060h, 07Ch, 060h, 060h, 07Eh, 000h, 000h
	.db	000h, 07Eh, 060h, 060h, 07Ch, 060h, 060h, 060h, 000h, 000h
	.db	000h, 03Eh, 063h, 060h, 060h, 067h, 063h, 03Eh, 000h, 000h
	.db	000h, 063h, 063h, 063h, 07Fh, 063h, 063h, 063h, 000h, 000h
	.db	000h, 03Ch, 018h, 018h, 018h, 018h, 018h, 03Ch, 000h, 000h
	.db	000h, 006h, 006h, 006h, 006h, 066h, 066h, 03Ch, 000h, 000h
	.db	000h, 063h, 066h, 06Ch, 078h, 06Ch, 066h, 063h, 000h, 000h
	.db	000h, 060h, 060h, 060h, 060h, 060h, 060h, 07Eh, 000h, 000h
	.db	000h, 063h, 077h, 06Bh, 063h, 063h, 063h, 063h, 000h, 000h
	.db	000h, 066h, 066h, 076h, 06Eh, 066h, 066h, 066h, 000h, 000h
	.db	000h, 03Eh, 063h, 063h, 063h, 063h, 063h, 03Eh, 000h, 000h
	.db	000h, 07Eh, 063h, 063h, 07Eh, 060h, 060h, 060h, 000h, 000h
	.db	000h, 03Eh, 063h, 063h, 063h, 06Bh, 067h, 03Eh, 001h, 000h
	.db	000h, 07Eh, 063h, 063h, 07Eh, 06Ch, 066h, 063h, 000h, 000h
	.db	000h, 03Eh, 063h, 060h, 03Eh, 003h, 063h, 03Eh, 000h, 000h
	.db	000h, 07Eh, 05Ah, 018h, 018h, 018h, 018h, 018h, 000h, 000h
	.db	000h, 063h, 063h, 063h, 063h, 063h, 063h, 03Eh, 000h, 000h
	.db	000h, 063h, 063h, 063h, 063h, 036h, 01Ch, 008h, 000h, 000h
	.db	000h, 063h, 063h, 063h, 06Bh, 06Bh, 03Eh, 014h, 000h, 000h
	.db	000h, 066h, 066h, 03Ch, 018h, 03Ch, 066h, 066h, 000h, 000h
	.db	000h, 066h, 066h, 03Ch, 018h, 018h, 018h, 018h, 000h, 000h
	.db	000h, 07Eh, 006h, 00Ch, 018h, 030h, 060h, 07Eh, 000h, 000h
	.db	000h, 03Ch, 030h, 030h, 030h, 030h, 030h, 03Ch, 000h, 000h
	.db	000h, 000h, 060h, 030h, 018h, 00Ch, 006h, 000h, 000h, 000h
	.db	000h, 03Ch, 00Ch, 00Ch, 00Ch, 00Ch, 00Ch, 03Ch, 000h, 000h
	.db	000h, 018h, 03Ch, 066h, 042h, 000h, 000h, 000h, 000h, 000h
	.db	000h, 000h, 000h, 000h, 000h, 000h, 000h, 07Eh, 000h, 000h
	.db	000h, 030h, 030h, 018h, 000h, 000h, 000h, 000h, 000h, 000h
	.db	000h, 000h, 000h, 03Ch, 006h, 03Eh, 066h, 03Eh, 000h, 000h
	.db	000h, 060h, 060h, 07Ch, 066h, 066h, 066h, 07Ch, 000h, 000h
	.db	000h, 000h, 000h, 01Eh, 030h, 030h, 030h, 01Eh, 000h, 000h
	.db	000h, 006h, 006h, 03Eh, 066h, 066h, 066h, 03Eh, 000h, 000h
	.db	000h, 000h, 000h, 03Ch, 066h, 07Eh, 060h, 03Ch, 000h, 000h
	.db	000h, 00Ch, 018h, 018h, 03Ch, 018h, 018h, 018h, 000h, 000h
	.db	000h, 000h, 000h, 03Eh, 066h, 066h, 066h, 03Eh, 006h, 03Ch
	.db	000h, 060h, 060h, 07Ch, 066h, 066h, 066h, 066h, 000h, 000h
	.db	000h, 018h, 000h, 038h, 018h, 018h, 018h, 03Ch, 000h, 000h
	.db	000h, 018h, 000h, 038h, 018h, 018h, 018h, 018h, 018h, 070h
	.db	000h, 060h, 060h, 066h, 06Ch, 078h, 06Ch, 066h, 000h, 000h
	.db	000h, 018h, 018h, 018h, 018h, 018h, 018h, 018h, 000h, 000h
	.db	000h, 000h, 000h, 076h, 06Bh, 06Bh, 06Bh, 06Bh, 000h, 000h
	.db	000h, 000h, 000h, 07Ch, 066h, 066h, 066h, 066h, 000h, 000h
	.db	000h, 000h, 000h, 03Ch, 066h, 066h, 066h, 03Ch, 000h, 000h
	.db	000h, 000h, 000h, 07Ch, 066h, 066h, 066h, 07Ch, 060h, 060h
	.db	000h, 000h, 000h, 03Eh, 066h, 066h, 066h, 03Eh, 006h, 006h
	.db	000h, 000h, 000h, 036h, 038h, 030h, 030h, 030h, 000h, 000h
	.db	000h, 000h, 000h, 01Eh, 030h, 01Ch, 006h, 03Ch, 000h, 000h
	.db	000h, 018h, 018h, 03Ch, 018h, 018h, 018h, 00Ch, 000h, 000h
	.db	000h, 000h, 000h, 066h, 066h, 066h, 066h, 03Eh, 000h, 000h
	.db	000h, 000h, 000h, 066h, 066h, 066h, 03Ch, 018h, 000h, 000h
	.db	000h, 000h, 000h, 063h, 063h, 06Bh, 03Eh, 014h, 000h, 000h
	.db	000h, 000h, 000h, 066h, 03Ch, 018h, 03Ch, 066h, 000h, 000h
	.db	000h, 000h, 000h, 066h, 066h, 066h, 066h, 03Eh, 006h, 03Ch
	.db	000h, 000h, 000h, 07Eh, 00Ch, 018h, 030h, 07Eh, 000h, 000h
	.db	000h, 00Eh, 018h, 018h, 070h, 018h, 018h, 00Eh, 000h, 000h
	.db	000h, 018h, 018h, 018h, 000h, 018h, 018h, 018h, 000h, 000h
	.db	000h, 070h, 018h, 018h, 00Eh, 018h, 018h, 070h, 000h, 000h
	.db	000h, 000h, 000h, 033h, 06Bh, 066h, 000h, 000h, 000h, 000h
	.db	000h, 07Eh, 07Eh, 07Eh, 07Eh, 07Eh, 07Eh, 07Eh, 000h, 000h
	.db	008h, 008h, 03Eh, 06Bh, 063h, 07Fh, 063h, 063h, 000h, 000h
	.db	008h, 008h, 07Eh, 068h, 060h, 07Ch, 060h, 07Eh, 000h, 000h
	.db	008h, 008h, 03Ch, 018h, 018h, 018h, 018h, 03Ch, 000h, 000h
	.db	008h, 008h, 03Eh, 06Bh, 063h, 063h, 063h, 03Eh, 000h, 000h
	.db	014h, 000h, 03Eh, 063h, 063h, 063h, 063h, 03Eh, 000h, 000h
	.db	014h, 014h, 03Eh, 063h, 063h, 063h, 063h, 03Eh, 000h, 000h
	.db	008h, 008h, 06Bh, 063h, 063h, 063h, 063h, 03Eh, 000h, 000h
	.db	014h, 000h, 063h, 063h, 063h, 063h, 063h, 03Eh, 000h, 000h
	.db	014h, 014h, 077h, 063h, 063h, 063h, 063h, 03Eh, 000h, 000h
	.db	000h, 000h, 000h, 000h, 01Fh, 01Fh, 018h, 018h, 018h, 018h
	.db	018h, 018h, 018h, 018h, 01Fh, 01Fh, 000h, 000h, 000h, 000h
	.db	018h, 018h, 018h, 018h, 018h, 018h, 018h, 018h, 018h, 018h
	.db	018h, 018h, 018h, 018h, 01Fh, 01Fh, 018h, 018h, 018h, 018h
	.db	000h, 000h, 000h, 000h, 0FFh, 0FFh, 018h, 018h, 018h, 018h
	.db	018h, 018h, 018h, 018h, 0FFh, 0FFh, 018h, 018h, 018h, 018h
	.db	0FFh, 0E7h, 0C3h, 099h, 099h, 081h, 099h, 099h, 0FFh, 0FFh
	.db	008h, 008h, 008h, 03Ch, 006h, 03Eh, 066h, 03Eh, 000h, 000h
	.db	008h, 008h, 008h, 03Ch, 066h, 07Eh, 060h, 03Ch, 000h, 000h
	.db	008h, 008h, 000h, 038h, 018h, 018h, 018h, 03Ch, 000h, 000h
	.db	008h, 008h, 008h, 03Ch, 066h, 066h, 066h, 03Ch, 000h, 000h
	.db	000h, 024h, 000h, 03Ch, 066h, 066h, 066h, 03Ch, 000h, 000h
	.db	024h, 024h, 000h, 03Ch, 066h, 066h, 066h, 03Ch, 000h, 000h
	.db	008h, 008h, 008h, 066h, 066h, 066h, 066h, 03Eh, 000h, 000h
	.db	000h, 024h, 000h, 066h, 066h, 066h, 066h, 03Eh, 000h, 000h
	.db	024h, 024h, 000h, 066h, 066h, 066h, 066h, 03Eh, 000h, 000h
	.db	000h, 000h, 000h, 000h, 0F8h, 0F8h, 018h, 018h, 018h, 018h
	.db	018h, 018h, 018h, 018h, 0F8h, 0F8h, 000h, 000h, 000h, 000h
	.db	000h, 000h, 000h, 000h, 0FFh, 0FFh, 000h, 000h, 000h, 000h
	.db	018h, 018h, 018h, 018h, 0F8h, 0F8h, 018h, 018h, 018h, 018h
	.db	018h, 018h, 018h, 018h, 0FFh, 0FFh, 000h, 000h, 000h, 000h
	.db	0FFh, 0C3h, 099h, 09Fh, 09Fh, 09Fh, 099h, 0C3h, 0FFh, 0FFh
	.db	0FFh, 0C3h, 099h, 09Fh, 0C3h, 0F9h, 099h, 0C3h, 0FFh, 0FFh

LCE7A:
;
; ---- Eddig tartanak a karaktermtrixok, egyben az UPM I/O rutinok vge ----
;




;
;
;	A kvetkez programrszek mr mindig az U3 RAM-ban futnak
;

;
;
;	CP/M verziszm s BDOS belpsi vektor a COMMAND.COM indtshoz
;
;	megj.: mindig 256 bjtos laphatron kell elhelyezkednie, a BDOS
;	       ugrsi utastsnak pedig a xx06h cmen; ez a kezdeti TPA
;	       terlet legfels hatra
;

	.org	0E100h

	.db	000h
	.db	016h			; CP/M verziszm: 1.6 (decimlisan 22, lehet hogy bug?)
	.db	000h
	.db	000h
	.db	000h
	.db	000h
;
LE106:	jp	LEE62			; BDOS belpsi vektor a COMMAND.COM indulshoz


;
; ---- Veremterlet az U3 RAM-ban ----
;
	
	.org	0E200h

;
;
;	UIOS ugrsi tbla
;	(UPM kompatibilits miatt, 17 funkci, ld. pdf 72. oldal)
;
;
LE200:	jp	LE410			; WBOOT  - meleg indts
LE203:	jp	LE410			; WBOOT  - meleg indts
LE206:	jp	LE23B			; CONST  - konzol llapot
LE209:	jp	LE260			; CONIN  - konzol input
LE20C:	jp	LE265			; CONOUT - konzol output
LE20F:	jp	LE24D			; LIST   - listz (prhuzamos nyomtat) output
LE212:	jp	LE256			; PUNCH  - lyukaszt (soros) output
LE215:	jp	LE25B			; READER - olvas (soros) input
	jp	LE233			; RETURN   (UPM-ben: home)
	jp	LE233			; RETURN   (UPM-ben: diszk kivlts)
	jp	LE233			; RETURN   (UPM-ben: plyacmzs)
	jp	LE233			; RETURN   (UPM-ben: szektorcmzs)
	jp	LE233			; RETURN   (UPM-ben: DMA cm)
	jp	LE233			; RETURN   (UPM-ben: szektor-olvass)
	jp	LE233			; RETURN   (UPM-ben: szektor-rs)
	jp	LE239			; LSTST  - lista llapot
	jp	LE233			; RETURN   (UPM-ben: szektorszm-konverzi)
;

;
;
;	Nem megvalstott funkcik visszatrsi rutinja (RETURN funkci)
;
LE233:	ld	hl,00000h
	ld	a,0FFh
	ret

;
;
;	Lista llapot funkci (LSTST)
;
LE239:	xor	a
	ret

;
;
;	Konzol llapot funkci (CONST)
;	in:  -
;	out:  A - van/nincs rvnyes karakter a billentyzetrl jelzs
;
LE23B:	di
	ld	a,090h			; U0,U1,VID,U3 lapozs
	out	(002h),a
	ld	bc,(0BE90h)		; C= rvnyes billentyzet karaktert jelz flag
	ld	a,(0003Bh)		; A reg.= felhasznli lapozs
	out	(002h),a		; lapozs vissza
	ei
	ld	a,c
	or	a
	ret

;
;
;	Listz (prhuzamos nyomtat) output funkci (LIST)
;	in:   C - kikldend adatbjt
;	out:  A - hibakd
;
LE24D:	ld	hl,PG0ADR(LE2A9)	; HL= vgrehajtand rutin cme a 0. lapra lapozott U3-ban
	ld	a,(00042h)		; A reg.= tirnyts, 000h -> prhuzamos nyomtat  <>0 -> soros egysg
	ld	b,a
	jr	LE268

;
;
;	Lyukaszt (soros) output funkci (PUNCH)
;	in:   C - kldend karakter
;	out:  A - hibakd
;
LE256:	ld	hl,PG0ADR(LE2B7)	; HL= vgrehajtand rutin cme a 0. lapra lapozott U3-ban
	jr	LE268

;
;
;	Olvas (soros) input funkci (READER)
;	in:   -
;	out:  A - hibakd
;	      C - vett karakter
;
LE25B:	ld	hl,PG0ADR(LE2BB)	; HL= vgrehajtand rutin cme a 0. lapra lapozott U3-ban
	jr	LE268

;
;
;	Konzol input funkci (CONIN)
;	in:   -
;	out:  A - hibakd (000h)
;	      C - beolvasott karakter kdja
;
LE260:	ld	hl,PG0ADR(LE2B0)	; HL= vgrehajtand rutin cme a 0. lapra lapozott U3-ban
	jr	LE268

;
;
;	Konzol output funkci (CONOUT)
;	in:  C - karakterkd
;	out: -
;
LE265:	ld	hl,PG0ADR(LE2B4)	; HL= vgrehajtand rutin cme a 0. lapra lapozott U3-ban

;
;
;	UPM-es konzol I/O funkcik vgrehajtsa
;	in:  HL - a tnyleges vgrehajt rutin cme
;	out: -
;
LE268:	ld	(LE2A2 + 1),sp		; SP rtke a rutin vgn lv "LD SP,xxxx" utasts paramterbe
	ld	(LE28E + 1),hl		; vgrehajt rutin cme a "CALL xxxx" utasts paramterbe
	ld	hl,0E200h		; sajt veremterlet belltsa
	xor	a
	sbc	hl,sp			; jelenlegi verempozci ellenrzse
	jr	c,LE27A			; ugrs, ha a kijellend cm felett van
	or	h
	jr	z,LE27C			; ugrs, ha 256 bjtnl nem nagyobb a tvolsg
LE27A:	add	hl,sp			; HL ismt 0E200h
	ld	sp,hl			; veremmutat belltsa 0E200h-ra
LE27C:	di				; megszak. tilt
	ld	hl,04000h		; veremmmutat thelyezse a 0. lapra
	add	hl,sp
	ld	sp,hl
	ld	a,0B8h			; U3,U1,U2,U3 lapozs
	out	(002h),a		; memrialapozs belltsa
	jp	PG0ADR(LE289)		; ugrs a kvetkez utastsra a 0. lapon
;
LE289:	ld	a,018h			; U3,U1,VID,CART lapozs
	out	(002h),a		; memrialapozs belltsa
	ei
LE28E:	call	00000h			; megadott UPM funkci meghvsa
	di
	ld	a,0B8h			; U3,U1,U2,U3 lapozs
	out	(002h),a		; memrialapozs belltsa
	jp	LE299			; ugrs a kvetkez utastsra a 3. lapon
;
LE299:	ld	a,0B0h			; U0,U1,U2,U3 lapozs
	out	(002h),a		; memrialapozs belltsa
	ld	a,(0003Bh)		; A reg.= aktulis (felhasznli) memrialapozs
	out	(002h),a		; memrialapozs belltsa
LE2A2:	ld	sp,00000h		; veremmutat helyrelltsa (ld. rutin belpsnl)
	ei				; megszak. eng.
	ld	a,c
	or	a
	ret
;

;
;
;	Listz (prhuzamos) output funkci vgrehajtsa (LIST)
;
LE2A9:	ld	a,b
	or	a
	jp	z,LC958			; ugrs a 3. lapon lv CART-ba
	jr	LE2B7			; ugrs a lyukaszt (soros) outputra

;
;
;	Konzol input funkci vgrehajtsa (CONIN)
;
LE2B0:	xor	a
	jp	LC517			; ugrs a 3. lapon lv CART-ba

;
;
;	Konzol output funkci vgrehajtsa (CONOUT)
;
LE2B4:	jp	LC16F			; ugrs a 3. lapon lv CART-ba

;
;
;	Lyukaszt output funkci vgrehajtsa (PUNCH)
;
LE2B7:	ld	a,0FFh			; tviteli irny jelzse A reg.-ben
	jr	LE2BC			; ugrs a folytatsra

;
;
;	Olvas input funkci vgrehajtsa (READER)
;
LE2BB:	xor	a			; tviteli irny jelzse A reg.-ben
LE2BC:	jp	LC7F9			; ugrs a 3. lapon lv CART-ba


;
;
;	Floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
;	in: -
;	out: - minden regiszter megrzdik
;
LE2BF:	push	hl			; hasznland regiszterek mentse
	push	af
	ld	a,0B8h			; U3,U1,U2,U3 lapozs
	di				; megszak. tilt
	out	(002h),a		; memrialapozs belltsa
	jp	PG0ADR(LE2C9)		; ugrs a kvetkez utastsra a 0. lapon
LE2C9:	ld	hl,04000h
	add	hl,sp
	ld	sp,hl			; verem mutatt is thelyezi a 0. lapra, de lnyegben ugyanoda mutat
	ld	a,0F8h			; U3,U1,U2,EXT/IOMEM lapozs
	out	(002h),a		; memrialapozs belltsa
	ld	(0DFFFh),a		; lapozsi rtket a floppy RAM vltozjba is elmenti
	ld	a,0DEh			; interrupt vektor belltsa 0DExxh-ra (floppy RAM cm)
	ld	i,a
	ei				; megszak. eng.
	pop	af			; hasznlt regiszterek helyrelltsa
	pop	hl
	ex	(sp),hl			; HL= visszatrsi cm
	res	7,h			; visszatrsi cm a 0. lapra mutat
	res	6,h
	ex	(sp),hl			; mdostott cm vissza a verembe
	ret


;
;
;	U3 visszalltsa a 3. lapra (floppy rutin vgrehajtsa utn)
;	in: -
;	out: - minden regiszter megrzdik
;
LE2E3:	push	hl			; hasznland regiszterek mentse
	push	af
	ld	a,0B8h			; U3,U1,U2,U3 lapozs
	di
	out	(002h),a		; memrialapozs belltsa
	jp	LE2ED			; ugrs a kvetkez utastsra a 3. lapon
LE2ED:	ld	hl,0C000h
	add	hl,sp
	ld	sp,hl			; verem mutatt is thelyezi a 3. lapra, de lnyegben ugyanoda mutat
	ld	a,0B0h			; U0,U1,U2,U3 lapozs
	out	(002h),a		; memrialapozs belltsa
	ld	a,(0003Bh)		; A reg.= felhasznli memrialapozs
	out	(002h),a		; felhasznli memrialapozs belltsa
	ld	a,0FEh			; interrupt vektor belltsa 0FExxh-ra (U3-on)
	ld	i,a
	ei				; megszak. eng.
	pop	af			; hasznlt regiszterek helyrelltsa
	pop	hl
	ex	(sp),hl			; HL= visszatrsi cm
	set	7,h			; visszatrsi cm a 3. lapra mutat
	set	6,h
	ex	(sp),hl			; mdostott cm vissza a verembe
	ret


;
;
;	Diszk hiba kirsa a kpernyre s felhasznli beavatkozs megvrsa
;	(megj.: a floppy RAM-bl hvott rutin)
;	in:   B - hibakd
;	      C - meghajt szma, ahol a hiba trtnt
;	      E - 0FFh-> IGNORE vlasz ajnlhat  000h-> nem ajnlhat (bug? - fordtva?)
;	out:  E - vlasztott mvelet sorszma (1->Abort  2-> Retry  3->Ignore) 
;
LE309:	call	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra
	ld	hl,0EDABh		; HL= konzol-bemenetknt megnyitott fjl FCB-je
	ld	d,(hl)			; eredeti els bjt D-be
	ld	(hl),000h		; els bjt nullzsa (nincs tirnyts)
	ld	hl,0EDDBh		; HL= konzol-kimenetknt megnyitott fjl FCB-je
	ld	a,(hl)
	ld	(hl),000h		; els bjt nullzsa (nincs tirnyts)
	ld	l,a			; output FCB eredeti els bjt L-be
	ld	h,d			;  input FCB eredeti els bjt H-ba
	push	hl			; els bjtok mentse a verembe
	push	de			; DE mentse
	ld	hl,(0E684h)		; HL= diszk-hibakezel szubrutin cme 
	ld	a,h
	or	l
	push	bc			; BC mentse
	call	nz,LE3AB		; ha nem nulla a cm, akkor a diszk-hibakezel rutin meghvsa
	pop	hl			; H = belpskori hibakd   L = meghajt szma, ahol a hiba volt
	pop	bc			; C = IGNORE vlasz ajnlhat-e
	or	a			; visszaadott vlasz vizsglata
	ld	e,a			; vlasz E-be is
	jr	nz,LE39E		; ugrs, ha nem a norml hibakezels kell (pl. volt hibakazel rutin hvs)
	push	bc			; BC mentse
	call	LE3C2			; soremels a konzolon
	ld	a,h			; belpskori hibakd ellenrzse
	cp	0B2h			; .WDRV hiba volt? (megfelel lemez behelyezs krse)
	ld	a,009h			; azonost: "Insert disk for"
	jr	z,LE34C			; ugrs, ha .WDRV volt
	ld	a,h
	call	LFD1F			; hibakdnak megfelel rendszerzenet kezdcmnek meghatrozsa
	jr	nc,LE346		; ugrs, ha tallt megfelel zenetet
	ld	a,001h			; azonost: "Error "
	call	LE3D6			; rendszerzenet kirsa a konzolra
	ld	a,h			; A reg.= hibakd
	call	LE3E2			; hibakd kirsa decimlis formtumban
	scf				; CY=1 -> a kvetkez rutinhvst tlpi
LE346:	call	nc,LE3D9		; tallt hiba-zenet kirsa a konzolra
	ld	a,002h			; azonost: " --"
	or	a
LE34C:	push	af			; ZF=1 ha lemez behelyezs krse volt
	call	LE3D6			; rendszerzenet kirsa a konzolra
	ld	a,003h			; azonost: " drive "
	call	LE3D6			; rendszerzenet kirsa a konzolra
	ld	a,l			; A reg.= meghajt szma, ahol a hiba volt
	add	a,040h			; meghajtszmbl ASCII karakter (1-> 'A'  2-> 'B' stb.)
	call	LE3C9			; karakter kirsa
	ld	a,03Ah			; A reg.= ':'
	call	LE3C9			; karakter kirsa
	call	LE3C2			; soremels a konzolon
LE363:	pop	af
	push	af
	ld	a,00Ah			; azonost: "Press RETURN to continue... "
	jr	z,LE375			; ugrs, ha lemez-behelyezs krse volt
	pop	af
	pop	bc			; C = IGNORE vlasz ajnlhat-e
	push	bc			; rtkek vissza a verembe
	push	af
	inc	c
	dec	c
	ld	a,004h			; azonost: "Abort, Retry or Ignore (A/R/I)? "
	jr	z,LE375			; ugrs, ha IGNORE nem ajnlhat (bug?)
	ld	a,005h			; "Abort or Retry (A/R)? "
LE375:	call	LE3D6			; rendszerzenet kirsa a konzolra
	call	LE3AD			; vrakozs egy gombnyomsra, a vlasz kirsa a kpernyre
	pop	af
	push	af
	jr	nz,LE388		; ugrs, ha nem lemez-behelyezs krse volt
	ld	a,h			; vlasz karaktere A reg.-be
	cp	00Dh
	jr	nz,LE363		; ugrs, ha nem a RETURN volt (jra kirja a vlasztsi lehetsgeket)
	ld	e,002h			; E= 002h -> Retry
	jr	LE39C			; ugrs a befejezsre
;
LE388:	ld	l,000h			; L= szmll nullzsa
	ld	a,006h			; azonost: "Aa"
	call	LE403			; vlasz karakter keresse az adott azonostj zenetben
	ld	a,007h			; azonost: "Rr"
	call	nc,LE403		; ha mg nem volt tallat, tovbb keres az adott zenetben
	ld	a,008h			; azonost: "Ii"
	call	nc,LE403		; ha mg nem volt tallat, tovbb keres az adott zenetben
	jr	nc,LE363		; ha nem volt megfelel vlasz, akkor jra kirja a vlasztsi lehetsgeket
	ld	e,l			; E= vlasztott karakter sorszma (A->1  R->2  I->3) 
LE39C:	pop	bc			; verem kitakartsa
	pop	bc
LE39E:	pop	hl			; HL= konzol I/O FCB els bjtok mentett rtke
	ld	a,h
	ld	(0EDABh),a		; konzol-bemenet FCB-jnek helyrelltsa
	ld	a,l
	ld	(0EDDBh),a		; konzol-kimenet FCB-jnek helyrelltsa
	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
	ret

;
LE3AB:	ld	a,e			; A reg.= IGNORE vlasz ajnlhat-e
	jp	(hl)			; ugrs a felhasznli diszk-hibakezel rutinra


;
;
;	Vrakozs egy gombnyomsra s a lettt karakter beolvassa,
;	majd kirsa a kpernyre s soremels
;	in:    -
;	out: H - lettt karakter
;
LE3AD:	ld	c,00Bh			; C= funkci kd: Konzol llapot
	call	LEE62			; VT-DOS funkci vgrehajtsa
	push	af			; eredmny a verembe
	ld	c,008h			; C= funkci kd: Konzol input echo nlkl
	call	LEE62			; VT-DOS funkci vgrehajtsa
	ld	h,a			; beolvasott karakter H-ba
	pop	af
	jr	nz,LE3AD		; ismtls, ha nem volt kszenltben karakter
	ld	a,h			; beolvasott karakter vissza A reg.-be
	cp	020h
	call	nc,LE3C9		; karakter kirsa a konzolra, ha nem SPACE volt
;
;
;	Soremels a konzolon
;	in: -
;	out: BC,DE,HL - megrzdik
;
LE3C2:	ld	a,00Dh			; A reg.= kocsi vissza karakter
	call	LE3C9			; karakter kirsa
	ld	a,00Ah			; A reg.= j sor karakter
;
;
;	Karakter kirsa a konzolra
;	in:   A - karakterkd
;	out: BC,DE,HL - megrzdik
;
LE3C9:	push	hl
	push	de
	push	bc
	ld	c,002h			; C= funkci kd: Konzol output
	ld	e,a			; E= kirand karakter
	call	LEE62			; VT-DOS funkci vgrehajtsa
	pop	bc
	pop	de
	pop	hl
	ret


;
;
;	Rendszerzenet kirsa a konzolra
;	in:   A - rendszerzenet azonostja
;	out:  A - A= 000h (az zenetet lezr nulla karakter)
;
LE3D6:	call	LFD1F			; rendszerzenet kezdcmnek meghatrozsa

;
;
;	Nullval lezrt string kirsa a konzolra
;	in:  DE - string kezdkarakternek cme
;	out:  A - A= 000h (az zenetet lezr nulla karakter)
;
LE3D9:	ld	a,(de)			; A reg.= kvetkez karakter
	inc	de
	or	a
	ret	z			; visszatrs, ha a lezr nulla
	call	LE3C9			; karakter kirsa a konzolra
	jr	LE3D9			; ismtls


;
;
;	Szm kirsa decimlis formtumban, a bevezet nullk elhagysval (a hibakir rutinhoz)
;	in:  A - kirand 8 bites szm
;	out:   -
;
LE3E2:	ld	bc,00064h		; B= 000h -> nem rja ki a 0-t  C= oszt (100)
	call	LE3F0			; szzas helyirtk kirsa
	ld	c,00Ah			; C= oszt (10)
	call	LE3F0			; tzes helyirtk kirsa
	ld	bc,03001h		; B= 030h -> kirja a 0-t is  C= oszt (1)
LE3F0:	ld	d,0FFh			; egyesek kirsa
LE3F2:	sub	c			; A reg. cskkentse C-vel, amg nem lesz alulcsorduls
	inc	d			; D= eredmny (A reg. osztva C-vel)
	jr	nc,LE3F2		; ismtls, amg C megvan A reg.-ben
	ld	e,a			; oszts maradka E-be
	ld	a,d			; egsz rsz A reg.-be
	jr	z,LE3FC			; ugrs, ha nulla lett az eredmny
	ld	b,030h			; B= ASCII '0' karakter kdja
LE3FC:	or	b			; szmjegy ASCII kdja A reg.-be
	call	nz,LE3C9		; szmjegy kirsa a konzolra, ha nem 000h az ASCII kd
	ld	a,e			; maradk A reg.-be
	add	a,c			; utols kivons visszalltsa
	ret


;
;
;	Karakter keresse az adott azonostj zenetben (a hibakir rutinhoz)
;	in:   A - rendszerzenet azonostja
;	      H - keresett karakter
;	      L - szmll, amit eggyel megnvel
;	out: DE - a keresett karakter utni bjtra mutat a rendszerzenetben
;	     CY - CY=1 -> megtallta a keresett karaktert
;
LE403:	inc	l
	call	LFD1F			; rendszerzenet kezdcmnek meghatrozsa
LE407:	ld	a,(de)			; A reg.= zenet aktulis karaktere
	or	a
	ret	z			; visszatrs, ha a lezr nulla
	inc	de			; DE az zenet kvetkez karakterre mutat
	cp	h
	jr	nz,LE407		; ugrs, ha nem a keresett karakter volt
	scf				; CY= 1
	ret



;
;
;	START
;
LE410:	di
	ld	a,0B0h			; U0,U1,U2,U3 lapozs
	out	(002h),a		; memrialapozs belltsa
	ld	(0003Bh),a		; msolat a memrialapozsrl
	ld	sp,LE200		; veremterlet kezdete
	ld	hl,LE669		; 11 bjtnyi kd tmsolsa
	ld	de,00008h
	ld	bc,0000Bh
	ldir
	ld	de,00048h		; tovbbi 16 bjt msolsa
	ld	c,010h
	ldir
	ld	a,0C3h			; A reg. = JP NNNN kdja
	ld	hl,00000h
	ld	(hl),a
	inc	hl
	ld	(hl),LE203 & 255	; 0. cm: JP 0E203h (program befejezse)
	inc	hl
	ld	(hl),LE203 >> 8
	inc	hl
	ld	(hl),000h
	inc	hl
	inc	hl
	ld	(hl),a			; 5. cm: JP 0E106h (VT-DOS funkc vgrehajtsa)
	inc	hl
	ld	(hl),LE106 & 255
	inc	hl
	ld	(hl),LE106 >> 8
	xor	a			; vltozk inicializlsa az U3 RAM-ban
	ld	(0EE0Bh),a		; program visszatrsi hibakdja: 000h
	ld	(0EDABh),a		; konzol-bemenet: billentyzet
	ld	(0EDDBh),a		; konzol-kimenet: kperny
	ld	hl,0ECABh
	ld	(0ECA3h),hl
	ld	(0ECA5h),hl
	ld	de,000FFh
LE45B:	ld	(hl),00Dh		; 255 darab 00Dh bjt bersa U3-ba 0ECABh-tl kezdve
	inc	hl
	dec	de
	ld	a,d
	or	e
	jr	nz,LE45B
	ld	(0ECA7h),a		; bels sorpuffer res (kurzor fel/le nem fog szvegeket visszaadni)
	ld	(0EC99h),a		; konzol inputrl olvasott karakter kdja: kiolvasva
	ld	(0EC97h),a		; 5.bit - konzolkimenet a nyomtatra: 0 -> tiltva
	ld	a,0FEh			; interrupt vektor belltsa 0FExxh-ra
	ld	i,a
	im	2			; 2-es megszaktsi md belltsa
	ei				; megszaktsok engedlyezse
	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
	ld	hl,0DF22h
	ld	(0DFF8h),hl		; floppy hibakezel fggvny cmnek belltsa
	ld	iy,(0DFF5h)		; IY a floppy vltozk bziscmre mutat
	ld	hl,0DF22h
	ld	(0DFF8h),hl		; floppy hibakezel fggvny cmnek belltsa ismt (bug?)
	xor	a
	ld	(0DFF2h),a		; DOSCART = 000h -> nincs VT-DOS (mg nem fut)
	ld	l,a
	ld	h,a
	ld	(02688h),hl		; veremmutat /SP/ mentett rtknek nullzsa (-> nincs mentett rtk)
LE48F:	ld	a,(iy-060h)		; A reg.= BOOT_DRV (a floppy RAM-bl)
	or	a
	jr	nz,LE4A9		; ugrs, ha nem nulla (mr korbban prblkozott betlteni a COMMAND.COM-ot (?))
	ld	a,001h			; az A: meghajtval kezdi prblkozst
LE497:	call	PG0ADR(LE4B1)		; COMMAND.COM betltse s elindtsa
	inc	a			; ha visszatrt a szubrutinbl, akkor nem sikerlt betlteni
	cp	005h
	jr	nz,LE497		; prblkozs a kvetkez meghajtn
	ld	a,001h
	ld	(PG0ADR(LE5D5)),a	; meghajt sorszmnak visszalltsa 1-re
	call	PG0ADR(LE55E)		; hibakezels hibakd nlkl
	jr	LE48F			; jrakezdi az sszes meghajt vgigvizsglsval
;
LE4A9:	call	PG0ADR(LE4B1)		; COMMAND.COM betltse s elindtsa
	call	PG0ADR(LE55E)		; hibakezels hibakd nlkl, ha nem sikerlt
	jr	LE48F			; ugrs az jraprblkozshoz


;
;
;	COMMAND.COM betltse s elindtsa
;	(megj.: a funkci cme a 0. lapon: L24B1)
;	in:  A - meghajt sorszma (1->A  2->B ..)
;	out: A - belpskori rtk (?)
;
LE4B1:	push	af
	ld	(PG0ADR(LE5D5)),a	; meghajt sorszm belltsa, egyben az FCB fejlcbe is belekerl
LE4B5:	ld	hl,LE5CB
	ld	(02684h),hl		; diszk-hibakezel rutin cmnek belltsa
	ld	hl,PG0ADR(LE5CE)	; keressi FCB elksztse a COMMAND.COM-hoz
	ld	de,025E1h
	ld	bc,00013h		; 19 bjt msolsa
	push	de
	ldir
	pop	de			; DE= hasznlatlan FCB
	ld	bc,02611h		; BC= hely az FCB szmra
	ld	hl,02641h		; HL= tvonalnv
	ld	a,004h			; A reg.= 004h - Els keresse
	call	LC02E			; FISH hvsa
	sbc	hl,hl
	ld	(02684h),hl		; diszk-hibakezel szubrutin cmnek nullzsa
	cp	0A1h			; fjl nem tallhat (.NOFIL) hiba volt?
	jr	z,LE4E4			; ugrs, ha igen
	cp	0ABh			; rvnytelen meghajt (.IDRV)?
	jr	z,LE4E4			; ugrs, ha igen
	cp	0ADh			; mvelet megszakadt (.ABORT)?
	jr	nz,LE4E6		; ugrs, ha nem
LE4E4:	pop	af
	ret
;
LE4E6:	or	a			; ZF belltsa A reg. rtke szerint
	ex	de,hl			; HL= keressi FCB
	ld	e,c			; DE= meghatrozott FCB
	ld	d,b
	call	z,PG0ADR(LE5C1)		; fjl megnyitsa, ha keresskor nem volt lemezes hiba
	ld	ix,04000h		; IX= cl memriacm (U1 RAM els bjtja)
	ld	bc,08000h		; BC= olvasand bjtok szma (32768)
	call	z,PG0ADR(LE5C6)		; olvass fjlbl
	jr	z,LE54E			; ugrs, ha nem volt hiba
	cp	0ECh
	jr	nz,LE550		; ugrs, ha nem .EOF hiba
	ld	a,b
	or	c			; ZF=1 ha BC= 0000h volt (olvasott bjtok szma)
	ld	a,093h			; A reg.= .BADCOM - rvnytelen COMMAND.COM
	jr	z,LE550			; ugrs, ha nem olvasott egy bjtot sem
	ld	a,0FFh
	ld	(0DFF2h),a		; DOSCART = 0FFh (VT-DOS fut)
	ld	a,(PG0ADR(LE5D5))	; A reg.= meghajt sorszma
	ld	(iy-060h),a		; BOOT_DRV belltsa
	ld	(iy-05Fh),a		; DEF_UNIT belltsa
	call	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra
	dec	a
	ld	(0004h),a		; meghajt sorszm -1 trolsa U0 elejn
	ld	hl,04000h		; a beolvasott adatblokk tmsolsa az U0 256. cmre
	ld	de,00100h
	ldir
	ld	hl,0005Ch
LE523:	ld	(hl),h			; U0 kinullzsa az 005Ch cmtl 00FFh-ig
	inc	l
	jr	nz,LE523
	ld	l,05Dh			; HL a 005Ch cmen kezdd CP/M FCB fjlnevre mutat
	call	LE556			; fjlnv kitltse SPACE karakterekkel
	ld	l,06Dh			; HL a 006Ch cmen kezdd CP/M FCB fjlnevre mutat
	call	LE556			; fjlnv kitltse SPACE karakterekkel
	ld	hl,00080h
	ld	(0E68Ah),hl		; diszk tviteli cm vltoz belltsa
	ld	hl,0E643h
	ld	(0003Ch),hl		; parancskeressi tvonal cmnek belltsa
	xor	a
	ld	l,a			; HL= 0000h
	ld	h,a
	ld	(0003Eh),hl		; programbetltsi tvonal cmnek kinullzsa
	ld	(00040h),hl		; parancsparamter string cmnek kinullzsa
	push	hl			; visszatrsi cm belltsa 0000h-ra (ott JP 0E203h utasts ll)
	ld	de,0E1FFh		; DE= 0E1FFh
	dec	c			; C = 0FFh
	jp	00100h			; ugrs a betlttt program kezdetre
;
LE54E:	ld	a,08Ch			; A reg.= .NORAM hibakd (nincs elg memria)
LE550:	call	PG0ADR(LE55F)		; hibakd kirsa s felhasznli beavatkozs krse
	jp	PG0ADR(LE4B5)		; ugrs az jraprblkozsra, a meghajt sorszma marad a rgi


;
;
;	Fjlnv kitltse SPACE karakterekkel
;	in:  HL - fjlnvre mutat
;	out: HL - a fjlnv utnra mutat 
;
LE556:	ld	b,00Bh
LE558:	ld	(hl),020h
	inc	hl
	djnz	LE558
	ret


;
;
;	Hibakezels hibakd nlkl
;	in:  -
;	out: -
;
LE55E:	xor	a			; hibakd kinullzsa

;
;
;	Hibakezels, ha nem sikerlt betlteni a COMMAND.COM-ot
;	in:   A - hibakd
;	out:    -
;
LE55F:	call	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra
	ld	hl,LE5B5
	ld	(LEEBE + 1),hl		; a 0EEBEh cmen lv "CALL NZ,xxxx" utasts paramternek belltsa
	or	a
	jr	z,LE588			; ugrs, ha nem volt belpskor hibakd megadva
	push	af			; hibakd mentse
	cp	0F5h			; A reg.= .STOP ? (CTRL-ESC -et nyomtak)
	jr	z,LE572			; ugrs, ha igen
	cp	092h			; A reg.= .CTRLC ? (CTRL-C -t nyomtak)
LE572:	call	z,LE3C2			; soremels a konzolon, ha igen
	call	LE3C2			; soremels a konzolon
	ld	a,00Bh			; A reg.= "*** " string azonostja
	call	LE3D6			; string kirsa a konzolra
	pop	af			; A reg.= hibakd
LE57E:	call	LFD1F			; hibakdnak megfelel rendszerzenet kezdcmnek meghatrozsa
	ld	a,00Dh			; A reg.= "Cannot load COMMAND.COM" string azonostja
	jr	c,LE57E			; jabb keress, ha nem tallhat a hibakdnak megfelel zenet
	call	LE3D9			; nullval lezrt string kirsa a konzolra
LE588:	call	LE3C2			; soremels a konzolon
	ld	a,00Ch			; A reg.= "Insert COMMAND.COM disk in drive " string azonostja
	call	LE3D6			; string kirsa a konzolra
	ld	a,(LE5D5)		; A reg.= meghajt sorszma
	add	a,040h			; sorszm konvertlsa A,B,C.. karakterre
	call	LE3C9			; karakter kirsa a konzolra
	ld	a,03Ah			; A reg.= ":"
	call	LE3C9			; karakter kirsa a konzolra
	call	LE3C2			; soremels a konzolon
LE5A0:	ld	a,00Ah			; A reg.= "Press RETURN to continue... " string azonostja
	call	LE3D6			; string kirsa a konzolra
	call	LE3AD			; vrakozs egy gombnyomsra
	ld	a,h			; lettt gomb vizsglata
	sub	00Dh
	jr	nz,LE5A0		; ismtls, ha nem a RETURN volt
	ld	l,a			; HL= 0000h
	ld	h,a
	ld	(LEEBE + 1),hl		; "Abort" szubrutin cmnek belltsa
	jp	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
					; majd visszatrs a hvhoz
;
;
;	"Abort" szubrutin
;	(megj.: a 0EEBEh cmen lv "CALL NZ,xxxx" utasts paramterbe kerl)
;
LE5B5:	ld	sp,0E200h
	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
	call	PG0ADR(LE55F)		; hibakezels
	jp	PG0ADR(LE48F)		; jrakezdi az sszes meghajt vgigvizsglsval


;
;
;	Fjl megnyitsa FISH funkci meghvsa
;
LE5C1:	ld	a,00Ch
	jp	LC02E


;
;
;	Olvass fjlbl FISH funkci meghvsa
;
LE5C6:	ld	a,00Fh
	jp	LC02E


;
;
;	Lemezes hibakezel rutin
;
LE5CB:	ld	a,001h
	ret


;
;
;	FCB fix bjtjai a "COMMAND.COM" betltshez
;
LE5CE:	.db	0FFh, 000h, 000h, 000h
	.db	000h, 000h, 000h
LE5D5:	.db	001h			; meghajt sorszma
	.db	"COMMAND COM"		; fjlnv
;

;
;	2 x 48 bjtos FISH tpus FCB a "COMMAND.COM" betltshez
;
LE5E1:					; FCB1 (48 bjt)
LE611:					; FCB2 (48 bjt)


	.org	0E641h

	.db	05Ch, 000h		; '\' - nullval lezrt tvonalnv string a COMMAND.COM betltshez
	.db	020h			; parancskeressi tvonal ide mutat a COMMAND.COM betltse utn


;
;	Adatbjt kiolvassa a floppy RAM-bl, megszaktsok tiltsa
;	(floppy RAM cm a hv rutin utni kt bjton letrolva)
;	in:   -
;	out:  A - kiolvasott adat, minden ms regiszter megrzdik
;
LE644:	di				; (U3-ban a 0. lapon: L2644)
	ex	(sp),hl			; HL mentse, visszatrsi cm HL-be
	push	de			; DE mentse
	ld	e,(hl)			; cm betltse DE-be a visszatrsi cmrl
	inc	hl
	ld	d,(hl)
	inc	hl
	ld	a,0F8h			; U3,U1,U2,EXT/IOMEM lapozs
	out	(002h),a		; memrialapozs belltsa
	ld	a,(de)			; adat betltse a floppy RAM-bl A reg.-be
	jr	LE660			; ugrs a befejez rszre


;
;
;	Adatbjt belltsa a floppy RAM-ban, megszaktsok tiltsa
;	(floppy RAM cm a hv rutin utni kt bjton letrolva)
;	in:   A - belltand rtk
;	out:    - minden regiszter megrzdik
;
LE652:	di				; (U3-ban a 0. lapon: L2652)
	ex	(sp),hl			; HL mentse, visszatrsi cm HL-be
	push	de			; DE mentse
	ld	e,(hl)			; cm betltse DE-be a visszatrsi cmrl
	inc	hl
	ld	d,(hl)
	inc	hl
	push	af			; belltand rtk mentse
	ld	a,0F8h			; U3,U1,U2,EXT/IOMEM lapozs
	out	(002h),a		; memrialapozs belltsa
	pop	af
	ld	(de),a			; j rtk belltsa
LE660:	push	af			; A reg. mentse
	ld	a,018h			; U3,U1,VID,CART lapozs
	out	(002h),a		; memrialapozs belltsa
	pop	af			; A reg. vissza
	pop	de			; DE vissza
	ex	(sp),hl			; HL vissza, megnvelt visszatrsi cm ismt a verembe
	ret



;
;
; ---------------- Rendszerindulskor az U0 RAM elejre msolt kdrszek ----------------
;

LE669:
;
;	Felhasznli programbl hvott FISH funkcik vgrehajtsnak belpsi pontja
;
L0008h:	or	a			; CY=0
	jr	$ + 03Fh		; relatv ugrs 00048h-ra

;
;
;	Felhasznli programbl hvott FISH s DISKIO funkcik vgrehajtsnak befejez rsze
;
L000Bh:	out	(002h),a		; felhasznli memrialapozs visszalltsa
	pop	af			; A reg. helyrelltsa (hibakd)
	ei
	ret

;
;
;	Felhasznli programbl hvott DISKIO funkcik vgrehajtsnak belpsi pontja
;
L0010h:	scf				; CY=1
	jr	$ + 037h		; relatv ugrs 00048h-ra


;
;	Felhasznli programbl hvott FISH s DISKIO funkcik kzs belpsi rsze
;
L0048h:	push	af			; funkcikd a verembe
	push	hl			; HL-ben adott paramter a verembe
	ld	hl,02200h
	ld	(0E688h),hl		; hasznland veremmutat-rtk belltsa
	di
	ld	a,0F0h			; U0,U1,U2,EXT/IOMEM lapozs
	out	(002h),a		; memrialapozs belltsa
	jp	LDF49			; ugrs a floppy RAM-ba tlttt belpsi rutinra

LE683:

;
; ---------------- eddig msol ----------------
;



LE684:

;
;	Bels VT-DOS vltozk terlete az U3 RAM-ban
;
;	tartomny: 0E684h ... 0EE61h
;


	.org	0EE62h

;
;
;	VT-DOS funkci vgrehajtsa
;	(elkszti a sajt veremterletet, majd meghvja a funkci cmt kikeres rutint s vgrehajtja)
;	in:   B - paramter
;	      C - funkcikd
;	     DE - paramter
;	     HL - paramter
;	out:  A - ltalban a funkci hibakdja  
;	     minden ms - a funkcinak megfelelen belltott regiszterrtkek
;
LEE62:	push	hl
	ld	hl,(LEEAA + 1)		; HL= a 0EEAAh cmen lv "LD SP,xxxx" utasts paramtere
	ld	(LEEAA + 1),sp		; ugyanannak az utastsnak a paramternek tlltsa
	ex	(sp),hl			; az eredeti rtk lementse a verembe, HL= belpskori rtk
	push	hl			; HL belpskori rtke a verembe
	ld	hl,0E200h		; HL= veremterlet indulsi kezdcme
	xor	a			; A reg.= 000h  CY= 0
	sbc	hl,sp			; HL= a veremben lv adatok szma
	jr	c,LEE77			; ugrs, ha a veremmutat rtke nagyobb a kiindulsi rtknl (?)
	or	h
	jr	z,LEE7C			; ugrs, ha 256-nl kevesebb bjt van a veremben
LEE77:	pop	hl			; HL= belpskori rtk
	ld	sp,0E200h		; veremmutat alaphelyzetbe
	.db	03Eh			; a kvetkez bjttal: LD A,0E1H (elfedi POP HL-t)
LEE7C:	pop	hl			; HL= belpskori rtk
	ei				; megszak. eng.
	push	iy			; IY mentse
	push	ix			; IX mentse
	ex	af,af'
	push	af			; AF' mentse
	push	hl			; HL belpskori rtk mentse
	ld	hl,(LEE9B + 1)		; HL= a 0EE9Bh cmen lv "LD SP,xxxx" utasts paramtere
	ex	(sp),hl			; az eredeti rtk lementse a verembe, HL= belpskori rtk
	ld	iy,(0E686h)		; IY az U3-ban lv vltozterletre mutat
	ld	(LEE9B + 1),sp		; a 0EE9Bh cmen lv "LD SP,xxxx" utasts paramternek belltsa
	call	LEEC7			; VT-DOS funkci cmnek kikeresse a tblzatbl s ugrs a funkcira
	ex	af,af'
	ld	a,0C9h
	ld	(LEEB3),a		; a rutin vgn lv "RET" utasts helyrelltsa
	ex	af,af'
LEE9B:	ld	sp,00000h		; SP= a funkcira ugrs eltti sajt veremcm
	ex	(sp),hl			; HL tmeneti mentse, az elz utasts eredeti paramternek betltse HL-be
	ld	(LEE9B + 1),hl		; az elz "LD SP,xxxx" utasts paramternek visszalltsa
	pop	hl			; HL helyrelltsa
	ex	af,af'
	pop	af			; AF', IX s IY helyrelltsa
	ex	af,af'
	pop	ix
	pop	iy
LEEAA:	ld	sp,00000h		; SP= a belpskori rtk (ld. rutin elejn ide menti el)
	ex	(sp),hl			; HL tmeneti mentse, az elz utasts eredeti paramternek betltse HL-be
	ld	(LEEAA + 1),hl		; az elz "LD SP,xxxx" utasts paramternek visszalltsa
	pop	hl			; HL helyrelltsa
	or	a
LEEB3:	ret


;
;
;	"Abort" szubrutin meghvsa majd program befejezse
;
;
LEEB4:	push	hl			; ezt a rutinrszt nem kzvetlenl hvja, hanem az elz "RET" utasts "NOP"-ra
	push	af			;  lltsa utn itt folytatdik a funkci vgrehajtsa
	ld	hl,(LEEBE + 1)		; HL= a "CALL NZ,xxxx" utasts paramtere ("Abort" szubrutin cme)
	ld	a,h			; paramter ellenrzse, hogy nulla-e
	or	l
	pop	hl			; A reg. helyrelltsa
	ld	a,h
	pop	hl			; HL helyrelltsa
LEEBE:	call	nz,00000h		; "Abort" szubrutin meghvsa, ha nem 0000h a belltott rutincm 
	ld	(0EE0Bh),a		; hibakd mentse
	jp	00000h			; ugrs a memria 0. cmn lv program-befejezsre


;
;
;
;	VT-DOS funkci cmnek kikeresse a tblzatbl s ugrs a funkcira
;	in:   B - paramter
;	      C - funkcikd
;	     DE - paramter
;	     HL - paramter
;	out:  A - ltalban a funkci hibakdja  
;	     minden ms - a funkcinak megfelelen belltott regiszterrtkek
;
LEEC7:	push	de			; DE mentse
	push	hl
	ld	hl,LEEF0
	ex	(sp),hl			; LEEF0 rutin cmnek bersa a verembe, HL= a belpskori rtk
	ld	a,c
	cp	031h
	jr	c,LEEDF			; ugrs, ha A reg. < 031h
	cp	080h
	jr	c,LEF01			; ugrs, ha A reg. < 080h  (A reg. s B nullzsa, majd ugrs LEEF0-ra)
	cp	087h
	jr	nc,LEF01		; ugrs, ha A reg. >= 087h (A reg. s B nullzsa, majd ugrs LEEF0-ra)
	sub	04Fh			; itt A reg.= 080h...086h -> majd A= 031h...037h
	inc	sp			; verembe rt 0EEF0h rtk eldobsa (nem UPM kompatibilis funkci)
	inc	sp
	pop	de			; DE= belpskori rtk
LEEDF:	push	hl			; HL s BC belpskori rtknek mentse
	push	bc
	ld	b,000h			; BC= funkci sorszma 16 biten brzolva
	ld	c,a
	ld	hl,LEF05		; HL= cmtblzat eleje
	add	hl,bc			; tblzatbeli cm szmtsa, egy elem 2 bjtos
	add	hl,bc
	ld	c,(hl)			; funkci cmnek betltse HL-be
	inc	hl
	ld	h,(hl)
	ld	l,c
	pop	bc			; BC= belpskori rtk
	ex	(sp),hl			; funkci cme a verembe, HL= belpskori rtk
	ret				; ugrs a krt funkci vgrehajtsra, ha UPM kompatibilis, akkor az LEEF0 rutinon keresztl tr vissza


;
;
;	UPM kompatibilis funkcik visszatrsi kdrsze
;
LEEF0:	ld	l,a			; A reg.= L s B = H belltsa az UPM kompatibilits miatt
	ld	h,b
	pop	de			; DE= a funkci meghvsakori rtk
	ld	c,e			; C = E belltsa
	ret


;
;
;	DOS_84h - VT-DOS verziszmainak beolvassa
;	in:     -
;	out:  A - llapotkd
;	     BC - diszk ROM verziszm
;	     DE - VT-BDOS verziszm
;
LEEF5:	ld	a,01Fh			; funkcikd: diszk ROM verziszmnak beolvassa
	call	LF890			; FISH funkci meghvsa
	ld	de,00101h		; DE= VT-BDOS verziszm: 1.1
	ret


;
;
;	DOS_0Ch - CP/M verziszm beolvassa
;	in:     -
;	out:  A - CP/M verziszma
;	      B - 000h
;
LEEFE:	ld	a,022h			; ver. 2.2
	.db	006h			; a kvetkez bjttal: LD B,0AFH (elfedi XOR A-t)


;
;
;	DOS_29h - Nem hasznlt funkcik rutinja
;	in: -
;	out:  A - 000h
;	      B - 000h
;
LEF01:	xor	a
	ld	b,000h
	ret


;
;
;	VT-DOS funkcik cmtblzata (55 darab funkci)
;
LEF05:
	.dw	LEF7F			; DOS_00h - Befejezs hiba nlkl
	.dw	LF013			; DOS_01h - Konzol input
	.dw	LF021			; DOS_02h - Konzol output
	.dw	LF0AE			; DOS_03h - Segd input
	.dw	LF0B8			; DOS_04h - Segd output
	.dw	LF0C1			; DOS_05h - Lista output
	.dw	LF04B			; DOS_06h - Kzvetlen konzol I/O
	.dw	LF062			; DOS_07h - Kzvetlen konzol input
	.dw	LF037			; DOS_08h - Konzol input echo nlkl
	.dw	LF02F			; DOS_09h - String output
	.dw	LF0FE			; DOS_0Ah - Pufferelt sor-input
	.dw	LF045			; DOS_0Bh - Konzol llapot
	.dw	LEEFE			; DOS_0Ch - CP/M verziszm beolvassa
	.dw	LF52A			; DOS_0Dh - Diszk reset
	.dw	LF53F			; DOS_0Eh - Diszk kivlasztsa
	.dw	LF561			; DOS_0Fh - Fjl megnyitsa
	.dw	LF5A4			; DOS_10h - Fjl lezrsa
	.dw	LF5B6			; DOS_11h - Els keresse
	.dw	LF5CA			; DOS_12h - Kvetkez keresse
	.dw	LF629			; DOS_13h - Fjl trlse
	.dw	LF65A			; DOS_14h - Szekvencilis olvass
	.dw	LF678			; DOS_15h - Szekvencilis rs
	.dw	LF69E			; DOS_16h - Fjl ltrehozsa
	.dw	LF6C9			; DOS_17h - Fjl tnevezse
	.dw	LF705			; DOS_18h - Login vektor beolvassa
	.dw	LF70D			; DOS_19h - Implicit meghajt beolvassa
	.dw	LF717			; DOS_1Ah - Diszk-tviteli cm belltsa
	.dw	LF71C			; DOS_1Bh - Helyfoglalsi informci beolvassa
	.dw	LEF01			; DOS_1Ch - Nem hasznlt funkci
	.dw	LEF01			; DOS_1Dh - Nem hasznlt funkci
	.dw	LEF01			; DOS_1Eh - Nem hasznlt funkci
	.dw	LEF01			; DOS_1Fh - Nem hasznlt funkci
	.dw	LEF01			; DOS_20h - Nem hasznlt funkci
	.dw	LF731			; DOS_21h - Vletlen elrs olvass
	.dw	LF74B			; DOS_22h - Vletlen elrs rs
	.dw	LF762			; DOS_23h - Fjlmret beolvassa
	.dw	LF791			; DOS_24h - Vletlen rekordszm belltsa
	.dw	LEF01			; DOS_25h - Nem hasznlt funkci
	.dw	LFA25			; DOS_26h - Blokk rs
	.dw	LFA22			; DOS_27h - Blokk olvass
	.dw	LF74E			; DOS_28h - Vletlen elrs rekord ltrehozsa
	.dw	LEF01			; DOS_29h - Nem hasznlt funkci
	.dw	LEF9D			; DOS_2Ah - Dtum beolvassa
	.dw	LEFAC			; DOS_2Bh - Dtum belltsa
	.dw	LEFB0			; DOS_2Ch - Id beolvassa
	.dw	LEFB6			; DOS_2Dh - Id belltsa
	.dw	LF79A			; DOS_2Eh - rs-ellenrzs jelz belltsa / trlse
	.dw	LF7AE			; DOS_2Fh - Abszolt szektor olvass
	.dw	LF7B1			; DOS_30h - Abszolt szektor rs
	.dw	LEF81			; DOS_80h - Befejezs hibakddal
	.dw	LEF8B			; DOS_81h - Az elz hiba kdjnak beolvassa
	.dw	LEF73			; DOS_82h - Abort szubrutin definilsa
	.dw	LEF79			; DOS_83h - Diszk-hiba szubrutin definilsa
	.dw	LEEF5			; DOS_84h - VT-DOS verziszmainak beolvassa
	.dw	LEFEA			; DOS_85h - Karakter I/O tirnytsa


;
;
;	DOS_82h - Abort szubrutin definilsa
;	in:  DE - Abort szubrutin cme
;	out:  A - 000h
;
LEF73:	ld	(LEEBE + 1),de		; cm kzvetlen bersa egy CALL NZ,xxxx utastsba
	xor	a			; A reg.= 000h
	ret


;
;
;	DOS_83h - Diszk-hiba szubrutin definilsa
;	in:  DE - diszk-hiba szubrutin cme
;	out:  A - 000h
;
LEF79:	ld	(0E684h),de		; cm bersa a bels vltozba
	xor	a			; A reg.= 000h
	ret


;
;
;	DOS_00h - Befejezs hiba nlkl
;	in:  -
;	out: -
;
LEF7F:	ld	b,000h			; hibakd = 000h


;
;
;	DOS_80h - Befejezs hibakddal
;	in:   B - az tadand hibakd
;	out:    -
;
LEF81:	ld	a,b
LEF82:	push	af
	xor	a
	ld	(LEEB3),a		; "RET" utasts trsa "NOP"-ra a funkcivgrehajt frutin vgn
	pop	af
	jp	LEE9B			; ugrs vissza a frutin befejez szakaszra, ahonnan az "Abort" rutin meghvsra lp tovbb


;
;
;	DOS_81h - Az elz hiba kdjnak beolvassa
;	in:     -
;	out:  B - hibakd
;
LEF8B:	ld	hl,0EE0Bh		; HL= hibakd cme
	ld	b,(hl)			; hibakd B-be
	xor	a
	ld	(hl),a			; hibakd trlse
	ret


;
; ------ nem hvott rutin ??? ------
;
LEF92:	call	LE2BF
	ld	a,01Ah			; funkcikd: rendszervltozk beolvassa/belltsa
	call	LC02E
	jp	PG0ADR(LE2E3)


;
;
;	DOS_2Ah - Dtum beolvassa
;	in:  -
;	out:  A - a ht napja (0- vasrnap  1- htf stb.)
;	      D - hnap (1..12)
;	      E - nap (1..31)
;	     HL - v (1980..2079)
;
LEF9D:	pop	bc			; kzbens visszatrsi cm s lementett DE paramter kivtele a verembl
	pop	bc
	ld	a,01Bh			; funkcikd: aktulis dtum beolvassa
	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
	call	LC02E			; FISH funkci meghvsa kzvetlenl a floppy ROM-ban
	call	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra
	ld	a,c			; a ht napja A reg.-be
	ret				; visszatrs kzvetlenl a hvhoz


;
;
;	DOS_2Bh - Dtum belltsa
;	in:   D - hnap (1..12)
;	      E - nap (1..31)
;	     HL - v (1980..2079)
;	out:  A - hiba jelzse: 000h-> rvnyes volt a dtum  0FFh-> nem volt rvnyes
;
LEFAC:	ld	a,01Ch			; funkcikd: aktulis dtum belltsa
	jr	LEFB8			; ugrs a folytatsra


;
;
;	DOS_2Ch - Id beolvassa
;	in:  -
;	out:  D - msodperc (0..59)
;	      E - szzadmsodperc (0..99)
;	      H - ra (0..23)
;	      L - perc (0..59)
;
LEFB0:	pop	bc			; kzbens visszatrsi cm s lementett DE paramter kivtele a verembl
	pop	bc
	ld	a,01Dh			; funkcikd: aktulis id beolvassa
	jr	LEFB8			; ugrs a folytatsra


;
;
;	DOS_2Dh - Id belltsa
;	in:   D - msodperc (0..59)
;	      E - szzadmsodperc (0..99)
;	      H - ra (0..23)
;	      L - perc (0..59)
;	out:  A - hiba jelzse: 000h-> rvnyes volt az id  0FFh-> nem volt rvnyes
;
LEFB6:	ld	a,01Eh			; funkcikd: aktulis id belltsa
LEFB8:	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
	call	LC02E			; FISH funkci meghvsa kzvetlenl a floppy ROM-ban
	call	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra
	add	a,0FFh			; 0FFh hozzadsa a hibakdhoz, ha volt hiba akkor CY=1
	sbc	a,a			; A reg.= 000h ha nem volt hiba, s A reg.= 0FFh ha volt hiba
	ret


;
; ------ nem hvott rutin ??? ------
;
LEFC5:	push	hl
	push	de
	ld	a,l
	ld	hl,0EFDDh		; HL= tblzatcm -1
	and	003h
	ld	e,d
	ld	d,000h
	add	hl,de
	sub	001h
	ld	a,(hl)
	bit	7,a
	jr	z,LEFDA
	adc	a,09Ch
LEFDA:	ld	b,a
	pop	de
	pop	hl
	ret


;
;	valamilyen adatok (12 bjt)
;
LEFDE:
	.db	01Fh, 080h, 01Fh, 01Eh, 01Fh, 01Eh, 01Fh, 01Fh, 01Eh, 01Fh, 01Eh, 01Fh


;
;
;	DOS_85h - Karakter I/O tirnytsa
;	in:  DE - az j output FCB-re mutat, ha 0000h -> megmarad a rgi
;	     HL - az j  input FCB-re mutat, ha 0000h -> megmarad a rgi
;	out:  A - hibakd
;	     DE - az aktulis output FCB-re mutat
;	     HL - az aktulis  input FCB-re mutat
;
LEFEA:	push	de			; j output FCB cme a verembe
	ld	de,0EDABh		; DE= aktulis input FCB cme
	call	LF00A			; j FCB tmsolsa az input FCB-be, ha nem nulla a cme
	ld	a,(0EDDBh)		; A reg.= aktulis output FCB els bjtja
	or	a			; bjt vizsglata
	ld	de,02DDBh		; DE= aktulis output FCB cme a 0.lapon lv U3 RAM-ban
	ld	a,00Dh			; funkcikd: fjl lezrsa
	call	nz,LF890		; ha nem a kperny volt a kimenet, akkor a FISH funkci meghvsa
	ld	d,0EDh			; DE= aktulis output FCB cme a 3.lapon
	pop	hl			; HL= az j output FCB cme
	push	de			; aktulis output FCB cme a verembe
	call	LF00A			; j FCB tmsolsa az output FCB-be, ha nem nulla a cme
	pop	de			; DE= aktulis output FCB cme
	ld	hl,0EDABh		; HL= aktulis input FCB cme
	xor	a
	ret


;
;
;	FCB tmsolsa a megfelel bels karakteres I/O FCB-be, ha nem nulla a cme
;	in:  DE - bels FCB cme
;	     HL - tmsoland FCB cme
;	out: -
;
LF00A:	ld	a,h			; HL rtknek vizsglata
	or	l
	ret	z			; visszatrs ha HL= 0000h
	ld	bc,00030h		; 48 bjtot msol
	ldir				; FCB tmsolsa
	ret


;
;
;	DOS_01h - Konzol input
;	in: -
;	out:  A - karakterkd
;	      B - 000h
;
LF013:	call	LF037			; karakter olvassa a billentyzetrl vagy a megnyitott fjlbl
	push	af			; karakter mentse a verembe
	call	LF19E			; ASCII karakterkd ellenrzse
	call	nc,LF156		; karakter kirsa a konzolra, ha a kd nem kisebb 020h-nl vagy feldolgozhat vezrlkd
	pop	af			; karakterkd A reg.-be
	ld	b,000h			; B= 000h
	ret


;
;
;	DOS_02h - Konzol output
;	in:   E - kikldend karakter
;	out:  A - 000h
;	      B - 000h
;
LF021:	ld	a,e			; karakterkd A reg.-be
	call	LF156			; karakter kirsa a konzolra
	xor	a			; A reg.= 000h
	ld	b,a			; B= 000h
	ret


;
;
;	String kirsi ciklus eleje
;
LF028:	push	de			; karakterpozci mentse
	ld	e,a			; kirand karakter E-be
	call	LF021			; DOS_02h - Konzol output funkci hvsa
	pop	de			; karaktercm vissza DE-be
	inc	de			; cm nvelse

;
;
;	DOS_09h - String output
;	in:  DE - karakterlnc cme (a string vgt '$' jelzi)
;	out:  A - 000h
;	      B - 000h
;
LF02F:	ld	a,(de)			; aktulis karakter A reg.-be
	cp	024h
	jr	nz,LF028		; ugrs a kvetkez karakter kirsra, ha a karakter nem '$'
	xor	a			; A reg.= 000h
	ld	b,a			; B= 000h
	ret


;
;
;	DOS_08h - Konzol input echo nlkl
;	(karakter olvassa a billentyzetrl vagy fjlbl)
;	in: -
;	out:  A - olvasott karakterkd
;	      B - B= 000h
;
LF037:	ld	a,(0EDABh)		; konzolbemeneti FCB els bjtjnak vizsglata
	ld	c,a			; bjt C-be is (fjlbemenet esetn CTRL-Z s CTRL-C is ellenrzi)
	or	a
	jp	nz,LF070		; ugrs, ha a konzolbemenet egy fjlbl trtnik
	call	LF1CD			; karakter olvassa a billentyzetrl
	ld	b,000h
	ret


;
;
;	DOS_0Bh - Konzol llapot
;	in: -
;	out:  A - 000h -> nincs rvnyes karakter  0FFh -> van rvnyes karakter
;	      B - B= 000h
;
LF045:	call	LF1B0			; karakter olvassa a billentyzetrl vrakozs nlkl
	ld	b,000h
	ret


;
;
;	DOS_06h - Kzvetlen konzol I/O
;	in:   E - kikldend karakter v. input krs jelzse (ha E=0FFh)
;	out:  A - 000h v. olvasott karakter, ha hvskor E=0FFh volt
;	      B - 000h
;
LF04B:	ld	a,e			; E-ben adott paramter vizsglata
	inc	a
	jr	z,LF05D			; ugrs, ha input szksges
	ld	a,(0EDDBh)		; konzolkimeneti FCB els bjtjnak vizsglata
	or	a
	ld	a,e			; karakterkd A reg.-be
	jr	nz,LF098		; ugrs, ha a konzolkimenet fjlba van irnytva
	ld	c,a			; karakterkd C-be
	call	LE20C			; UPM CONOUT funkci hvsa
	xor	a			; A reg.= 000h
	ld	b,a			; B= 000h
	ret
;
LF05D:	call	LE206			; UPM CONST funkci hvsa (konzol llapot)
	ld	b,a
	ret	z			; visszatrs, ha nincs rvnyes karakter


;
;
;	DOS_07h - Kzvetlen konzol input
;	in:  -
;	out:  A - olvasott karakter
;	      B - 000h
;
LF062:	ld	a,(0EDABh)		; konzolbemeneti FCB els bjtjnak vizsglata
	or	a
	ld	c,000h			; CTRL-Z s CTRL-C ellenrzsnek tiltsa fjl bemenet esetre
	jr	nz,LF070		; ugrs, ha a konzolbemenet egy fjlbl trtnik
	call	LE209			; UPM CONIN funkci hvsa (konzol input)
	ld	b,000h			; B= 000h
	ret


;
;
;	Karakter olvassa, ha a konzolbemenet egy fjlbl trtnik
;	in:   C - ha 000h, akkor nem ellenrzi az olvasott karaktert CTRL-Z s CTRL-C -re
;	out:  A - olvasott karakter
;	      B - B= 000h (ha nem trtnt hiba)
;
LF070:	push	bc
	ld	de,02DABh		; DE= konzolbemenetknt megnyitott FCB cme
	ld	ix,02C98h		; IX= cl memriacm
	ld	bc,00001h		; BC= olvasand bjtok szma
	ld	a,00Fh			; A reg.-be funkcikd: olvass fjlbl
	call	LF890			; FISH funkci meghvsa
	pop	bc
	jr	nz,LF095		; ugrs, ha hiba trtnt
	ld	b,a			; B= 000h
	or	c
	ld	a,(0EC98h)		; beolvasott bjt A reg.-be
	ret	z			; visszatrs, ha nem volt vals FCB (?)
	cp	01Ah			; CTRL-Z kdjnak ellenrzse (fjlvg TXT fjloknl)
	jr	z,LF093			; ugrs, ha fjlvg jelet tallt
	cp	003h			; CTRL-C kdjnak ellenrzse
	ret	nz			; visszatrs, ha nem az
	ld	a,092h			; hibakd: .CTRLC (CTRL-C-t nyomtak)
;
	.db	0C2h			; a kvetkez bjtokkal: "JP NZ,LEC3E" (elfedi A reg. betltst)
;
LF093:	ld	a,0ECh			; hibakd: .EOF (End of file - fjl vge)
LF095:	jp	LEF82			; szubrutin befejezse az "Abort" rutinon keresztl


;
;
;	Karakter kirsa, ha a konzolkimenet fjlba trtnik
;	in:   A - karakterkd
;	out:  A - A= 000h (ha nem trtnt hiba)
;	      B - B= 000h (ha nem trtnt hiba)
;
LF098:	ld	(0EC98h),a		; fjlba rand karakter letrolsa
	ld	de,02DDBh		; DE= konzolkimenetknt megnyitott FCB cme, ha U3 a 0. lapra van lapozva
	ld	ix,02C98h		; IX= tviteli cm U3-ban a 0. lapra lapozva
	ld	bc,00001h		; BC= tviteli hossz
	ld	a,010h			; A reg.= rs fjlba funkcikd
	call	LF890			; FISH funkci meghvsa
	jr	nz,LF095		; ugrs, ha hiba trtnt
	ld	b,a			; B= 000h
	ret


;
;
;	DOS_03h - Segd input
;	in: -
;	out:  A - beolvasott karakterkd
;	      B - 000h
;
LF0AE:	call	LE215			; UPM READER funkci hvsa (soros input)
	ld	c,a			; olvasott karakter C-be
	call	LF204			; CTRL-ESC ellenrzse
	ld	b,a			; B= 000h
	ld	a,c			; olvasott karakter A reg.-be
	ret


;
;
; 	DOS_04h - Segd output
;	in:   E - kikldend karakter
;	out:  A - 000h
;	      B - 000h
;
LF0B8:	ld	c,e			; karakterkd C-be
	call	LE212			; UPM PUNCH funkci hvsa (soros output)
	call	LF204			; CTRL-ESC ellenrzse
	ld	b,a			; B= A reg.= 000h
	ret


;
;
;	DOS_05h - Lista output
;	in:   E - kikldend karakter
;	out:  A - 000h
;	      B - 000h
;
LF0C1:	call	LF0C8			; konzolkimenet a nyomtatra
	ld	b,a			; B= 000h v. 0F5h
	ret	z			; visszatrs, ha nem trtnt hiba (ilyenkor B= 000h)
	jr	LF095			; egybknt visszatrs az "Abort" rutinon keresztl


;
;
;	Konzolkimenet a nyomtatra
;	in:   E - karakterkd
;	out:  A - hibakd (0F5h v. 000h)
;	     ZF - ZF=0 -> volt CTRL-ESC
;
LF0C8:	ld	hl,(0EC9Ch)		; HL= nyomtat karakteres oszloppozcija
	call	LF181			; oszloppozci belltsa vezrlkarakter esetn
	ld	(0EC9Ch),hl		; mdostott oszloppozci visszarsa
	ld	c,e			; kikldend adatbjt C-be
	call	LE20F			; UPM LIST funkci meghvsa (prhuzamos nyomtat output)


;
;
;	.STOP_FLAG rtknek kiolvassa a floppy RAM-bl (CTRL-ESC megnyomsnak vizsglata)
;	in: -
;	out:  A - hibakd (0F5h v. 000h)
;	     ZF - ZF=0 -> volt CTRL-ESC
;
LF0D5:	di				; megszak. tiltsa
	ld	a,0B8h			; U3,U1,U2,U3 lapozs
	out	(002h),a		; memrialapozs belltsa
	jp	PG0ADR(LF0DD)		; ugrs a 0. lapon a kvetkez utastsra
;
LF0DD:	ld	a,0F8h			; U3,U1,U2,EXT/IOMEM lapozs 
	out	(002h),a		; memrialapozs belltsa
	ld	hl,0DFF4h
	ld	a,(hl)			; A reg.= STOP_FLAG msolata (ha 0FFh: CTRL-ESC-t nyomtak)
	ld	(hl),000h
	or	a			; ZF belltsa a STOP_FLAG szerint
	ld	a,0B8h			; U3,U1,U2,U3 lapozs
	out	(002h),a		; memrialapozs belltsa
	jp	LF0EF			; ugrs a 3. lapon a kvetkez utastsra
;
LF0EF:	ld	a,0B0h			; U0,U1,U2,U3 lapozs
	out	(002h),a		; memrialapozs belltsa
	ld	a,(0003Bh)		; A reg.= aktulis memrialapozs
	out	(002h),a		; memrialapozs belltsa
	ei				; megszak. engedlyezse
	ld	a,0F5h			; A reg.= .STOP hibakd (CTRL-ESC-et nyomtak)
	ret	nz			; visszatrs ha CTRL-ESC volt
	xor	a			; hibakd trlse s visszatrs
	ret


;
;
;	DOS_0Ah - Pufferelt sor-input
;	in:  DE - input puffer cme
;	out:  A - 000h
;	      B - 000h
;	     DE - input puffer cme
;
LF0FE:	push	de			; puffercm mentse
	ld	a,(0EDABh)		; konzolbemeneti FCB els bjtjnak vizsglata
	or	a
	jr	nz,LF10A		; ugrs, ha a konzolbemenet egy fjlbl trtnik
	call	LF23F			; pufferelt sor-input kzvetlenl a billentyzetrl
	jr	LF144			; ugrs az utols RETURN karakter letrolsra, ha a pufferben van mg hely

;
LF10A:	ex	de,hl			; puffercm HL-be
	ld	b,(hl)			; puffer els bjtja B-be (puffer hossza)
	ld	c,000h			; C szmolja a beolvasott karaktereket
	inc	hl
	push	hl			; puffer msodik bjt cmnek mentse
LF110:	push	hl			; aktulis puffercm mentse
	push	bc			; karakterszmllk mentse
	ld	c,0FFh			; CTRL-Z s CTRL-C -t is ellenrizni fogja
	call	LF070			; karakter olvassa a konzolbemeneti fjlbl
	pop	bc			; szmllk vissza
	pop	hl			; puffercm vissza
	or	a
	jr	z,LF110			; ismtls, ha 000h karaktert olvasott
	cp	00Ah
	jr	z,LF110			; ismtls, ha 00Ah (soremels) karaktert olvasott
	cp	00Dh
	jr	z,LF13F			; ugrs, ha RETURN karaktert olvasott
	ld	e,a			; olvasott karakter E-be
	ld	a,b
	cp	c
	jr	z,LF134			; ugrs, ha betelt a puffer
	inc	c			; karakterszmll nvelse
	inc	hl			; puffercm nvelse
	ld	(hl),e			; olvasott karakter trolsa
	ld	a,e			; karakter A reg.-be is
	push	hl			; regiszterek mentse
	push	bc
	call	LF156			; karakter kirsa a konzolra
	jr	LF13B			; ugrs a folytatsra
;
LF134:	push	hl			; regiszterek mentse
	push	bc
	ld	c,007h			; C= BEEP karakter kdja (hangjelzs)
	call	LE20C			; UPM CONOUT funkci hvsa (konzol output)
LF13B:	pop	bc			; regiszterek vissza
	pop	hl
	jr	LF110			; ugrs a kvetkez karakter beolvassra
;
LF13F:	pop	hl			; HL= puffer msodik bjtjnak cme
	ld	(hl),c			; beolvasott karakterszm trolsa
	call	LF156			; utols karakter kirsa a konzolra (RETURN)
LF144:	pop	hl			; HL= puffer kezdcme
	push	hl
	ld	a,(hl)			; A reg.= pufferhossz
	inc	hl
	cp	(hl)			; pufferhossz sszehasonltsa a beolvasott karakterszmmal
	jr	z,LF152			; ugrs, ha betelt a puffer
	ld	e,(hl)			; olvasott karakterszm E-be
	ld	d,000h
	add	hl,de			; HL= pufferben letrolt utols karakter cme
	inc	hl			; HL most az utols karakter utnra mutat
	ld	(hl),00Dh		; RETURN karakter letrolsa
LF152:	pop	de			; DE= puffer cme
	xor	a			; A reg.= 000h
	ld	b,a			; B= 000h
	ret


;
;
;	Karakter kirsa a konzolra
;	in:  A - ASCII karakterkd
;	out:   -
;
LF156:	cp	009h
	jr	nz,LF167		; ugrs, ha nem TAB karakter
LF15A:	ld	a,020h			; TAB kirsa szkzkkel
	call	LF167			; egy SPACE karakter kirsa
	ld	a,(0EC9Ah)		; oszloppozci als bjtja A reg.-be
	and	007h			; 8-cal val oszts maradknak ellenrzse
	jr	nz,LF15A		; ismtls, amg nem tlttte ki a TAB szlessget
	ret
;
LF167:	push	af			; karakterkd mentse
	call	LF1B0			; karakter olvassa a billentyzetrl vrakozs nlkl (CTRL-ESC vizsglata (?))
	pop	af
	ld	hl,(0EC9Ah)		; HL= oszloppozci
	call	LF181			; oszloppozci mdostsa vezrlkarakter esetn
	ld	(0EC9Ah),hl		; mdostott oszloppozci mentse
	ld	e,a			; karakterkd mentse E-be
	ld	a,(0EDDBh)		; konzolkimeneti FCB els bjtjnak vizsglata
	or	a
	ld	a,e			; karakterkd vissza A reg.-be
	jp	nz,LF098		; karakter kirsa, ha a konzolkimenet fjlba van irnytva
	jp	LF225			; egybknt konzol kimenet a kpernyre s a nyomtatra


;
;
;	Oszloppozci mdostsa vezrlkarakter esetn
;	in:   A - karakterkd
;	     HL - oszloppozci
;	out:  A - vltozatlan karakterkd
;	     HL - mdostott oszloppozci
;
LF181:	inc	hl
	cp	07Fh			; karakterkd ellenrzse  !! ez a sor nincs a VT-DOS 1.2-ben
	jr	z,LF189			; ugrs, ha CTRL-DEL       !! ez a sor nincs a VT-DOS 1.2-ben
	cp	020h
	ret	nc			; visszatrs, ha nem kisebb 020h-nl
LF189:	dec	hl			; HL a belpskori rtkt tartalmazza
	ld	b,a			; karakterkd mentse B-be
	ld	a,h			; HL vizsglata
	or	l
	ld	a,b			; karakterkd vissza A reg.-be
	ret	z			; visszatrs, ha HL=0000h volt (sor elejn volt)
	dec	hl			; pozci balra lptetse eggyel
	cp	008h
	ret	z			; visszatrs, ha DEL volt
	cp	07Fh
	ret	z			; visszatrs, ha CTRL-DEL volt
	inc	hl			; a tovbbi karakterek esetn az eredeti pozci visszalltsa
	cp	00Dh
	ret	nz			; visszatrs, ha nem RETURN (kocsi vissza) karakter volt
	ld	hl,0000h		; oszloppozci a sor elejre
	ret


;
;
;	ASCII karakterkd ellenrzse
;	in:   A - karakterkd
;	out:  A - megrzdik
;	     ZF - ZF=1 ha a karakterkd egy vezrlkarakter
;	     CY - CY=1 ha a karakterkd kisebb 020h-nl
;	
LF19E:	cp	00Dh			; RETURN
	ret	z
	cp	00Ah			; LF (soremels)
	ret	z
	cp	009h			; TAB
	ret	z
	cp	008h			; DEL
	ret	z
	cp	07Fh			; BACK SPACE
	ret	z
	cp	020h			; SPACE
	ret


;
;
;	Karakter olvassa a billentyzetrl vrakozs nlkl
;	in: -
;	out:  A - 000h -> nincs rvnyes karakter  0FFh -> van rvnyes karakter
;
LF1B0:	ld	hl,0EC99h		; billentyzetrl olvasott karakterkd ellenrzse
	ld	a,(hl)
	or	a
	jr	nz,LF1C8		; ugrs, ha van vals karakter
	call	LE206			; CONST - konzol llapot beolvassa
	jp	z,LF204			; ugrs a CTRL-ESC ellenrzsre, ha nincs rvnyes bejv karakter
	call	LE209			; CONIN - konzol input
	call	LF1DD			; karakterkd szrse, specilis vezrlkdok vgrehajtsa
	or	a
	ret	z			; visszatrs, ha vgrehajtott vezrlkd volt
	ld	(0EC99h),a		; karakterkd mentse
LF1C8:	call	LF204			; CTRL-ESC ellenrzse (ha volt, akkor mr nem tr vissza)
	dec	a			; A reg.= 0FFh
	ret


;
;
;	Karakter olvassa a billentyzetrl
;	(ha vezrl kdot olvas, azt vgrehajtja, majd vrakozik egy jabb gombnyomsra)
;	in: -
;	out:  A - olvasott karakterkd
;
LF1CD:	ld	hl,0EC99h
	ld	a,(hl)
	ld	(hl),000h
LF1D3:	or	a			; A reg. vizsglata
	ret	nz			; visszatrs, ha A reg. tartalma nem nulla (hasznlhat karakter)
	call	LE209			; UPM CONIN funkci meghvsa
	call	LF1DD			; karakterkd szrse, specilis vezrlkdok vgrehajtsa
	jr	LF1D3			; ismtls, amg nem olvasott be egy hasznlhat karaktert


;
;
;	Karakterkd szrse
;	(kiszrt kdok, amiket rtelmez s vgrehajt: CTRL-ESC, CTRL-P, CTRL-C, CTRL-S)
;	in:  A - karakterkd
;	out: A - megszrt karakterkd (kiszrt karakter esetn 000h)
;
LF1DD:	push	af
	call	LF204			; CTRL-ESC lenyomsnak vizsglata (ha lenyomtk, akkor ide mr nem tr vissza)
	pop	af
	cp	010h			; karakterkd ellenrzse
	jr	z,LF1FA			; ugrs, ha CTRL-P (nyomtat be/ki kapcsolsa)
	cp	003h
	jr	z,LF1F5			; ugrs, ha CTRL-C (folytats)
	cp	013h
	ret	nz			; visszatrs, ha nem CTRL-S (sznet)
	call	LE209			; UPM CONIN funkci meghvsa
	cp	003h
	ld	a,000h			; visszaadott karakterkd: 000h
	ret	nz			; visszatrs, ha nem CTRL-C (folytats)
LF1F5:	ld	a,092h			; hibakd: .CTRLC (CTRL-C -t nyomtak)
	jp	LEF82			; funkci befejezse az "Abort" szubrutinon keresztl
;
LF1FA:	ld	a,(0EC97h)		; flag bjt A reg.-be
	xor	020h			; nyomtat bit invertlsa
	ld	(0EC97h),a
	xor	a			; visszaadott karakterkd: 000h
	ret


;
;
;	CTRL-ESC ellenrzse
;	(csak akkor tr vissza a hv rutinhoz, ha nem nyomtak CTRL-ESC-et)
;	in:  -
;	out: -
;
LF204:	call	LF0D5			; CTRL-ESC megnyomsnak vizsglata
	ret	z			; visszatrs, ha nem volt CTRL-ESC
	jp	LEF82			; program befejezse az "Abort" szubrutin meghvsval


;
;
; ------ nem hvott rutin ??? ------
;
LF20B:	cp	009h
	jr	nz,LF21C
LF20F:	ld	a,020h
	call	LF21C
	ld	a,(0EC9Ah)
	and	007h
	jr	nz,LF20F
	ret
;
LF21C:	ld	hl,(0EC9Ah)
	call	LF181
	ld	(0EC9Ah),hl



;
;
;	Konzol kimenet a kpernyre s a nyomtatra is, ha engedlyezett
;	in:   A - karakterkd
;	out:  -
;
LF225:	ld	c,a			; karakterkd C-be is
	ld	hl,0EC97h		; HL= flag bjt cme
	bit	5,(hl)
	jr	z,LF23C			; ugrs, ha a konzolkimenet nem engedlyezett a nyomtatra
	push	hl			; flagbjt cmnek mentse
	push	bc			; karakterkd mentse
	ld	e,a			; karakterkd E-be
	call	LF0C8			; konzolkimenet a nyomtatra
	pop	bc			; C = karakterkd
	pop	hl			; HL= flag bjt cme
	jr	z,LF23C			; ugrs, ha nem trtnt hiba
	res	5,(hl)			; nyomtatkimenet tiltsa
	jp	LEF82			; befejezs hiba nlkl
;
LF23C:	jp	LE20C			; ugrs az UPM-es CONOUT funkcira


;
;
;	Pufferelt sor-input kzvetlenl a billentyzetrl
;	in:   DE - input puffer cme
;	out:  -
;
LF23F:	inc	de			; puffercm nvelse
	xor	a
	ld	(de),a			; olvasott karakterek szmnak nullzsa
	dec	de			; DE ismt a puffer elejre mutat
	ld	(0ECAAh),a		; vltoz nullzsa
LF246:	push	de			; felhasznli puffercm elmentse
	call	LF316			; sor beolvassa a felhasznli pufferbe
	pop	de			; DE= felhasznli puffercm
	dec	a
	jr	z,LF297			; ugrs, ha kurzor fel volt (elz sor a bels pufferbl)
	dec	a
	jr	z,LF2B5			; ugrs, ha kurzor le (kvetkez sor a bels pufferbl)
	inc	de
	ld	a,(de)			; A reg.= beolvasott karakterek szma
	or	a
	ret	z			; visszatrs, ha egy karaktert sem olvasott
	ld	b,a
	ld	(0ECA7h),a		; olvasott hossz mentse
	ld	a,(0ECAAh)		; A reg.= legutbb a bels sorpufferbl felhasznlt szveg hossza
	or	a
	jr	z,LF275			; ugrs, ha nem volt a pufferbl szveg kimsolva a szerkesztmezbe
	push	de			; felhasznli puffercm mentse
	push	bc			; olvasott karakterszm mentse
	ld	hl,(0ECA3h)		; HL= a legutbb begpelt szveg cme a bels pufferben
LF264:	inc	de
	ld	a,(de)			; karakterek sszehasonltsa a kt pufferben
	cp	(hl)
	jr	nz,LF271		; ugrs, ha nem azonosak
	call	LF2F2			; sorpuffer aktulis cmnek nvelse (cirkulris puffer)
	djnz	LF264			; ismtls az olvasott hosszon
	ld	a,(hl)			; utols karakter vizsglata a bels pufferben
	cp	00Dh			; sorelvlaszt karakter ? (vge a sornak)
LF271:	pop	bc			; B = ismt az olvasott karakterek szma
	pop	de			; DE= felhasznli puffercm
	jr	z,LF289			; ugrs, ha a kt puffer tartalma megegyezett
LF275:	ld	hl,(0ECA5h)		; HL= els szabad hely cme a bels sorpufferben
LF278:	inc	de
	ld	a,(de)			; puffer tartalmnak tmsolsa a sajt bels pufferbe
	ld	(hl),a
	call	LF2F2			; cirkulris sorpuffer aktulis cmnek nvelse
	djnz	LF278
	ld	a,(hl)			; szveg utni korbbi karakter A reg.-be
	ld	(hl),00Dh		; sorelvlaszt karakter elhelyezse
	call	LF2F2			; cirkulris sorpuffer aktulis cmnek nvelse
	ld	(0ECA5h),hl		; els szabad hely cmnek frisstse
LF289:	ld	(0ECA3h),hl		; legutbb begpelt szveg cmnek mentse
LF28C:	cp	00Dh			; a flig fellrt korbbi szveget kitrli teljesen
	ret	z			; visszatrs, ha mr res terletre/ a korbbi szveg vgre rt
	ld	a,(hl)			; korbbi karakter A reg.-be
	ld	(hl),00Dh		; trlsi rtk bersa
	call	LF2F2			; cirkulris sorpuffer aktulis cmnek nvelse
	jr	LF28C			; ismtls, amg a szvegmaradvny tart


;
;
;	Kurzor fel (elz sor a bels pufferbl)
;	in:  DE - a felhasznl input pufferre mutat
;	out: DE - megrzdik
;
LF297:	ld	a,(0ECA7h)		; A reg.= legutbb a sorpufferbe msolt szveg hossza
	or	a
	jr	z,LF246			; ugrs, ha nincs mg egy sor sem a bels pufferben
	ld	hl,(0ECA3h)		; HL= a legutbb begpelt szveg kezdcme
LF2A0:	call	LF304			; a cirkulris sorpuffer aktulis cmnek cskkentse
	ld	a,(hl)			; elz karakter vizsglata
	cp	00Dh
	jr	z,LF2A0			; ugrs, ha res hely karakter
LF2A8:	call	LF304			; a cirkulris sorpuffer aktulis cmnek cskkentse
	ld	a,(hl)			; karakter vizsglata
	cp	00Dh
	jr	nz,LF2A8		; ismtls, amg meg nem tallta az elz szveg elejt
	call	LF2F2			; HL-t a szveg els karakterre lltja
	jr	LF2CF			; ugrs a folytatsra

;
;
;	Kurzor le (kvetkez sor a bels pufferbl)
;	in:  DE - a felhasznl input pufferre mutat
;	out: DE - megrzdik
;
LF2B5:	ld	a,(0ECA7h)		; A reg.= legutbb a sorpufferbe msolt szveg hossza
	or	a
	jr	z,LF246			; ugrs, ha nincs mg egy sor sem a bels pufferben
	ld	hl,(0ECA3h)		; HL= a legutbb begpelt szveg kezdcme
LF2BE:	ld	a,(hl)			; karakter vizsglata
	cp	00Dh
	call	LF2F2			; puffercm nvelse
	jr	nz,LF2BE		; ismtls, amg az utoljra begpelt szveg vgre nem rt
	scf				; CY=1 -> a kvetkez cmnvelst tlpi
LF2C7:	call	nc,LF2F2		; puffercm nvelse (ha CY=0)
	ld	a,(hl)
	cp	00Dh
	jr	z,LF2C7			; ismtls, amg meg nem tallta a kvetkez szveg elejt
LF2CF:	ld	(0ECA3h),hl		; cm mentse, mint a legutoljra begpelt szveg cme
	push	de			; felhasznli puffer cmnek mentse
	ld	a,(de)
	ld	b,a			; B= felhasznli puffer hossza
	inc	de
	inc	de
	ld	c,0FFh			; C= tmsolt karakterek
LF2D9:	ld	a,(hl)			; szveg tmsolsa a bels pufferbl a felhasznli pufferbe
	ld	(de),a
	inc	c
	call	LF2F2			; a cirkulris sorpuffer aktulis cmnek nvelse
	cp	00Dh			; legutbb tmsolt karakter vizsglata
	inc	de			; DE= felhasznli puffer kvetkez cme
	jr	z,LF2E7			; ugrs, ha a msoland szveg vgre rt
	djnz	LF2D9			; szveg msolsa, amg a felhasznli puffer be nem telik
	inc	c			; tmsolt karakterek szmnak nvelse
LF2E7:	pop	de			; DE ismt a felhasznli puffer elejre mutat
	inc	de
	ld	a,c
	ld	(de),a			; pufferben lv karakterek szmnak belltsa
	dec	de			; DE ismt a felhasznli puffer elejre mutat
	ld	(0ECAAh),a		; karakterszm a vltozba is
	jp	LF246			; ugrs a felhasznli puffer szerkesztsre


;
;
;	Cirkulris sorpuffer aktulis cmnek nvelse
;	in:   HL - a bels sorpuffer aktulis cme
;	out:  HL - eggyel megnvelt cm, vagy a cirkulris puffer eleje, ha mr a vgnl tartott
;
LF2F2:	push	af
	push	de
	ld	de,0EDA9h		; DE= utols bjt cme a bels sorpufferben
	or	a
	sbc	hl,de
	add	hl,de
	inc	hl			; sorpuffer aktulis cmnek nvelse
	jr	nz,LF301		; ugrs, ha mg nem rt a vgre
	ld	hl,0ECABh		; HL a bels sorpuffer elejre mutat
LF301:	pop	de
	pop	af
	ret


;
;
;	Cirkulris sorpuffer aktulis cmnek cskkentse
;	in:   HL - a bels sorpuffer aktulis cme
;	out:  HL - eggyel cskkentett cm, vagy a cirkulris puffer vge, ha mr az elejnl tartott
;
LF304:	push	af
	push	de
	ld	de,0ECABh		; DE= els bjt cme a bels sorpufferben
	or	a
	sbc	hl,de
	add	hl,de
	dec	hl			; sorpuffer aktulis cmnek cskkentse
	jr	nz,LF313		; ugrs, ha mg nem rt az elejre
	ld	hl,0EDA9h		; HL a bels sorpuffer vgre mutat
LF313:	pop	de
	pop	af
	ret


;
;
;	Egy sor szerkesztse s beolvassa a pufferbe
;	in:  DE - puffer kezdcme
;	out:  A - vezrls a bels sorpuffer-kezelnek: 0-> RETURN volt  1-> kurzor fel  2-> kurzor le
;
LF316:	ld	hl,(0EC9Ah)		; HL= karakteres oszloppozci a kpernyn
	ld	(0EC9Eh),hl		; a szerkeszt mez kezd oszloppozcija (bal szle)
	ld	(0ECA8h),hl		; aktulis szerkesztsi oszloppozci(?)
	ex	de,hl			; puffer kezdcme HL-be
LF320:	ld	c,(hl)			; C= puffer hossza
	inc	hl
	ld	(0ECA1h),hl		; puffer msodik bjt cmnek mentse
	ld	a,(hl)			; A reg.= pufferben mr benne lv karakterek szma (pl. kurzor fel/le utn belemsolt korbbi szvegek)
	or	a
	ld	b,a			; karakterek szma B-be is
	jr	z,LF330			; ugrs, ha mg res a puffer
	inc	hl
	call	LF4BD			; karakterek kirsa a konzolra a pufferbl
	dec	hl
	ld	a,b
LF330:	ld	(0ECA0h),a		; karakterek szmnak mentse
LF333:	ld	de,LF333
	push	de			; kztes visszatrsi cm a verembe (0F333h)
	push	bc			; B = a pufferben lv karakterek szma  C= puffer hossza
	push	hl
	ld	hl,0ECA0h
	ld	a,(hl)			; A reg.= pufferbe kezdskor (?) bentlv karakterek szma
	cp	b
	jr	nc,LF341		; ugrs, ha mg nem lpte tl 
	ld	(hl),b			; j rtk bersa
LF341:	call	LF1CD			; karakter olvassa a billentyzetrl
	pop	hl
	pop	bc
	or	a
	ret	z			; visszatrs LF333-ra, ha az olvasott karakterkd 000h
	cp	00Dh
	jp	z,LF49C			; ugrs, ha RETURN karaktert olvasott
	cp	00Ah
	ret	z			; visszatrs LF333-ra, ha soremels karaktert olvasott
	cp	01Dh
	jp	z,LF419			; ugrs, ha kurzor balra
	cp	01Ch
	jp	z,LF3FD			; ugrs, ha kurzor jobbra
	cp	008h
	jr	z,LF360			; ugrs, ha DEL
	cp	07Fh
LF360:	jp	z,LF458			; ugrs, ha DEL vagy CTRL-DEL
	cp	0EFh
	jp	z,LF45F			; ugrs, ha SHIFT-DEL
	cp	0ECh
	jp	z,LF3D6			; ugrs, ha INS
	cp	01Bh
	jr	z,LF37B			; ugrs, ha ESC
	cp	015h
	jr	z,LF37B			; ugrs, ha CTRL-U (UPM : trli az ppen bers alatt ll sort)
	cp	018h
	jr	z,LF37B			; ugrs, ha CTRL-X (UPM : trli az ppen bers alatt ll sort)
	cp	019h
LF37B:	jp	z,LF495			; ugrs, ha CTRL-Y (MOPS: trli az ppen bers alatt ll sort)
	cp	01Eh
	jp	z,LF4AF			; ugrs, ha kurzor fel
	cp	01Fh
	jp	z,LF4B6			; ugrs, ha kurzor le
	cp	0E5h
	jp	z,LF408			; ugrs, ha SHIFT-balra
	cp	0E4h
	jp	z,LF40F			; ugrs, ha SHIFT-jobbra
	ld	e,a			; karakterkd E-be
	ld	a,b			; A reg.= pufferbe eddig beolvasott karakterek szma
	cp	c			; sszehasonlts a puffer hosszval
	jr	z,LF3CC			; ugrs, ha betelt a puffer
	inc	hl			; HL a kvetkez karakter trolsi cmre mutat
	ld	a,(0ECA0h)		; A reg.= eddig elrt maximlis szveghossz
	cp	b
	jr	z,LF3C5			; ugrs, ha a szveg vgre kerl a karakter
	ld	a,(hl)			; fellrand karakter A reg.-be
	ld	(hl),e			; j karakter trolsa
	call	LF19E			; A reg.-ben lv ASCII karakterkd ellenrzse
	jr	c,LF3BE			; ugrs, ha a karakterkd kisebb 020h-nl
	jr	nz,LF3AB		; ugrs, ha nem feldolgozhat vezrlkarakter
	cp	020h
	jr	nz,LF3BE		; ugrs, ha nem szkz
LF3AB:	ld	a,e			; j karakterkd A reg.-be
	call	LF19E			; A reg.-ben lv ASCII karakterkd ellenrzse
	jr	c,LF3BE			; ugrs, ha a karakterkd kisebb 020h-nl
	jr	nz,LF3B7		; ugrs, ha nem feldolgozhat vezrlkarakter
	cp	020h
	jr	nz,LF3BE		; ugrs, ha nem szkz
LF3B7:	inc	b			; karakterek szmnak nvelse
	call	LF4FD			; karakter kirsa a konzolra, a nem feldolgozott vezrlkaraktereket '^' eljellel s eltolt rtkkel
	jp	LF515			; visszatrs LF333-ra az aktulis oszloppozci ellenrzse utn
;
LF3BE:	call	LF4CD			; a kijelzett s szerkesztsi pozci kztti helyek kitltse szkzzel
	inc	b			; karakterek szmnak nvelse
	jp	LF41D			; ugrs a konzol kurzorpozcijnak kiigaztsra
;
LF3C5:	cp	c			; sszehasonlts a puffer hosszval
	jr	nc,LF3CC		; ugrs, ha betelt a puffer
	ld	(hl),e			; karakter trolsa
	ld	a,e			; j karakterkd A reg.-be is
	jr	LF3B7
;
LF3CC:	push	bc			; regiszterek mentse
	push	hl
	ld	c,007h			; C= BEEP karakter kdja (hangjelzs)
	call	LE20C			; UPM CONOUT funkci hvsa (konzol output)
	pop	hl			; regiszterek visszalltsa
	pop	bc
	ret				; vissza LF333-ra

;
;
;	Szerkeszt-mveletek vgrehajtsa
;
;

;
;	INS vgrehajtsa
;	in:   B - pufferen belli aktulis pozci (ide szr be egy szkzt)
;	      C - puffer hossza
;	     HL - aktulis pufferpozci memriacme
;	out: -
;
LF3D6:	ld	a,(0ECA0h)		; A reg.= beolvasott karakterek szma
	cp	c
	jr	nc,LF3CC		; ugrs a BEEP kikldsre, ha nincs mr hely a pufferben
	ld	e,020h			; E= szkz kdja
	push	hl			; regiszterek mentse
	push	de
	push	bc
	inc	a			; pufferben lv karakterszm nvelse
	ld	(0ECA0h),a		; rtk visszarsa a vltozba is
	dec	a
	sub	b			; A reg.= az aktulis karakterpozci utn ll karakterek szma
	jr	z,LF3F2			; ugrs, ha a puffer utols karaktern ll
	ld	c,a
	ld	b,000h
	add	hl,bc			; HL a pufferen utols karakterre mutat
	ld	d,h
	ld	e,l
	inc	de			; DE az utols karakter utni cmre mutat
	lddr				; karakter htrbb mozgatsa
LF3F2:	pop	bc			; regiszterek helyrelltsa
	pop	de
	pop	hl
	inc	hl			; HL a beszrt karakter cmre mutat
	ld	(hl),e			; szkz bersa az j pozciba
	call	LF4CD			; szkz beszrsa a konzolon is
	jp	LF41D			; ugrs a konzol kurzorpozcijnak kiigaztsra

;
;	Kurzor jobbra
;	in:   B - pufferen belli aktulis pozci
;	     HL - aktulis pufferpozci memriacme
;	out: -
;
LF3FD:	ld	a,(0ECA0h)		; A reg.= beolvasott karakterek szma
	cp	b
	ret	z			; visszatrs, ha az utols karakternl van a kurzor
	inc	hl			; HL= puffer kvetkez memricme
	inc	b
	ld	a,(hl)
	jp	LF4FD			; karakter kirsa a konzolra, majd visszatrs a hvhoz

;
;	SHIFT-balra (sor elejre ugrik)
;	in:   B - pufferen belli aktulis pozci
;	     HL - aktulis pufferpozci memriacme
;	out: -
;
LF408:	ld	a,b
	or	a
	ret	z			; visszatrs, ha mr a sor elejn van a kurzor
	ld	b,000h			; aktulis pozci = 0
	jr	LF41D			; ugrs a befejezsre

;
;	SHIFT-jobbra (sor vgre ugrik)
;	in:   B - pufferen belli aktulis pozci
;	     HL - aktulis pufferpozci memriacme
;	out: -
;
LF40F:	inc	hl
	call	LF4CD			; kurzort a sor vgre viszi
	ld	a,(0ECA0h)		; A reg.= pufferben lv karakterek szma
	ld	b,a			; B = az utols karakter sorszma
	jr	LF41D			; ugrs a befejezsre

;
;
;	Kurzor balra
;	in:   B - pufferen belli aktulis pozci
;	     HL - aktulis pufferpozci memriacme
;	out:  B - j aktulis pozci
;	     HL - az j pozcinak megfelel memriacm
;
LF419:	ld	a,b
	or	a
	ret	z			; visszatrs, ha mr a sor elejn van a kurzor
	dec	b			; pufferen belli pozci cskkentse

;
;
;	A pufferben az aktulis szerkeszt pozci eltt (balra) lv szveg
;	hossznak kiszmtsa s a konzol kurzorpozci hozzigaztsa (balra lptetse)
;	in:   B - pufferen belli aktulis pozci
;	out:  B - u.a. mint belpskor
;	     HL - a pozcinak megfelel puffercm
;
LF41D:	ld	hl,(0ECA1h)		; HL= a puffer +1 cmre mutat
	ld	de,(0EC9Eh)		; DE= a szerkeszt mez kezd oszloppozcija (bal szle)
	push	bc			; aktulis pufferen belli pozci mentse
	inc	b			; pozci + 1 karaktert fog vgignzni
	jr	LF440
;
LF428:	inc	hl			; HL a kvetkez karakterre mutat
	ld	a,(hl)			; A reg.= karakter a pufferbl
	cp	009h
	jr	nz,LF439		; ugrs, ha nem TAB
	ld	a,e			; A reg.= oszloppozci als bjtja
	add	a,008h			; tabullsi mret hozzadsa (8 karakter)
	jr	nc,LF434		; ugrs, ha nincs tvitel a fels bjtra
	inc	d			; fels bjt nvelse
LF434:	and	0F8h			; oszloppozci kerektse a legkzelebbi TAB pozcira
	ld	e,a			; j pozci DE-be
	jr	LF440			; ugrs a kvetkez karkater feldolgozsra
;
LF439:	call	LF19E			; A reg.-ben lv ASCII karakterkd ellenrzse
	inc	de			; oszloppozci nvelse
	jr	nc,LF440		; ugrs, ha 020h-nl nem kisebb vagy feldolgozhat vezrlkarakter
	inc	de			; oszloppozci tovbbi nvelse (^ + karakter formban rja ki)
LF440:	djnz	LF428			; ismtls a B-ben megadott szm karakterre
	push	hl			; puffer-pozci mentse
	ld	hl,(0EC9Ah)		; HL= karakteres oszloppozci a kpernyn
	or	a
	sbc	hl,de			; oszloppozcik sszehasonltsa
	jr	z,LF455			; ugrs, ha a szmolt s tnyleges oszloppozci megegyezik
LF44B:	ld	a,008h			; DEL karakter kirsa (konzol karakterpozci visszalptetse balra)
	call	LF4FD			; karakter kirsa a konzolra
	dec	hl			; klnbsg cskkentse
	ld	a,h
	or	l
	jr	nz,LF44B		; ismtls az oszloppozcik klnbsgnek megfelel szmban
LF455:	pop	hl
	pop	bc
	ret


;
;
;	DEL vagy CTRL-DEL
;
LF458:	ld	a,b			; aktulis pozci vizsglata
	or	a
	ret	z			; visszatrs, ha a puffer elejn ll
	dec	b			; pozci cskkentse
	call	LF41D			; cskkents a konzolon is (eddig u.a. mint a 'kurzor balra')

;
;
;	SHIFT-DEL
;	in:   B - pufferen belli aktulis pozci
;	     HL - aktulis pufferpozci memriacme
;	out:  B - pufferen belli j pozci
;	     HL - a pozcinak megfelel puffercm
;
LF45F:	ld	a,(0ECA0h)		; A reg.= eddigi maximlis szerkesztsi hossz
	cp	b
	ret	z			; visszatrs, ha a szerkesztett szveg vgn llt
	dec	a
	ld	(0ECA0h),a		; szveghossz cskkentse s trolsa
	sub	b			; A reg.= az aktulis pozci s a szveg vge kztti karakterek szma
	jr	z,LF478			; ugrs, ha a vgn ll
	push	bc			; aktulis pozcik a verembe
	push	hl
	ld	c,a			; BC= a jobbra lv karakterek szma
	ld	b,000h
	inc	hl
	ld	d,h			; DE az els jobbra lv karakterre mutat
	ld	e,l
	inc	hl			; HL a kettvel elbbire
	ldir				; szvegrszlet balra msolsa
	pop	hl
	pop	bc
LF478:	inc	hl			; aktulis pufferpozci nvelse
	call	LF4CD			; jobbra lv szvegrszlet kirsa, konzol igaztsa szkzkkel
	dec	hl			; aktulis pufferpozci cskkentse
	jp	LF41D			; igazts DEL karakterekkel, majd ksz


;
;
;	Input puffer trlse s alaphelyzetbe lltsa
;	in:   B - pufferen belli aktulis pozci
;	out:  B - pufferen belli j pozci (000h)
;	     HL - az input puffer elejre mutat
;
LF480:	xor	a
	cp	b			; aktulis pozci vizsglata
	ld	b,a			; aktulis pozci nullzsa
	call	nz,LF41D		; ha nem a puffer elejn llt, akkor az aktulis oszloppozcit oda lltja, s DEL karakterekkel trli a konzolt
	call	LF4F8			; konzol kurzor jobbra igaztsa
	ld	b,000h
	call	LF41D			; konzol kurzor balra igaztsa
	ld	hl,(0ECA1h)		; felhasznli input puffer cm + 1
	ld	(hl),000h		; pufferben lv karakterek szma = 000h
	dec	hl			; HL a puffer elejre mutat
	ret

;
;
;	Trli az ppen bers alatt ll sort (ESC, CTRL-U, CTRL-X, CTRL-Y)
;
LF495:	call	LF480			; input puffer trlse s alaphelyzetbe lltsa
	pop	de			; kztes cm (LF333) kivtele a verembl
	jp	LF320			; ugrs a puffer szerkeszt rutin elejre


;
;
;	RETURN karakter utn
;	in: -
;	out:  A - 000h
;
LF49C:	inc	hl
	call	LF4CD			; ??? a kijelzett s szerkesztsi pozci kztti helyek kitltse szkzzel
	ld	hl,(0ECA1h)
	ld	a,(0ECA0h)
	ld	(hl),a
	ld	a,00Dh
	call	LF4FD
	pop	hl			; kztes visszatrsi cm kivtele a verembl
	xor	a			; A reg.= 000h
	ret				; vissza a hvhoz


;
;
;	Kurzor fel karakter utn
;	in: -
;	out:  A - 001h
;
LF4AF:	pop	hl			; kztes visszatrsi cm kivtele a verembl
	call	LF480			; input puffer trlse s alaphelyzetbe lltsa
	ld	a,001h
	ret				; vissza a hvhoz


;
;
;	Kurzor le karakter utn
;	in: -
;	out:  A - 002h
;
LF4B6:	pop	hl			; kztes visszatrsi cm kivtele a verembl
	call	LF480			; input puffer trlse s alaphelyzetbe lltsa
	ld	a,002h
	ret				; vissza a hvhoz


;
;
;	Karakterek kirsa a konzolra pufferbl
;	in:   B - kirand karakterszm
;	     HL - puffercm
;	out:  B - megrzdik
;	     HL - az utols kirt karakter puffercme utnra mutat
;
LF4BD:	push	bc			; B mentse
	inc	b			; karakterszmll nvelse, ha esetleg 0 lenne
	jr	LF4C9			; ugrs a ciklus tesztfelttelre
;
LF4C1:	ld	a,(hl)			; A reg.= kirand karakter
	call	LF4FD			; karakter kirsa a konzolra, a vezrlkaraktereket '^' eljellel
	call	LF515			; aktulis oszloppozci sszehasonltsa a kperny pozcival s korrigls, ha kisebb nla
	inc	hl			; puffermutat nvelse
LF4C9:	djnz	LF4C1			; az sszes karakter kirsa a pufferbl
	pop	bc			; B visszalltsa
	ret

;
;
;	Puffer aktulis szerkesztsi pozcijtl jobbra es karakterek kirsa,
;	majd a kijelzett s szerkesztsi pozci kztti helyek kitltse szkzzel (?)
;	in:   -
;	out:  -
;
LF4CD:	push	bc			; regiszterek mentse
	push	de
	push	hl
	ld	a,(0ECA0h)		; A reg.= pufferben lv karakterek szma
	sub	b			; az aktulis karakterpozci kivonsa
	ld	b,a			; B= az aktulis pozci utn ll karakterek szma
	call	LF4BD			; karakterek kirsa a konzolra a pufferbl
LF4D8:	ld	de,(0EC9Ah)		; DE= karakteres oszloppozci a kpernyn
	ld	hl,(0ECA8h)		; HL= aktulis szerkesztsi oszloppozci
	or	a
	sbc	hl,de
	jr	z,LF4F4			; ugrs, ha az aktulis kpernypozci a sor vgvel megegyezik
	jr	c,LF4F4			; ugrs, ha sor vge utn van
LF4E6:	ld	a,020h			; A reg.= szkz kdja
	call	LF4FD			; szkz kirsa a konzolra
	dec	hl
	ld	a,h
	or	l
	jr	nz,LF4E6		; ismtls a megfelel szm szkz beszrsig
	ld	(0ECA8h),de		; aktulis pozci frisstse
LF4F4:	pop	hl			; regiszterek helyrelltsa
	pop	de
	pop	bc
	ret


;
;
;	A kijelzett s szerkesztsi pozci kztti helyek kitltse szkzzel
;	in:   -
;	out:  -
;
LF4F8:	push	bc
	push	de
	push	hl
	jr	LF4D8

;
;
;	Karakter kirsa a konzolra, a nem feldolgozhat vezrlkaraktereket '^' eljellel s eltolt rtkkel
;	(feldolgozhat: RETURN, LF (soremels), TAB, DEL, BACK SPACE (07Fh))
;	in:   A - karakterkd
;	out:  BC,DE,HL - megrzdik
;
LF4FD:	push	bc			; regiszterek mentse
	push	de
	push	hl
	call	LF19E			; ASCII karakterkd ellenrzse
	jr	nc,LF50E		; ugrs, ha nem kisebb 020h-nl vagy feldolgozhat vezrlkarakter
	push	af
	ld	a,05Eh			; A reg.= '^'
	call	LF156			; karakter kirsa a konzolra
	pop	af
	add	a,040h			; A reg.= A reg. + 64
LF50E:	call	LF156			; karakter kirsa a konzolra
	pop	hl			; regiszterek helyrelltsa
	pop	de
	pop	bc
	ret

;
;
;	Aktulis szerkesztsi oszloppozci sszehasonltsa
;	a kperny pozcival s korrigls, ha kell
;	in: -
;	out: A,BC,DE,HL - megrzdik
;
LF515:	push	hl			; regiszterek mentse
	push	bc
	ld	hl,(0ECA8h)		; HL= aktulis szerkesztsi oszloppozci
	ld	bc,(0EC9Ah)		; BC= konzol karakteres oszloppozcija a kpernyn
	or	a			; CY= 0
	sbc	hl,bc
	jr	nc,LF527		; ugrs, ha a aktulis szerkesztsi oszloppozci nem kisebb a kperny pozcinl
	ld	(0ECA8h),bc		; szerkesztsi pozci kiigaztsa
LF527:	pop	bc			; regiszterek helyrelltsa
	pop	hl
	ret


;
;
;	DOS_0Dh - Diszk reset
;	in:   -
;	out:  A - 000h
;	      B - 000h
;
LF52A:	ld	b,000h			; B= 000h -> aktulis meghajt (C= 00Dh !)
	ld	a,00Eh			; funkcikd: pufferek trlse
	call	LF890			; FISH funkci meghvsa
	ld	hl,00080h
	ld	(0E68Ah),hl		; diszk tviteli cm visszalltsa 0080h-ra
	ld	a,0FFh
	ld	(0E68Ch),a
	xor	a			; A reg.= 000h
	ld	b,a			; B = 000h
	ret


;
;
;	DOS_0Eh - Diszk kivlasztsa
;	in:   E - meghajtszm: 0->A:  1->B: stb.
;	out:  A - meghajtk szma
;	      B - 000h
;
LF53F:	ld	a,e			; meghajtszm A reg.-be
	and	00Fh			; csak max. 16 meghajt lehet
	ld	(0004h),a		; meghajtszm trolsa a memria elejn
	inc	a			; meghajtszm nvelse (1->A:  2->B: stb.)
	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
	ld	(iy-05Fh),a		; DEF_UNIT vltoz belltsa a floppy RAM-ban (0D021h)
	call	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra
	ld	a,014h			; funkcikd: login vektor beolvassa
	call	LF890			; FISH funkci meghvsa
	ld	b,020h			; B = 32 bitet vizsgl
	xor	a			; A reg. szmolja majd a meghajtkat
LF557:	add	hl,hl			; DE:HL 4 bjtos login vektor rtk lptetse balra
	rl	e
	rl	d
	adc	a,000h			; a legfels kilp bit hozzadsa A reg.-hez
	djnz	LF557
	ret


;
;
;	DOS_0Fh - Fjl megnyitsa
;	in:  DE - megnyitni kvnt FCB-re mutat
;	out:  A - hiba jelzse: 000h-> nem volt hiba  0FFh-> hiba trtnt
;	      B - 000h
;
LF561:	call	LF7C6			; DE-ben adott DOS tpus FCB konvertlsa FISH tpus FCB-re, s letrolsa a floppy RAM-ban
	ld	hl,PG0ADR(LE2E3)	; "U3 visszalltsa a 3. lapra" rutin cme a verembe
	push	hl
	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
LF56B:	call	PG0ADR(LF82C)		; els illeszked fjl keresse
	ret	nz			; ha hiba volt, akkor U3 visszalltsa a 3. lapra s visszatrs
LF56F:	ld	hl,0DC85h		; HL= keressi FCB (a floppy RAM-ban)
	ld	de,0DCB5h		; DE= meghatrozott FCB (a floppy RAM-ban)
	ld	a,00Ch			; funkcikd: fjl megnyitsa
	call	PG0ADR(LF899)		; FISH funkci meghvsa (ha U3 mr a 0. lapra van lapozva)
	ld	hl,0DCB5h		; HL= megnyitott fjl FCB cme
	ld	de,0DC85h		; DE= ltalnosan hasznlt FCB cme
	ld	a,0FFh			; A reg.= visszatrsi hibakd
	ld	(0268Ch),a		; a rekord pufferben lv blokk aktulis meghajtszmnak rvnytelentse
	ld	b,000h
	ret	nz			; visszatrs, ha hiba trtnt
	ld	c,030h
	ldir				; megnyitott FCB tmsolsa 0DC85h cmre
	call	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra
	call	LF9F8			; megnyitott FISH tpus FCB tkonvertlsa az U3-ban lv DOS tpus FCB-be
	xor	a			; A reg.= 000h
	ld	l,a
	ld	h,a			; HL= 0000h
	ld	(0EE1Ah),hl		; DOS FCB +00Dh (nem hasznlt) s +00Eh (bvtsi szm UPM-hez) bejegyzseinek nullzsa
	call	LF9C9			; vletlen rekordszm belltsa a DOS FCB-ben s fjlmutat belltsa a FISH FCB-ben
	call	LF98A			; "Rekordok szma az UPM-es funkcikhoz" mez belltsa a bels DOS tpus FCB-ben
	call	LF80C			; bels DOS tpus FCB visszamsolsa a felhasznl sajt FCB-jbe
	jp	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra, majd visszatrs
					; (azrt kell, mert a veremben az "U3 visszalltsa a 3. lapra" rutin cme van)


;
;
;	DOS_10h - Fjl lezrsa
;	in:  DE - a megnyitott FCB-re mutat
;	out:  A - hiba jelzse: 000h-> nem volt hiba  0FFh-> hiba trtnt
;	      B - 000h
;
LF5A4:	call	LF7C6			; DE-ben adott DOS tpus FCB konvertlsa FISH tpus FCB-re, s letrolsa a floppy RAM-ban
	ld	de,0DC85h		; DE= FISH FCB cme a floppy RAM-ban
	ld	a,00Dh			; funkcikd: fjl lezrsa
	call	LF890			; FISH funkci meghvsa
	ld	a,0FFh
	ld	b,000h			; B= 000h
	ret	nz			; visszatrs, ha hiba trtnt (A reg.= 0FFh)
	xor	a			; egybknt A reg.= 000h
	ret


;
;
;	DOS_11h - Els keresse
;	in:  DE - megnyitatlan FCB-re mutat
;	out:  A - hiba jelzse: 000h-> tallt fjlt  0FFh-> nem tallt fjlt
;	      B - 000h
;
LF5B6:	call	LF7C6			; DE-ben adott DOS tpus FCB konvertlsa FISH tpus FCB-re, s letrolsa a floppy RAM-ban
	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
	ld	a,(02E19h)		; A reg.= bvtsi szm als bjtja a 0. lapon lv DOS FCB-bl
	ld	(02C93h),a		; rtk tmsolsa (?)
	call	PG0ADR(LF82C)		; els illeszked fjl keresse
	jp	nz,PG0ADR(LE2E3)	; ha hiba volt, akkor U3 visszalltsa a 3. lapra s visszatrs
	jr	LF5DE			; ugrs a folytatsra


;
;
;	DOS_12h - Kvetkez keresse
;	in:  -
;	out:  A - hiba jelzse: 000h-> tallt fjlt  0FFh-> nem tallt fjlt
;	      B - 000h
;
LF5CA:	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
	ld	hl,02E32h		; HL= FCB msolat cme az U3 RAM-ban a 0. lapon
	ld	de,0DC85h		; DE= FCB cme a floppy RAM-ban
	ld	bc,00030h
	ldir				; FCB tmsolsa az U3 RAM-bl a floppy RAM-ba
	call	PG0ADR(LF832)		; kvetkez fjl keresse
	jp	nz,PG0ADR(LE2E3)	; ha hiba volt, akkor U3 visszalltsa a 3. lapra s visszatrs
LF5DE:	ld	hl,0DC85h		; HL= keressi FCB cme a floppy RAM-ban
	ld	de,02E32h		; DE= FCB msolat cme az U3 RAM-ban a 0. lapon
	ld	bc,00030h
	ldir				; keressi FCB tmsolsa a floppy RAM-bl az U3 RAM-ba
	ld	hl,0DCBCh		; HL= meghajt szm cme a tallt FCB-ben
	ld	de,02E0Dh		; DE= DOS tpus FCB kezdcme U3 RAM-ban
	ld	bc,0000Ch
	ldir				; meghajt szm s 8+3 fjlnv tmsolsa
	ld	a,(02C93h)		; A reg.= bvtsi szm als bjtja az tmeneti vltozbl
	ld	(de),a			; bvtsi szm bersa a DOS FCB-be
	inc	de
	inc	hl
	xor	a
	ld	(de),a			; DOS FCB +00Dh mezbe 000h
	inc	de
	inc	hl
	ld	(de),a			; DOS FCB +00Eh mezbe 000h
	inc	de			; DE= a DOS FCB +00Fh mezre mutat
	inc	hl			; HL= tallt FISH FCB +016h mezre mutat
	ld	c,012h			
	ldir				; tovbbi 18 bjt tmsolsa a DOS FCB-be
	dec	de			; DE= a DOS FCB +020h mezre mutat (ide msoldott a tallt knyvtrbejegyzs fjlmret mezje)
	ld	hl,0DC9Fh		; HL= a fjlmret MSB bjtjra mutat a FISH FCB-ben
	ex	de,hl
	ld	c,004h
	lddr				; a 4 bjtos fjlmret visszamsolsa a tallt DOS FCB-bl a FISH FCB fjlmretbe
	call	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra
	xor	a			; A reg.= aktulis rekordszm (000h)
	call	LF9C9			; vletlen rekordszm belltsa a DOS FCB-ben
	call	LF98A			; rekordok szma (+00Fh) mez belltsa a bels DOS tpus FCB-ben
	jr	c,LF5CA			; kvetkez fjl keresse, ha nincs egy rekord sem a fjlban
	ld	hl,0EE0Dh		; HL= tallt DOS tpus FCB msolata
	ld	de,(0E68Ah)		; DE= felhasznli FCB cme
	ld	bc,00021h
	ldir				; tallt FCB tmsolsa a felhasznl adatterletre
	xor	a			; A reg.= 000h
	ld	b,a			; B = 000h
	ret


;
;
;	DOS_13h - Fjl trlse
;	in:  DE - megnyitatlan FCB-re mutat
;	out:  A - hiba jelzse: 000h-> trlt fjlt  0FFh-> nem trlt fjlt
;	      B - 000h
;
LF629:	call	LF7C6			; DE-ben adott DOS tpus FCB konvertlsa FISH tpus FCB-re, s letrolsa a floppy RAM-ban
	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
	ld	a,0FFh
	ld	(0268Ch),a		; flag belltsa
	ex	af,af'			; ments A'-be -> egyben ez lesz a visszaadott hibajelzs alaprtke is
	call	PG0ADR(LF82C)		; els illeszked fjl keresse
	jr	LF640
;
LF63A:	ex	af,af'			; hibajelz rtk ismt A reg.-be
	xor	a			; hibajelzs trlse (egy fjlt mr biztosan trlt)
	ex	af,af'			; jelzs vissza A'-be
LF63D:	call	PG0ADR(LF832)		; kvetkez fjl keresse
LF640:	jr	nz,LF654		; ugrs, ha hiba trtnt
	ld	a,(hl)			; tallt knyvtrbejegyzs attribtumbjtja A reg.-be
	and	000h			; itt mindig nulla lesz az eredmny (bug?)
	jr	nz,LF63D
	ld	de,0DCB5h		; DE= meghatrozott FCB
	ld	hl,0DC85h		; HL= keressi FCB
	ld	a,008h			; funkcikd: trls
	call	PG0ADR(LF899)		; FISH funkci meghvsa (ha U3 mr a 0. lapra van lapozva)
	jr	z,LF63A			; ugrs, ha sikeres volt
LF654:	ex	af,af'			; hibajelz rtk ismt A reg.-be
	ld	b,000h			; B = 000h
	jp	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra, majd visszatrs a hvhoz


;
;
;	DOS_14h - Szekvencilis olvass
;	in:  DE - a megnyitott FCB-re mutat
;	out:  A - hiba jelzse: 000h-> nem volt hiba  001h-> hiba trtnt
;	      B - 000h
;
LF65A:	call	LF7C6			; DE-ben adott DOS tpus FCB konvertlsa FISH tpus FCB-re, s letrolsa a floppy RAM-ban
	call	LF9C6			; vletlen rekordszm belltsa az FCB aktulis rekordja alapjn
	call	LF8B9			; rekord pufferben lv adatok rvnyessgnek ellenrzse
	jr	z,LF66C			; ugrs, ha minden rendben (HL az adatok kezdetre mutat)
	call	LF900			; rekordok beolvassa a lemezrl a bels rekord pufferbe
	ret	nz			; visszatrs, ha hiba trtnt
	ld	hl,0E693h		; HL a rekordpuffer elejre mutat
LF66C:	call	LF822			; egy 128 bjtos rekord tmsolsa a felhasznli diszk tviteli terletre
	call	LF96C			; rekordszm s bvtsi szm nvelse a bels DOS FCB-ben
	call	LF9F8			; megnyitott FISH tpus FCB tkonvertlsa az U3-ban lv DOS tpus FCB-be
	jp	LF80C			; bels DOS tpus FCB visszamsolsa a felhasznl sajt FCB-jbe, majd visszatrs


;
;
;	DOS_15h - Szekvencilis rs
;	in:  DE - a megnyitott FCB-re mutat
;	out:  A - hiba jelzse: 000h-> nem volt hiba  001h-> hiba trtnt
;	      B - 000h
;
LF678:	call	LF7C6			; DE-ben adott DOS tpus FCB konvertlsa FISH tpus FCB-re, s letrolsa a floppy RAM-ban
	call	LF9C6			; vletlen rekordszm belltsa az FCB aktulis rekordja alapjn
	call	LF8E3			; rekord puffer meghajtszmnak rvnytelentse
	ld	a,010h			; funkcikd: rs fjlba
	call	LF876			; egy rekord rsa: FISH funkci vgrejhajtsa a bels FISH FCB-vel, kzvetlenl a felhasznli tviteli cmre
	ld	a,001h			; A reg.= hiba jelzse
	ld	b,000h			; B= 000h
	ret	nz			; visszatrs, ha hiba trtnt
	call	LF96C			; vletlen rekordszm belltsa az FCB aktulis rekordja alapjn
	call	LF9F8			; megnyitott FISH tpus FCB tkonvertlsa az U3-ban lv DOS tpus FCB-be
	ld	a,(0EE2Dh)		; A reg.= aktulis rekord a DOS FCB-bl
	ld	hl,0EE1Ch		; HL= rekordok szma mez cme a DOS FCB-ben
	cp	(hl)			; rtkek sszehasonltsa
	jr	c,LF69B			; ugrs, ha a rekordok szma nagyobb az aktulis rekordnl
	ld	(hl),a			; aktulis rekord bersa a rekordok szma mezbe
LF69B:	jp	LF80C			; bels DOS tpus FCB visszamsolsa a felhasznl sajt FCB-jbe, majd visszatrs


;
;
;	DOS_16h - Fjl ltrehozsa
;	in:  DE - megnyitatlan FCB-re mutat
;	out:  A - hiba jelzse: 000h-> trlt fjlt  0FFh-> nem trlt fjlt
;	      B - 000h
;
LF69E:	call	LF7C6			; DE-ben adott DOS tpus FCB konvertlsa FISH tpus FCB-re, s letrolsa a floppy RAM-ban
	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
	ld	a,(02E19h)		; A reg.= bvtsi szm als bjtja a DOS FCB-bl
	or	a
	jr	z,LF6B1			; ugrs, ha nulla (ltrehozza a fjlt)
	call	PG0ADR(LF56B)		; fjl megnyitsa
	or	a
	jp	z,PG0ADR(LE2E3)		; ha a fjl ltezik: U3 visszalltsa a 3. lapra, majd visszatrs a hvhoz
LF6B1:	ld	hl,PG0ADR(LF84B)	; HL= tvonalnv string (csak egy null-stringre mutat)
	ld	de,0DC85h		; DE= hasznlatlan FCB
	ld	bc,0DCB5h		; BC= hely az FCB szmra
	ld	a,006h			; funkcikd: fjl ltrehozsa
	call	PG0ADR(LF899)		; FISH funkci meghvsa (ha U3 mr a 0. lapra van lapozva)
	ld	a,0FFh			; visszatrsi hibakd A reg.-be
	ld	b,000h			; B= 000h
	call	z,PG0ADR(LF56F)		; ha nem volt hiba, akkor a ltrehozott fjl megnyitsa
	jp	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra, majd visszatrs a hvhoz


;
;
;	DOS_17h - Fjl tnevezse
;	in:  DE - megnyitatlan mdostott FCB-re mutat
;	out:  A - hiba jelzse: 000h-> tnevezett legalbb egy fjlt  0FFh-> nem nevezett t fjlt
;	      B - 000h
;
LF6C9:	call	LF7C6			; DE-ben adott DOS tpus FCB konvertlsa FISH tpus FCB-re, s letrolsa a floppy RAM-ban
	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
	ld	a,0FFh
	ex	af,af'			; visszatrsi hibajelzs alaprtke A'-be
	call	PG0ADR(LF82C)		; els illeszked fjl keresse
	ld	a,(0DC8Ch)		; A reg.= meghajt szm a FISH FCB-bl
	ld	de,0DCECh
	ld	(de),a			; tmsols a harmadik bels FISH FCB meghajtszmba
	inc	de			; DE a harmadik FISH FCB fjlnv mezjre mutat
	ld	hl,02E1Eh		; HL= a mdostott FCB-ben lv j fjlnv kezdete
	ld	bc,0000Bh
	ldir				; 8+3 -as j fjlnv tmsolsa a FISH FCB-be
	jr	LF6ED			; ugrs a folytatsra
;
LF6E7:	ex	af,af'			; visszatrsi hibajelzs A reg.-be
	xor	a			; hibajelzs trlse (egy fjlt mr tnevezett)
	ex	af,af'			; hibajelzs mentse A'-be
	call	PG0ADR(LF832)		; kvetkez fjl keresse
LF6ED:	jr	nz,LF6FF		; ugrs, ha hiba volt
	ld	bc,0DCE5h		; BC= hasznlatlan FCB az j nvvel
	ld	de,0DCB5h		; DE= meghatrozott FCB
	ld	hl,0DC85h		; HL= keressi FCB
	ld	a,009h			; funkcikd: tnevezs
	call	PG0ADR(LF899)		; FISH funkci meghvsa (ha U3 mr a 0. lapra van lapozva)
	jr	z,LF6E7			; ugrs a kvetkez fjl tnevezsre, ha nem trtnt hiba
LF6FF:	ex	af,af'			; hibajelz A reg.-be
	ld	b,000h			; B= 000h
	jp	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra, majd visszatrs a hvhoz


;
;
;	DOS_18h - Login vektor beolvassa
;	in: -
;	out:  A - login vektor L rsze
;	      B - login vektor H rsze
;	     HL - login vektor  als szava (u.a. mint B + A reg.)
;	     DE - login vektor fels szava
;
LF705:	ld	a,014h			; funkcikd: loginvektor beolvassa
	call	LF890			; FISH funkci meghvsa
	ld	a,l			; login vektor als sz als bjtja A reg.-be
	ld	b,h			; als sz fels bjtja B-be
	ret


;
;
;	DOS_19h - Implicit meghajt beolvassa
;	in:  -
;	out:  A - az aktulis implicit meghajt
;	      B - 000h
;
LF70D:	call	LF7BD			; DEF_UNIT vltoz kiolvassa a floppy RAM-bl
	dec	a			; rtk cskkentse (0 -> A:  1-> B: stb.)
	ld	(0004h),a		; meghajtsorszm trolsa a felhasznli adatterleten is
	ld	b,000h			; B= 000h
	ret


;
;
;	DOS_1Ah - Diszk-tviteli cm belltsa
;	in:  DE - a kvnt diszktviteli cm
;	out: -
;
LF717:	ld	(0E68Ah),de		; felhasznli diszktviteli cm vltoz belltsa
	ret


;
;
;	DOS_1Bh - Helyfoglalsi informci beolvassa
;	in:   E - meghajtszm (0= implicit meghajt)
;	out:  A - alapegysgenknti szektorszm vagy 0FFh, ha hiba trtnt
;	     BC - szektormret (mindig 512)
;	     DE - lemezen lv alapegysgek szma
;	     HL - lemezen lv szabad alapegysgek szma
;
LF71C:	pop	hl			; visszatrsi cm kivtele a verembl (LEEF0)
	pop	hl			; DE hvskori rtknek kivtele a verembl
	ld	a,e			; A reg.= meghajtszm
	or	a
	call	z,LF7BD			; ha implicit meghajt, akkor DEF_UNIT vltoz kiolvassa a floppy RAM-bl
	ld	b,a			; B = meghajtszm
	ld	a,015h			; funkcikd: lemez-foglaltsgi informcik beolvassa
	call	LF890			; FISH funkci meghvsa
	ld	a,b			; A reg.= alapegysgenknti szektorszm
	ld	bc,00200h		; BC= 512
	ret	z			; kzvetlen visszatrs a hvhoz, ha nem volt hiba
	ld	a,0FFh			; hiba jelzse
	ret				; kzvetlen visszatrs a hvhoz


;
;
;	DOS_21h - Vletlen elrs olvass
;	in:  DE - a megnyitott FCB-re mutat
;	out:  A - hiba jelzse: 000h-> nem volt hiba  001h-> hiba trtnt
;	      B - 000h
;
LF731:	ld	a,00Fh			; funkcikd: olvass fjlbl
	call	LF84C			; egy 128 bjtos rekord olvassa a DOS tpus FCB-ben adott vletlen rekordszm alapjn
	add	ix,bc			; IX (diszk tviteli cm) nvelse a beolvasott bjtok szmval
	jr	z,LF73E			; ugrs, ha nem trtnt hiba
	sub	0ECh
	jr	nz,LF75E		; ugrs, ha nem fjlvg hiba (.EOF) trtnt
LF73E:	or	c
	jr	z,LF75E			; ugrs, ha egy bjtot sem olvasott
	neg				; A reg.= 0 - olvasott bjtok szma
	and	07Fh			; A reg.= a beolvasott rekord vgn tallhat res bjtok szma
	ld	c,a			; res bjtok szma C-be
	call	nz,LF960		; ha vannak res bjtok, akkor kitlti azokat 01Ah karakterrel (CTRL-Z)
	jr	LF755			; ugrs a befejezsre


;
;
;	DOS_22h - Vletlen elrs rs
;	in:  DE - a megnyitott FCB-re mutat
;	out:  A - hiba jelzse: 000h-> nem volt hiba  001h-> hiba trtnt
;	      B - 000h
;
LF74B:	ld	a,010h			; funkcikd: rs fjlba
;
	.db	021h			; a kvetkez bjtokkal: LD HL,0113Eh (elfedi 'LD A,011h' -t)
;

;
;
;	DOS_28h - Vletlen elrs rekord ltrehozsa / rsa 0-tltssel
;	in:  DE - a megnyitott FCB-re mutat
;	out:  A - hiba jelzse: 000h-> nem volt hiba  001h-> hiba trtnt
;	      B - 000h
;
LF74E:	ld	a,011h			; funkcikd: rs 0-tltssel
	call	LF84C			; egy 128 bjtos rekord rsa a DOS tpus FCB-ben adott vletlen rekordszm alapjn
	jr	nz,LF75E		; ugrs, ha hiba trtnt
LF755:	call	LF98A			; rekordok szma (+00Fh) mez belltsa a bels DOS tpus FCB-ben
	call	LF9F8			; megnyitott FISH tpus FCB tkonvertlsa az U3-ban lv DOS tpus FCB-be
	jp	LF810			; bels FCB visszamsolsa a felhasznl sajt FCB-jbe, 36 bjt hosszon, majd visszatrs
;
LF75E:	xor	a			; hibajelzs belltsa
	ld	b,a			; B= 000h
	inc	a			; A reg.= 001h
	ret


;
;
;	DOS_23h - Fjlmret beolvassa
;	in:  DE - megnyitatlan FCB-re mutat
;	out:  A - hiba jelzse: 000h-> megtallta a fjlt  0FFh-> nem tallja a fjlt
;	      B - 000h
;
LF762:	call	LF7C6			; DE-ben adott DOS tpus FCB konvertlsa FISH tpus FCB-re, s letrolsa a floppy RAM-ban
	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
	call	PG0ADR(LF82C)		; els illeszked fjl keresse
	jp	nz,PG0ADR(LE2E3)	; ha nem tallja, akkor U3 visszalltsa a 3. lapra, majd visszatrs a hvhoz
	ld	bc,(0DCD1h)		; BC= fjlmret  als szava a tallt FISH FCB-ben (bug? +008h -at mg hozz kellene adni ?)
	ld	de,(0DCD3h)		; DE= fjlmret fels szava a tallt FISH FCB-ben (bug? +008h -at mg hozz kellene adni ?)
	xor	a
	ld	h,a
	sub	c			; A reg.= 0 - az utols 128 bjtos rekordban lv bjtok szma
	and	07Fh
	ld	l,a			; HL= res bjtok szma az utols 128 bjtos rekordban
	add	hl,bc
	jr	nc,LF780		; ugrs, ha az utols rekord nem 64KB-os hatr alatt tallhat
	inc	de			; fjlmret fels szavnak nvelse
LF780:	add	hl,hl			; felkerektett als sz balra lptetse eggyel
	ld	a,h			; 128 bjtos rekordszm A reg.-be
	ex	de,hl			; HL-be a fjlmret fels szava
	adc	hl,hl			; fels szt is balra lpteti eggyel
	call	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra
	ld	(0EE2Eh),a		; vletlen rekordszm als 3 bjtjnak belltsa a fjlmret rekordszmra
	ld	(0EE2Fh),hl
	jp	LF810			; bels FCB visszamsolsa a felhasznl sajt FCB-jbe, 36 bjt hosszon, majd visszatrs


;
;
;	DOS_24h - Vletlen rekordszm belltsa
;	in:  DE - az FCB-re mutat
;	out:  A - 000h
;	      B - 000h
;
LF791:	call	LF7C6			; DE-ben adott DOS tpus FCB konvertlsa FISH tpus FCB-re, s letrolsa a floppy RAM-ban
	call	LF9C6			; vletlen rekordszm belltsa az FCB aktulis rekordja alapjn
	jp	LF810			; bels FCB visszamsolsa a felhasznl sajt FCB-jbe, 36 bjt hosszon, majd visszatrs


;
;
;	DOS_2Eh - rs-ellenrzs jelz belltsa / trlse
;	in:   E - 000h -> ellenrzs letiltsa   <>000h -> ellenrzs engedlyezse
;	out:  A - 000h
;	      B - 000h
;
LF79A:	xor	a			; A reg.= 000h
	cp	e
	jr	nz,LF79F		; ugrs, ha engedlyezs van
	dec	a			; A reg.= 0FFh
LF79F:	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
	ld	(iy-05Bh),a		; VERIFY vltoz lltsa a floppy RAM-ban
	call	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra
	ld	(0EE0Ch),a		; sajt bels vltozba is belltja
	xor	a			; A reg.= 000h
	ld	b,a			; B = 000h
	ret


;
;
;	DOS_2Fh - Abszolt szektor olvass
;	in:  DE - szektorszm
;	      L - meghajtszm (0-> A:  1-> B: stb.)
;	      H - olvasand szektorok szma
;	out:  A - hiba jelzse: 000h-> nem volt  0FFh-> hiba trtnt
;	      B - 000h
;	     DE - kvetkez szektorszm
;	      H - beolvasott szektorok szma
;
LF7AE:	ld	a,012h			; funkcikd: abszolt szektor olvass
;
	.db	001h			; a kvetkez bjtokkal: LD BC,0133Eh (elfedi 'LD A,013h'-t)
;

;
;
;	DOS_30h - Abszolt szektor rs
;	in:  DE - szektorszm
;	      L - meghajtszm (0-> A:  1-> B: stb.)
;	      H - rand szektorok szma
;	out:  A - hiba jelzse: 000h-> nem volt  0FFh-> hiba trtnt
;	      B - 000h
;	     DE - kvetkez szektorszm
;	      H - felrt szektorok szma	
;
LF7B1:	ld	a,013h			; funkcikd: abszolt szektor rs
	inc	l			; (bug?) meghajtszm nvelse (1-> A:  2-> B: stb.)
	call	LF87C			; FISH funkci vgrejhajtsa kzvetlenl a felhasznli tviteli cmre
	ld	b,000h			; B = 000h
	ld	a,b			; A reg.= 000h
	ret	z			; visszatrs, ha nem volt hiba
	dec	a			; A reg.= 0FFh
	ret


;
;
;	DEF_UNIT vltoz kiolvassa a floppy RAM-bl
;	in:  -
;	out:  A - DEF_UNIT vltoz rtke
;
LF7BD:	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
	ld	a,(iy-05Fh)		; A reg.= DEF_UNIT vltoz a floppy RAM-bl
	jp	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra, majd visszatrs a hvhoz


;
;
;	Felhasznli DOS tpus FCB lemsolsa, s konvertlsa FISH tpus FCB-re is a floppy RAM-ban
;	in:  DE - felhasznli DOS tpus FCB-re mutat
;	out:  -
;
LF7C6:	ex	de,hl			; FCB cme HL-be
	ld	(0EC95h),hl		; cm mentse
	ld	de,0EE0Dh
	ld	bc,00025h
	ldir				; FCB els 37 bjtjnak tmsolsa az U3 RAM-ba
	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
	xor	a
	ld	de,0DC8Bh		; DE a floppy RAM-ban lv FISH tpus FCB 6. bjtjra mutat
	ld	(de),a			; keressi attribtum trlse a FISH FCB-ben
	dec	a
	ld	(0DC85h),a		; hasznlatlan FCB jelzse a 0. bjton (0FFh)
	inc	de
	ld	hl,02E0Dh		; HL-be a DOS tpus FCB els bjtjnak cme a 0. lapon
	ld	a,(hl)			; meghajtszm vizsglata
	or	a
	jr	nz,LF7E9		; ugrs, ha van meghajt megadva
	ld	a,(iy-05Fh)		; egybknt A reg.-be az aktulis meghajt sorszma
LF7E9:	ld	(de),a			; meghajt sorszmnak trolsa a FISH FCB 7. bjtjn
	inc	hl
	inc	de
	ld	bc,0000Bh		; 11 karakteres fjlnv tmsolsa
	ldir
	ld	hl,02E1Dh		; HL a DOS FCB fjlmret mezjre mutat
	ld	de,0DC9Ch		; DE a FISH FCB fjlmretre mutat
	ld	c,004h
	ldir				; fjlmret tmsolsa
	ld	de,0DCB1h		; DE a FISH FCB ktetazonostjra mutat
	ld	c,004h
	ldir				; ktetazonost tmsolsa
	ld	de,0DCA4h		; FISH bels hasznlat FCB adatok cme
	ld	c,008h
	ldir				; bels hasznlat adatok tmsolsa
	jp	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra, majd visszatrs a hvhoz


;
;
;	Bels DOS tpus FCB visszamsolsa a felhasznl sajt FCB-jbe
;	in: -
;	out:  A - 000h
;	      B - 000h
;
LF80C:	ld	bc,00021h		; BC= FCB hossza 33 bjt
;					; alternatv belpsi pontok ms FCB mret esetre
	.db	021h			; a kvetkez bjtokkal: LD HL,02401h s NOP
;
LF810:	ld	bc,00024h		; BC= FCB hossza 36 bjt
;
	.db	021h			; a kvetkez bjtokkal: LD HL,02501h s NOP
;
LF814:	ld	bc,00025h		; BC= FCB hossza 37 bjt
;
	ld	hl,0EE0Dh		; HL= bels DOS tpus FCB msolat cme
	ld	de,(0EC95h)		; DE= eredeti felhasznli FCB cme
	ldir				; bels FCB visszamsolsa a felhasznl FCB-jbe
	xor	a			; A reg.= 000h
	ret


;
;
;	Egy 128 bjtos rekord tmsolsa a felhasznli diszk tviteli terletre
;	in:  HL - tmsoland adatok kezdete
;	out: -
;
LF822:	ld	de,(0E68Ah)		; DE= felhasznli diszk tviteli cm
	ld	bc,00080h		; 128 bjtot msol
	ldir
	ret


;
;
;	Els illeszked fjl keresse
;	(megj.: csak a 0. lapon fut)
;	in: -
;	out:  A - hiba jelzse: 000h-> nem volt hiba  0FFh-> hiba trtnt
;	     HL - a tallt FCB-ben az attribtumbjtra mutat (a floppy RAM-ban)
;
LF82C:	ld	a,004h			; funkcikd: els keresse
	ld	hl,PG0ADR(LF84B)	; HL= tvonalnv string (csak egy null-stringre mutat)
;
	.db	011h			; a kvetkez bjtokkal: LD DE,0053Eh (elfedi 'LD A,005h'-t)

;
;
;	Kvetkez fjl keresse
;	(megj.: csak a 0. lapon fut)
;	in: -
;	out:  A - hiba jelzse: 000h-> nem volt hiba  0FFh-> hiba trtnt
;	     HL - a tallt FCB-ben az attribtumbjtra mutat (a floppy RAM-ban)
;
LF832:	ld	a,005h			; funkcikd: kvetkez keresse
	ld	de,0DC85h		; DE= hasznlatlan (vagy keressi) FCB (a floppy RAM-ban van!)
	ld	bc,0DCB5h		; BC= hely az FCB szmra (szintn a floppy RAM-ban)
	call	PG0ADR(LF899)		; FISH funkci meghvsa (ha U3 mr a 0. lapra van lapozva)
	ld	a,0FFh
	ld	b,000h
	ret	nz			; visszatrs, ha brmilyen hiba trtnt
	ld	hl,0DCC8h		; tallt knyvtrbejegyzs attribtum-bjtjnak vizsglata
	ld	a,(hl)
	and	009h
	jr	nz,LF832		; ismtls, ha ktetnv vagy csak olvashat fjl (bug?)
	ret
;

LF84B	.db	000h			; nulla hosszsg string az tvonalnvhez


;
;
;	FISH funkci vgrehajtsa a DOS tpus FCB-ben adott vletlen rekordszm alapjn
;	in:   A - FISH funkcikd
;	     DE - a megnyitott DOS tpus FCB-re mutat
;	out:  A - hibakd
;	     IX - vltozatlan marad
;
LF84C:	ex	af,af'			; FISH funkcikd mentse A'-be
	call	LF7C6			; DE-ben adott DOS tpus FCB konvertlsa FISH tpus FCB-re, s letrolsa a floppy RAM-ban
	ld	a,(0EE2Eh)		; A reg.= vletlen rekordszm als bjtja a DOS FCB-bl
	ld	bc,(0EE2Fh)		; BC= vletlen rekordszm kt kzps bjtja a DOS FCB-bl
	call	LF9E0			; fjlmutat belltsa a FISH FCB-ben a vletlen rekordszm alapjn
	call	LF8E3			; rekord puffer meghajtszmnak rvnytelentse
	ld	a,(0EE2Eh)		; vletlen rekordszm HL:A regiszterekbe a DOS FCB-bl
	ld	hl,(0EE2Fh)
	ld	b,a			; als bjt B-be is
	add	a,a
	adc	hl,hl			; vletlen rekordszm balralptetse eggyel
	ld	a,l
	ld	(0EE19h),a		; a rekordszm 127-nl nagyobb rsznek bersa a FCB bvtsi szmnak als bjtjba
	ld	a,h
	ld	(0EE1Bh),a		; s a bvtsi szm fels bjtjba
	ld	a,b
	and	07Fh			; eredeti vletlen rekordszm als 7 bitjnek megtartsa (0..127)
	ld	(0EE2Dh),a		; aktulis rekord a kiterjesztsben nev mez belltsa az FCB-ben
	ex	af,af'			; FISH funkcikd visszalltsa A reg.-be s a funkci vgrehajtsa


;
;
;	FISH funkci vgrejhajtsa a bels FISH FCB-vel, kzvetlenl a felhasznli tviteli cmre
;	(megj.: egy darab 128 bjtos rekordot r vagy olvas)
;	in:   A - funkcikd
;	out:  A - hibakd
;	     IX - vltozatlan marad
;
LF876:	ld	bc,00080h		; BC= tviteli hossz
LF879:	ld	de,0DC85h		; DE= FISH tpus FCB
LF87C:	ld	ix,(0E68Ah)		; IX= felhasznli diszk tviteli cm
	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
	push	ix
	call	LDF01			; FISH funkci vgrehajtsa U0,U1,U2,EXT/IOMEM lapozssal
	call	nz,PG0ADR(LF8AC)	; hiba vizsglata, ha volt hiba
	pop	ix
	jp	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra, majd visszatrs a hvhoz


;
;
;	FISH funkci meghvsa
;	in:   A - funkcikd
;	out:  A - hibakd
;	     IX - vltozatlan marad
;
LF890:	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
	call	PG0ADR(LF899)		; a kvetkez rutin meghvsa, mr a 0. lapon
	jp	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra, majd visszatrs a hvhoz
;
LF899:	ld	(02688h),sp		; veremmutat mentse
	ld	sp,0DDDDh		; verem belltsa a floppy RAM-ba
	push	ix
	call	LC02E			; FISH funkci vgrehajtsra
	pop	ix
	ld	sp,(02688h)		; veremmutat helyrelltsa
	ret	z			; visszatrs, ha nem volt hiba
LF8AC:	cp	0ADh			; hibakd ellenrzse
	jr	z,LF8B3			; ugrs, ha .ABORT hiba volt
	cp	0F5h
	ret	nz			; visszatrs, ha nem .STOP (CTRL-ESC) hiba volt
LF8B3:	call	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra
	jp	LEF82			; szubrutin befejezse az "Abort" rutinon keresztl


;
;
;	Rekord pufferben lv adatok rvnyessgnek ellenrzse olvasshoz
;	in:  -
;	out:  HL - adatok kezdcme a rekord pufferben
;	      ZF - ZF=0 -> a rekordpufferben lv adatok nem rvnyesek
;
LF8B9:	call	LF8ED			; meghajtszm ellenrzse (???)
	ret	nz			; visszatrs, ha nem egyezik
	ld	a,(0E68Fh)
	ld	b,a			; a rekord pufferben lv blokk kezdetnek rekordszma DE:B regiszterekbe
	ld	de,(0E690h)
	ld	a,(0EE2Eh)		; A reg.= DOS FCB-bl a vletlen rekordszm als bjtja
	ld	hl,(0EE2Fh)		; HL= DOS FCB-bl a vletlen rekordszm kzps kt bjtja
	sub	b			; rekordszmok sszehasonltsa
	sbc	hl,de
	ret	nz			; visszatrs, ha 255-nl nagyobb a rekordszmok kztti eltrs
	ld	b,a			; B= rekordszmok als bjtjnak klnbsge
	ld	a,(0E692h)		; A reg.= a rekord pufferben lv rekordok szma
	sub	001h			; A reg. - 1
	ret	c			; visszatrs, ha eredetileg A reg. = 000h volt
	cp	b
	ret	c			; visszatrs, ha a rekordszmok kztti klnbsg nagyobb a pufferben lv rekordok szmnl
	xor	a
	srl	b			; BC= rekordszmok kztti eltrs * 128 bjt
	rra
	ld	c,a
	ld	hl,0E693h		; HL= rekord puffer kezdcme
	add	hl,bc			; offszet hozzadsa a puffer kezdcmhez
	xor	a			; CY= 0
	ret


;
;
;	Rekord pufferben lv adatok rvnyessgnek ellenrzse rshoz
;	in:  -
;	out:  ZF - ZF=0 -> a rekordpufferben lv adatok nem rvnyesek
;	
LF8E3:	call	LF8ED			; meghajtszm ellenrzse (???)
	ret	nz			; visszatrs, ha nem egyezik
	ld	a,0FFh
	ld	(0E68Ch),a		; rekord pufferben lv blokk meghajtszmnak rvnytelentse
	ret


;
;
;	Rekord pufferben lv blokkhoz tartoz meghajtszm ellenrzse (???)
;	in: -
;	out: ZF - ZF=1 -> rendben
;
LF8ED:	ld	a,(0EE0Dh)		; A reg.= meghajtszm a DOS tpus FCB-bl
	ld	b,a			; meghajtszm B-be
	ld	a,(0E68Ch)		; A reg.= rekordpufferben lv blokk meghajtszma
	cp	b			; meghajtszm ellenrzse
	ret	nz			; visszatrs, ha nem egyezik
	ld	hl,(0EE27h)		; HL= DOS FCB +01Ah s +01Bh mezje (nem dokumentlt)
	ld	de,(0E68Dh)		; DE= a rekord pufferben trolt adatokhoz tartoz mez rtkek
	sbc	hl,de			; rtkek sszehasonltsa
	ret


;
;
;	Rekordok beolvassa a lemezrl a bels rekord pufferbe
;	in: -
;	out:  A - hibajelzs: 000h - nem volt hiba  001h - hiba trtnt
;
LF900:	ld	a,0FFh
	ld	(0E68Ch),a		; rekord pufferben lv blokk meghajtszmnak rvnytelentse
	ld	a,(0EE2Eh)		; A reg.= vletlen rekordszm als bjtja
	and	003h			; als 2 bit megtartsa (4 * 128= 512 bjtos egy szektor)
	ld	b,a
	ld	a,00Ch			; 12 rekord fr el a bels pufferben
	sub	b
	ld	b,a			; B= 12 - rekordszm als 2 bitje
	xor	a			; (csak annyi rekordot olvas be, hogy 512 bjtos szektorhatrnl fejezze be)
	srl	b			; BC= olvasand bjtok szma (szmolt rekordszm * 128 bjt)
	rr	a
	ld	c,a
	ld	de,0DC85h		; DE= megnyitott FISH tpus FCB
	ld	ix,02693h		; IX= tviteli cm (rekord puffer eleje az U3 RAM-ban a 0. lapon)
	ld	a,00Fh			; funkcikd: olvass fjlbl
	call	LF890			; FISH funkci meghvsa
	jr	z,LF927			; ugrs, ha nem volt hiba
	cp	0ECh			; fjl vge (.EOF) hiba?
	jr	nz,LF95C		; ugrs, ha nem
LF927:	ld	a,b			; beolvasott bjtok szmnak ellenrzse
	or	c
	jr	z,LF95C			; ugrs, ha nem olvasott egy bjtot sem
	ld	hl,0007Fh
	add	hl,bc			; HL= olvasott bjtszm + 127 (felkerekts 128 bjtos egysgekre)
	add	hl,hl			; HL= felkerektett bjtszm balralptetse eggyel
	ld	a,h			; 128 bjtos rekordok szma A reg.-be
	ld	(0E692h),a		; a pufferbe beolvasott 128 bjtos rekordok szmnak letrolsa
	set	7,b			; BC= olvasott bjtszm + 0C000h
	set	6,b
	add	ix,bc			; IX= utols olvasott bjt utni cm a 3. lapon
	xor	a
	ld	b,a			; B= 000h
	sub	c			; A reg.= 0 - olvasott bjtszm als bjtja
	and	07Fh			; csak az als 7 bit meghagysa
	ld	c,a			; BC= az utols rekordban lv nem hasznlt bjtok szma
	call	nz,LF960		; ha vannak res bjtok, akkor azokat kitlti 01Ah karakterrel
	ld	hl,0EE2Eh		; HL= vletlen rekordszm a DOS FCB-ben
	ld	de,0E68Fh		; DE= a pufferben lv blokk kezdetnek rekordszma
	ld	bc,00003h
	ldir				; 3 bjt tmsolsa az FCB-bl
	ld	hl,(0EE27h)		; HL= a DOS FCB +01Ah s 01Bh nem dokumentlt mezje
	ld	(0E68Dh),hl		; rtk tmsolsa
	ld	a,(0EE0Dh)		; A reg.= meghajtszm
	ld	(0E68Ch),a		; meghajtszm tmsolsa
	xor	a
	ret
;
LF95C:	xor	a			; hibajelzsek belltsa
	ld	b,a			; B= 000h
	inc	a			; A reg.= 001h
	ret


;
;
;	Az utols nem teljes rekord res helyeinek kitltse
;	in:  BC - res bjtok szma a rekord vgn
;	     IX - a rekord els nem hasznlt bjtjra mutat
;	out: -
;
LF960:	push	ix
	pop	hl			; rekord nem hasznlt terletnek kezdete HL-be
LF963:	ld	(hl),01Ah		; fjl vge karakter elhelyezse (CTRL-Z)
	inc	hl			; bjtcm nvelse
	dec	bc			; bjtszmll cskkentse
	ld	a,b
	or	c
	jr	nz,LF963		; ismtls a rekord vgig
	ret


;
;
;	Rekordszm s bvtsi szm nvelse a bels DOS FCB-ben
;	in:  -
;	out: -
;
LF96C:	ld	a,(0EE19h)
	ld	l,a			; L= bvtsi szm als bjtja a DOS tpus FCB-bl
	ld	a,(0EE1Bh)
	ld	h,a			; H= bvtsi szm fels bjtja a DOS tpus FCB-bl
	ld	a,(0EE2Dh)		; A reg.= aktulis rekord a kiterjesztsben
	inc	a			; rekordsorszm nvelse
	jp	p,LF97E			; ugrs, ha A reg. kisebb maradt 128-nl
	inc	hl			; bvtsi szm nvelse
	ld	a,000h			; rekordszm nullzsa
LF97E:	ld	(0EE2Dh),a		; j rtkek visszarsa az FCB-be
	ld	a,l
	ld	(0EE19h),a
	ld	a,h
	ld	(0EE1Bh),a
	ret	p			; visszatrs, ha nem nvekedett a bvtsi szm
					; egybknt folytats a "rekordok szma" mez belltsval

;
;
;	"Rekordok szma az UPM-es funkciknl" mez belltsa a bels DOS tpus FCB-ben
;	(a fjl mutat utn a fjl vgig htralv bjtok szma osztva 128-al, de max. 128)
;	in: -
;	out: CY - CY=1 -> nincs egy rekord sem a fjlban
;
LF98A:	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
	ld	hl,(0DC9Ch)		; HL= fjlmret als szava a FISH FCB-bl (a floppy RAM-ban)
	xor	a
	ld	b,a
	sub	l
	and	07Fh
	ld	c,a			; BC= szabad bjtok szma az utols 128 bjtos blokkban
	add	hl,bc			; szabad bjtok hozzadsa az aktulis fjlmret als szavhoz
	ld	bc,(0DC9Eh)		; BC= fjlmret fels szava
	jr	nc,LF99E		; ugrs, ha fjl utols blokkja nem kzvetlenl egy 64kB-os hatr alatt helyezkedik el
	inc	bc			; egybknt BC= fjlmret fels szava + 1
LF99E:	ld	a,(0DCAEh)		; A reg.= fjlmutat msodik bjtja
	and	0C0h
	ld	d,a			; DE= fjlmutat als szava lefel kerektve 16kB-os egysgekre
	xor	a
	ld	e,a
	sbc	hl,de			; HL= fjlmret als sz - 16 kB-ra kerektett fjlmutat als szava
	push	bc			; fjlmret fels szava a verembe
	ex	(sp),hl			; HL= fjlmret fels szava, HL korbbi rtke a verembe
	ld	bc,(0DCAFh)		; BC= fjlmutat fels szava
	sbc	hl,bc			; 128 bjtra felkerektett fjlmret fels szava - fjlmutat fels szava
	pop	hl			; HL= az als szavak klnbsge (a fjl utols 16kB-os blokkjban lv bjtok szma 128 bjtra felkerektve)
	ld	b,a			; B = 000h
	jr	c,LF9BF			; ugrs, ha a fjlmutat tlmutat a fjl vgn (-> rekordszm = 000h)
	ld	b,080h
	jr	nz,LF9BF		; ugrs, ha a fjlmutat nem a fjl utols 64kB-jn bell van (-> rekordszm = 080h)
	ld	a,h
	and	0C0h
	jr	nz,LF9BF		; ugrs, ha a fjlmutat nem a fjl utols 16kB-jn bell van (-> rekordszm = 080h)
	add	hl,hl
	ld	b,h			; B= fjlmutat utni bjtok szma / 128
LF9BF:	ld	a,b
	ld	(0EE1Ch),a		; (bug? a 3. lapon a floppy RAM van) DOS FCB-ben a +00Fh bjt belltsa: rekordok szma az UPM-es funkcikhoz
	jp	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra, majd visszatrs a hvhoz


;
;
;	Vletlen rekordszm belltsa az FCB aktulis rekordja alapjn
;	in: -
;	out: -
;
LF9C6:	ld	a,(0EE2Dh)		; DOS tpus FCB-msolat aktulis rekordszma A reg.-be


;
;
;	Vletlen rekordszm belltsa a DOS FCB-ben,
;	s ennek megfelelen a fjlmutat belltsa a FISH FCB-ben
;	in:  A - aktulis rekordszm (0..127)
;	out: -
;
LF9C9:	push	af			; rekordszm als bjtja a verembe
	ld	a,(0EE1Bh)
	ld	b,a			; B= bvtsi szm fels bjtja a DOS FCB-bl
	ld	a,(0EE19h)
	ld	c,a			; C= bvtsi szm als bjtja a DOS FCB-bl
	pop	af
	add	a,a			; a balra lptetse eggyel (mert ksbb jobbra lpteti majd)
	srl	b			; BC osztsa 2-vel
	rr	c
	rra				; BC-bl kilp bit belptetse A reg. 7. bitjre
	ld	(0EE2Eh),a		; vletlen rekordszm trolsa a DOS FCB-ben (128 bjt/rekord)
	ld	(0EE2Fh),bc
LF9E0:	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
	ld	hl,0DCADh		; HL= fjlmutat cme a FISH FCB-ben (a floppy RAM-ban)
	ld	(hl),000h
	srl	b			; BC:A -ban trolt rekordszm jobbra lptetse (szorzs 128 bjttal)
	rr	c
	rra
	rr	(hl)			; a kilp bit belptetse a fjlmutat 0. bjtjnak 7. bitjre
	inc	hl
	ld	(hl),a			; fjlmutat 1. bjtja
	inc	hl
	ld	(hl),c			; fjlmutat 2. bjtja
	inc	hl
	ld	(hl),b			; fjlmutat 3. bjtja (MSB)
	jp	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra, majd visszatrs a hvhoz


;
;
;	Megnyitott FISH tpus FCB tkonvertlsa az U3-ban lv DOS tpus FCB-be
;	in:  -
;	out: -
;
LF9F8:	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
	ld	hl,0DC8Dh		; HL= fjlnv cme a FISH tpus FCB-ben (floppy RAM-ban)
	ld	de,02E0Eh		; DE= fjlnv cme a DOS tpus FCB-ben (U3 RAM-ban)
	ld	bc,0000Bh		; BC= 11 karaktert msol
	ldir				; fjlnv tmsolsa
	ld	hl,0DC9Ch		; HL= fjlmret cme a FISH FCB-ben
	inc	de
	inc	de
	inc	de
	inc	de			; DE= fjlmret cme a DOS FCB-ben
	ld	c,004h
	ldir				; 4 bjt tmsolsa
	ld	hl,0DCB1h		; HL= ktetazonost cme a FISH FCB-ben
	ld	c,004h
	ldir				; 4 bjt tmsolsa
	ld	hl,0DCA4h		; HL= bels FISH paramterek cme az FCB-ben
	ld	c,008h
	ldir				; 8 bjt tmsolsa
	jp	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra, majd visszatrs a hvhoz


;
;
;	DOS_27h - Blokk olvass
;	in:  DE - a megnyitott FCB-re mutat
;	     HL - felrand szektorok szma
;	out:  A - hibajelzs: 000h - nem volt hiba  001h - hiba trtnt
;
LFA22:	ld	a,00Fh			; FISH funkcikd: olvass fjlbl
;
	.db	001h			; a kvetkez bjtokkal: LD BC,0103Eh (elfedi 'LD A,010h'-t)


;
;
;	DOS_26h - Blokk rs
;	in:  DE - a megnyitott FCB-re mutat
;	     HL - felrand szektorok szma
;	out:  A - hibajelzs: 000h - nem volt hiba  001h - hiba trtnt
;
LFA25:	ld	a,010h			; FISH funkcikd: rs fjlba
	ex	af,af'			; funkcikd mentse A'-be
	push	hl			; szektorszm a verembe
	call	LF7C6			; DE-ben adott DOS tpus FCB konvertlsa FISH tpus FCB-re, s letrolsa a floppy RAM-ban
	call	LF8E3			; rekord puffer meghajtszmnak rvnytelentse
	ld	bc,(0EE1Bh)		; BC= rekordmret a DOS FCB-bl (+00Eh s +00Fh mezk)
	ld	hl,0003Fh
	xor	a
	sbc	hl,bc			; rekordmret vizsglata
	ld	de,(0EE30h)		; DE= vletlen rekordszm fels szava
	jr	nc,LFA41		; ugrs, ha a rekordmret kisebb 64-nl
	ld	d,a			; vletlen rekordszm legfels bjtjnak nullzsa
	dec	a			; A reg.= 0FFh
LFA41:	ld	(0EC94h),a		; flag belltsa: 000h-> rekordmret kisebb 64-nl   0FFh-> rekordmret >= 64 bjt
	call	LFAEB			; vletlen rekordszm fels szavnak szorzsa a rekordmrettel
	ld	a,h
	or	l
	jr	nz,LFA6F		; ugrs, ha az eredmny nem frt el 16 biten
	push	de			; eredmny als szava a verembe
	ld	de,(0EE2Eh)		; DE= vletlen rekordszm als szava
	call	LFAEB			; vletlen rekordszm als szavnak szorzsa a rekordmrettel
	pop	bc			; fels sz szorzata BC-be
	add	hl,bc			; als sz tlcsordulsnak hozzadsa a fels sz eredmnyhez
	jr	c,LFACD			; ugrs, ha az eredmny nem fr el 16 biten
	call	LE2BF			; floppy csatol memrijnak belapozsa a 3. lapra, U3 thelyezse a 0. lapra
	ld	(0DCADh),de		; kiszmolt rtkek bersa a FISH FCB fjlmutatjba
	ld	(0DCAFh),hl
	call	PG0ADR(LE2E3)		; U3 visszalltsa a 3. lapra
	pop	de			; DE= szektorszm a verembl
	push	de			; szektorszm vissza a verembe
	ld	bc,(0EE1Bh)		; BC= rekordmret a DOS FCB-bl (+00Eh s +00Fh mezk)
	call	LFAEB			; szektorszm szorzsa a rekordmrettel
	ld	a,h
	or	l
LFA6F:	jr	nz,LFACD		; ugrs, ha az eredmny nem frt el 16 biten
	ld	c,e			; BC= tviteli hossz bjtokban
	ld	b,d
	push	bc			; tviteli hossz a verembe is
	ex	af,af'			; funkcikd visszalltsa A reg.-be
	push	af			; kd mentse a verembe is
	call	LF879			; FISH funkci vgrejhajtsa a bels FISH FCB-vel, kzvetlenl a felhasznli tviteli cmre
	jr	z,LFA82			; ugrs, ha nem trtnt hiba
	sub	0ECh
	jr	z,LFA82			; ugrs, ha fjl vge hiba (.EOF) volt
	ld	bc,00000h		; tvitt bjtok szmnak nullzsa
LFA82:	add	ix,bc			; tviteli memriacm nvelse az tvitt bjtok szmval
	pop	af			; A reg.= funkcikd a verembl
	ex	af,af'			; funkcikd mentse A'-be
	xor	a			; visszatrsi hibakd alaprtke: 000h  s CY= 0
	pop	hl			; HL= krt tviteli hossz
	sbc	hl,bc			; tnylegesen tvitt bjtok szmnak kivonsa
	jr	z,LFAA9			; ugrs, ha annyi bjtot vitt t, amennyit krtek
	pop	de			; DE= szektorszm a verembl
	ld	de,(0EE1Bh)		; DE= rekordmret a DOS FCB-bl (+00Eh s +00Fh mezk)
	call	LFAD5			; tvitt bjtok szmnak osztsa a rekordmrettel
	ld	a,h			; oszts maradknak vizsglata
	or	l
	push	bc			; tvitt rekordszm egszrsze a verembe
	jr	z,LFAA7			; ugrs, ha a rekordmret egsz szm tbbszrst vitte t
	pop	bc			; BC= rekordszm egsz rsze
	inc	bc			; kerekts felfel
	push	bc			; felkerektett rekordszm a verembe
	ex	de,hl			; oszt HL-be, maradk DE-be
	sbc	hl,de
	ld	b,h			; BC= a rekord vgn tallhat res bjtok szma
	ld	c,l
	ex	af,af'			; funkcikd vissza A reg.-be
	cp	00Fh
	call	z,LF960			; ha olvass volt, akkor az res bjtokat kitlti 01Ah karakterrel (CTRL-Z)
LFAA7:	ld	a,001h			; visszatrsi hibakd: 001h
LFAA9:	ex	af,af'			; hibakd mentse A'-be
	call	LF9F8			; megnyitott FISH tpus FCB tkonvertlsa az U3-ban lv DOS tpus FCB-be
	pop	de			; DE= tvitt rekordszm
	ld	hl,(0EE2Eh)		; HL= vletlen rekordszm als szava a DOS FCB-bl
	add	hl,de			; rekordszm nvelse az tvvitt rekordszmmal
	ld	(0EE2Eh),hl		; j rtk visszarsa
	jr	nc,LFABE		; ugrs, ha nincs tvitel a fels szra
	ld	hl,(0EE30h)		; HL= vletlen rekordszm fels szava
	inc	hl			; fels sz nvelse
	ld	(0EE30h),hl		; j rtk visszarsa
LFABE:	push	de			; tvitt rekordszm a verembe
	ld	a,(0EC94h)		; A reg.= rekordmret flag
	or	a
	call	z,LF814			; ha rekordmret kisebb 64-nl, akkor 37 bjt hosszon,
	call	nz,LF810		; egybknt 36 bjt hosszon a bels FCB visszamsolsa a felhasznl sajt FCB-jbe 
	pop	hl			; HL= tvitt rekordszm
	ex	af,af'			; elmentett visszatrsi hibakd A reg.-be
	jr	LFAD2			; ugrs a befejezsre
;
LFACD:	pop	hl			; szektorszm kivtele a verembl
	xor	a
	ld	h,a			; HL= 0000h
	ld	l,a
	inc	a			; A reg.= 001h
LFAD2:	pop	de			; visszatrsi cm s DE bemeneti rtknek kivtele a verembl
	pop	de
	ret				; kzvetlen visszatrs a hvhoz


;
;
;	tvitt bjtok szmnak osztsa a rekordmrettel
;	in:  BC - tvitt bjtok (osztand)
;	     DE - rekordmret (oszt)
;	out: BC - eredmny
;	     DE - megrzdik
;	     HL - maradk
;
LFAD5:	xor	a			; A reg.= 000h  CY= 0
	ld	h,a			; HL= munkaregiszter (0000h)
	ld	l,a
	ld	a,010h			; A reg.= 16 bites mvelet lesz
LFADA:	ccf				; CY invertlsa
LFADB:	rl	c			; eredmny bit belptetse
	rl	b			; osztand bit kilptetse CY-be
	dec	a			; ciklusszmll cskkentse
	ret	m			; visszatrs, ha A reg. kisebb lett nullnl
	adc	hl,hl			; osztand kvetkez bitjnek belptetse HL-be
	sbc	hl,de			; oszt kivonsa
	jr	nc,LFADA		; ugrs, ha megvan az osztandban
	add	hl,de			; egybknt a kivons visszalltsa
	or	a			; CY= 0
	jr	LFADB			; folytats a kvetkez bittel


;
;
;	Rekordszmok szorzsa a rekordmrettel
;	in:  BC - rekordmret (szorz)
;	     DE - rekordszm als vagy fels szava (szorzand)
;	out: BC - megrzdik
;	     DE - eredmny als szava
;	     HL - eredmny fels szava
;
LFAEB:	push	bc
	ld	a,b			; szorz fels bjtja A reg.-be
	ld	hl,00000h		; HL-ben lesz az eredmny als szava
	ld	b,010h			; B= 16-bites szorzs lesz
LFAF2:	add	hl,hl			; eredmny balra lptetse
	rl	c			; A reg.-ben s C-ben lv szorz balra lptetse
	rla
	jr	nc,LFAFF		; ugrs, ha 0 a kilp bit
	add	hl,de			; szorzand hozzadsa az eredmnyhez
	jr	nc,LFAFF		; ugrs, ha nincs tlcsorduls
	inc	c			; tlcsordulsok hozzadsa C-hez
	jr	nz,LFAFF		; ugrs, ha C mg nem csordult tl
	inc	a			; tovbbi tvitel hozzadsa A reg.-hez
LFAFF:	djnz	LFAF2			; ismtls mind a 16 bitre
	ex	de,hl			; eredmny als szava DE-be
	ld	l,c			; eredmny fels szava HL-be
	ld	h,a
	pop	bc			; BC helyrelltsa
	ret


;
;
;	Rendszerzenetek tblzata
;	0. bjt - zenet hossza
;	1. bjt - zenet sorszma
;	2. bjt - zenet els karaktere
;	n. bjt - lezr 000h bjt
;
LFB06:
	.db	009h,0BCh,"Not ready",000h
	.db	00Ch,0BAh,"Verify error",000h
	.db	00Ah,0B9h,"Data error",000h
	.db	010h,0B8h,"Sector not found",000h
	.db	014h,0B7h,"Write protected disk",000h
	.db	010h,0B6h,"Unformatted disk",000h
	.db	00Eh,0B5h,"Not a DOS disk",000h
	.db	00Ah,0B4h,"Wrong disk",000h
	.db	013h,0B3h,"Wrong disk for file",000h
	.db	011h,0B1h,"Incompatible disk",000h
	.db	00Bh,0B0h,"Invalid FAT",000h
	.db	006h,001h,"Error ",000h
	.db	003h,002h," --",000h
	.db	007h,003h," drive ",000h
	.db	020h,004h,"Abort, Retry or Ignore "
	.db	"(A/R/I)? ",000h				; elz sor folytatsa
	.db	016h,005h,"Abort or Retry (A/R)? ",000h
	.db	002h,006h,"Aa",000h
	.db	002h,007h,"Rr",000h
	.db	002h,008h,"Ii",000h
	.db	00Fh,009h,"Insert disk for",000h
	.db	01Ch,00Ah,"Press RETURN to continue... ",000h
	.db	017h,0A1h,"Cannot find COMMAND.COM",000h
	.db	013h,093h,"Invalid COMMAND.COM",000h
	.db	010h,0F5h,"CTRL-ESC pressed",000h
	.db	00Eh,092h,"CTRL-C pressed",000h
	.db	016h,0ADh,"Disk operation aborted",000h
	.db	013h,08Ch,"COMMAND.COM too big",000h
	.db	004h,00Bh,"*** ",000h
	.db	021h,00Ch,"Insert COMMAND.COM disk "
	.db	"in drive ",000h				; elz sor folytatsa
	.db	017h,00Dh,"Cannot load COMMAND.COM",000h
	.db	0FFh

;
;
;	Adott sorszm rendszerzenet kezdcmnek meghatrozsa
;	in:   A - zenet sorszma
;	out: BC - megrzdik
;	     DE - nullval lezrt zenet kezdcme
;	     HL - megrzdik
;	     CY - CY=1 -> nem tallhat adott sorszmmal zenet
;
LFD1F:	push	hl
	push	bc
LFD21:	ld	hl,LFB06		; HL= tblzat kezdcme
	ld	bc,00000h		; BC= a kvetkez zenet "tvolsga"
LFD27:	add	hl,bc
	ld	c,(hl)			; 0. bjt: zenet hossza
	inc	c
	scf
	jr	z,LFD33			; ha a tblzatot zr 255-t tall, visszatr CY=1-el
LFD2D:	inc	hl
	cp	(hl)			; 1. bjt: zenet sorszma
	inc	hl
	jr	nz,LFD27		; ugrs a kvetkez zenet vizsglatra, ha a sorszm nem egyezik
	ex	de,hl			; egybknt a tallt zenet els karakternek cme DE-be
LFD33:	pop	bc
	pop	hl
	ret


;
; ---- 199 darab kitlt nulla bjt ----
;

	.org	0FDFDh

;
LFDFD:	jp	LFF01			; ugrs a tnyleges megszaktskiszolgl rutinra
;
LFE00:	.db	0FDh, 0FDh, 0FDh, 0FDh	; 257 darab 0FDh bjt 0FE00h..0FF00h -ig
	.db	0FDh, 0FDh, 0FDh, 0FDh	; (a processzor IM2 mdban van)
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh, 0FDh, 0FDh, 0FDh
	.db	0FDh


;
;
;	Megszaktskiszolgl rutin belpsi pontjai
;

;
;	Belpsi pont, ha a CART volt a 3. lapon (U3 pedig a 0. lapon)
;
LFF01:	push	af			; egyik lehetsges belpsi pont
	push	hl
	ld	hl,PG0ADR(LFF1D)	; HL= befejez rutin cme
	jp	PG0ADR(LFF2F)
;
;
;	Belpsi pont, ha a felhasznli program futott
;
LFF09:	push	af			; msik lehetsges belpsi pont
	push	hl
	ld	a,0B8h			; U3,U1,U2,U3 lapozs
	out	(002h),a
	ld	hl,LFF15		; HL= befejez rutin cme (a 3. lapon)
	jp	PG0ADR(LFF2F)


;
;
; 	Megszaktsok befejez kdrszletei
;
LFF15:	ld	a,0B0h			; U0,U1,U2,U3 lapozs
	out	(002h),a
	ld	a,(0003Bh)		; A reg.= aktulis (felhasznli) memrialapozs
;
	.db	021h			; a kvetkez bjtokkal: "LD HL,0183EH" (elfedi "LD A,018H"-t)
;
LFF1D:	ld	a,018h			; U3,U1,VID,CART lapozs
	out	(002h),a
	pop	hl
	pop	af
	ei
	ret

;
;
;	Befejez rutin, ha a floppy RAM volt eredetileg a 3. lapra belapozva:
;	ugrs a floppy RAM-ba
;
LFF25:	ld	a,0F8h			; U3,U1,U2,EXT/IOMEM lapozs
	out	(002h),a		; memrialapozs belltsa
	jp	LDDEB			; ugrs a floppy RAM-ban lv befejez rutinra


;
;
;	Belpsi pont, ha a floppy RAM volt eredetileg a 3. lapra belapozva
;
LFF2C:	ld	hl,PG0ADR(LFF25)	; HL= befejez rutin cme (visszaugrik majd a floppy RAM-ba)


;
;
;	Megszakts-kiszolgls f rutinja
;	 - meghvja az egyes rszegysgek (floppy s CART-ban lv) IT kiszolgl rutinjt
;	 - mindig a 0. lapon fut
;
;	in:  HL - befejez rutin cme
;	out:    -
;
LFF2F:	ld	(PG0ADR(LFF68) + 1),sp	; rgi veremmutat elmentse a LFF68 cmen tallhat utasts paramterbe
	ld	sp,04000h		; verem elhelyezse az 0. lap vgre (a rutin utn, max. 74 sz fr el)
	push	hl			; regiszterek mentse
	push	ix
	push	iy
	push	bc
	push	de
	exx
	push	bc			; msodlagos regiszterkszlet mentse
	push	de
	push	hl
	ex	af,af'
	push	af
	ld	a,0F8h			; U3,U1,U2,EXT/IOMEM lapozs
	out	(002h),a		; memrialapozs belltsa
	ld	(0DFFFh),a		; memrialapoz rtk a floppy bels vltozjba is (P_SAVE_COPY)
	ld	hl,(0C009h)		; HL= floppy csatol megszaktskiszolgljnak cme
	call	PG0ADR(LFF6B)		; a LFF6B cmen lv "JP (HL)" utasts meghvsa
	ld	a,018h			; U3,U1,VID,CART lapozs
	out	(002h),a		; memrialapozs belltsa
	call	LC53E			; megszakts-kiszolgl CART-ban fut rsznek meghvsa
	ld	a,0B8h			; U3,U1,U2,U3 lapozs
	out	(002h),a		; memrialapozs belltsa
	pop	af			; msodlagos regiszterkszlet visszalltsa
	ex	af,af'
	pop	hl
	pop	de
	pop	bc
	exx
	pop	de			; tovbbi regiszterek visszalltsa
	pop	bc
	pop	iy
	pop	ix
	pop	hl
LFF68:	ld	sp,00000h		; rgi veremmutat helyrelltsa (belpskor ide menti az SP eredeti rtkt)
LFF6B:	jp	(hl)			; ugrs a megadott befejez rutinra
;

U3COPY_END	.equ	$		; eddig msoldik az U3 RAM-ba


	.org	0FFF8h

	.db	000h, 000h, 000h, 000h	; csak azrt, hogy fordtskor teljesen kitltse a 16kB-ot
	.db	000h, 000h, 000h, 000h


.end
